#!/usr/bin/php -q
<?php
$ini = "/etc/default/bp.ini";
$inifd = fopen($ini, "r");
$contents = fread($inifd, filesize($ini));
fclose($inifd);
$contents_array = explode("\n", $contents);

$bploc = "";

for($i=0; $i<count($contents_array); $i++) {
	$line = trim($contents_array[$i]);
	if (strstr($line, "BPDIR") !== FALSE) {
		$line_array = explode('=', $line);
		$bploc = $line_array[1];
	}
}

if (empty($bploc) === TRUE) {
	echo "Could not locate BP install location\n";
	exit(1);
}


$bpReportsDir = $bploc . "/reports.dir/";

require("$bploc/bin/mail_report.php");

bp_bypass_cookie(3, 'alertman_report');

$dpu_id = bp_get_local_system_id();
$dpu = bp_get_system_info($dpu_id);

exec("uname -n", $hostname, $retval);
$hostname = $hostname[0];

$email_addr = bp_get_ini_value('Unattended Backup Information', 'MailTo', $dpu_id);
if ($email_addr === false) {
	echo "Could not determine email address for reports: ".bp_error()."\n";
	bp_destroy_cookie();
	exit(1);
}
if (empty($email_addr)) {
	echo "No email recipients are configured.\n";
	bp_destroy_cookie();
	exit(0);
}

// empty array of images
$images_array = array();
//18478 - Remove gifs from reports
//$red_image = array("filename" => $bploc."/images/red.gif", "cid" => "red.gif@unitrends.com", "type" => "gif");
//$green_image = array("filename" => $bploc."/images/green.gif", "cid" => "green.gif@unitrends.com", "type" => "gif");
//$yellow_image = array("filename" => $bploc."/images/yellow.gif", "cid" => "yellow.gif@unitrends.com", "type" => "gif");
//array_push($images_array, $red_image, $green_image, $yellow_image);


$from = "reports@" . $hostname;
$to = $email_addr;

if (bp_local_system_is_mgr() === TRUE) {
	$subject = $hostname . " Management Status Report " . date("m-d-Y");
	exec($bploc . '/bin/report_vault.php alertman_report_vault', $report, $retval);

	$report = implode("\n", $report);
	
	// Create pdf if needed
	$vaultReportFilenameHTML = $hostname . "-ManagementReport.html";
	$vaultReportFilenamePDF = $hostname . "-ManagementReport.pdf";	
	
	// save report to a file
	$htmlFilePath = $bpReportsDir . $vaultReportFilenameHTML;
	file_put_contents($htmlFilePath, $report);
	
	$pdfFile = createPDF($dpu_id, $htmlFilePath, $vaultReportFilenamePDF);

	mail_report($from, $to, $subject, $report, $images_array, $pdfFile);
	
	clearTempReports($htmlFilePath, $pdfFile);
}

// 4580: some customers want to turn off dpu report if this is a vault only
$allowVaultRept = bp_get_ini_value('Alertman', 'AllowVaultReport', $dpu_id);
if ($allowVaultRept === false) {
	echo "Could get Alertman AllowVaultReport setting: ".bp_error()."\n";
	bp_destroy_cookie();
	exit(1);
}

// Exit here if this is a vault only report
if (bp_local_system_is_mgr() === TRUE) {
	if (strtolower($allowVaultRept{0}) == "f" || strtolower($allowVaultRept{0}) == "n" || $allowVaultRept == "0") {
	   bp_destroy_cookie();
	   exit(1);
	}
}

$subject = $hostname . " System Status Report " . date("m-d-Y");
exec($bploc . '/bin/report_dpu.php alertman_report_dpu', $report, $retval);
$report = implode("\n", $report);

// Create pdf if needed
$dpuReportFilenameHTML = $hostname . "-SystemStatusReport.html";
$dpuReportFilenamePDF = $hostname . "-SystemStatusReport.pdf";

// Save report to a file
$htmlFilePath = $bpReportsDir . $dpuReportFilenameHTML;
file_put_contents($htmlFilePath, $report);

$pdfFile = createPDF($dpu_id, $htmlFilePath, $dpuReportFilenamePDF);

mail_report($from, $to, $subject, $report, $images_array, $pdfFile);

clearTempReports($htmlFilePath, $pdfFile);


// Returns full path to PDF file upon success
// Returns false upon failure or if PDF is not to be created
function createPDF($systemID, $htmlFilePath, $pdfFilename) {
	// load pdf conversion class
	$rootdir = "/var/www/html/recoveryconsole";
	$pdfScript = $rootdir . '/system/pdf_conversion.php';
	// if this method is called more than one time - it will fail without require_once
	require_once $pdfScript;
	$pdfConversion = new PDFConversion();
	
	// create PDF file is necessary
	$result = $pdfConversion->createPDF($systemID, $htmlFilePath, $pdfFilename);
	return $result;
}

// Deletes temp HTML and PDF reports created
function clearTempReports($htmlFilePath, $pdfFile) {
	if (file_exists($htmlFilePath)) {
		unlink($htmlFilePath);
	}
	if ($pdfFile !== false && file_exists($pdfFile)) {
		unlink($pdfFile);
	}
}

bp_destroy_cookie();
?>
