#!/bin/sh -u

# Displays supported archive media types

. /etc/default/bp.ini 2> /dev/null
. ${BPDIR}/bin/uarchive-scripts/constants.incl
. ${BPDIR}/bin/uarchive-scripts/capabilities.incl

if TwArchivingSupported; then
	# Either 3ware or 3ware MDA is supported.  If the MDA is present,
	# all the scripts assume that the MDA will be used.
	MDA=`tw_cli info 2>/dev/null | awk '{if($1 ~ "^c" && $2 ~ "9*-4LP") print $1}'`
	[ -n "$MDA" ] && echo "3ware MDA"
	[ -z "$MDA" ] && echo "3ware"
fi

if RemovableArchivingSupported; then
	if eSATAArchivingSupported; then
		case "$DPUType" in
			"Rec212"*|\
			"Rec312"*)
				echo "eSATA"
				;;
			*)
				echo "eSATA"
				echo "Recovery Archive"
				;;
		esac

	fi
	CheckDPUModelForUSB
        if [ $? -eq 0 ]; then
		echo "USB"
	fi
fi

exit 0

# End marker to help vim identify syntax of .incl files
# vim: syn=sh
