-- This script is only run on a fresh install!
-- To update or add views, add statements to the update_bpdb.sql script.

set search_path to bp,public;

CREATE VIEW privileges AS
SELECT user_id, priv_level, customer_id, location_id, CAST(system_id AS integer) FROM
 (SELECT user_id, priv_level, customer_id, null as location_id, null as system_id FROM customer_priv
  UNION ALL
  SELECT user_id, priv_level, null, location_id, null FROM location_priv
 ) AS cl
UNION ALL
  SELECT user_id, priv_level, null, null, system_id FROM system_priv;


CREATE VIEW ownership AS
SELECT * FROM
  (SELECT system_id, location_id FROM systems) AS s
FULL OUTER JOIN
  (SELECT location_id, customer_id FROM locations) AS l
USING (location_id)
FULL OUTER JOIN
  (SELECT customer_id FROM customers) AS c
USING (customer_id);


CREATE VIEW inherited_privileges AS
SELECT user_id, priv_level, o.customer_id, o.location_id, o.system_id FROM customer_priv AS p INNER JOIN ownership AS o USING (customer_id)
UNION ALL
SELECT user_id, priv_level, null, o.location_id, o.system_id FROM location_priv AS p INNER JOIN ownership AS o USING (location_id)
UNION ALL
SELECT user_id, priv_level, null, null, system_id FROM system_priv WHERE system_id IS NOT NULL;


CREATE VIEW viewables AS
SELECT user_id, priv_level, o.*
  FROM privileges AS p
  INNER JOIN ownership AS o
  ON (o.customer_id = p.customer_id OR o.location_id = p.location_id OR o.system_id = p.system_id)
WHERE (priv_level >= 1);

