<?php
/**
 * Created by PhpStorm.
 * User: Sonja12
 * Date: 4/10/2015
 * Time: 8:30 PM
 */

class Catalogs
{
    private $BP;

    public function __construct($BP = NULL)
    {
        $this->BP = $BP;

    }


    public function get_catalog($type, $filter, $sid, $systems)
    {
      //  print_r("type:  " . $type[0]);
        $allCatalogs = array();

        switch ($type[0]) {
            case 'backups':
                $allCatalogs = $this->getBackupCatalog($filter, $sid, $systems);
                break;
            case 'archives':
                $allCatalogs = $this->getArchiveCatalog($filter, $sid, $systems);
                break;
            default:
                $backupCatalog = $this->getBackupCatalog($filter, $sid, $systems);
                $archiveCatalog = $this->getArchiveCatalog($filter, $sid, $systems);

             //   print_r($backupCatalog);
                if (array_key_exists('catalog', $backupCatalog)) {
                    $a = $backupCatalog['catalog'];
                }

                if (array_key_exists('catalog', $archiveCatalog)) {
                    $b = $archiveCatalog['catalog'];
                }
                $view = isset($_GET['view']) ? $_GET['view'] : "system";

                $combined = array();

                if ($view == "day"){
                    foreach ($a as $backup){
                        $combined[] = $this->mergeDayView($backup, $b);
                    }
                    foreach($b as $archive) {
                        $catalogInstance = $this->findArchiveDayNoBackups($archive, $a);
                        if($catalogInstance !== false && $catalogInstance !== NULL) {
                            $combined[] = $catalogInstance;
                        }
                    }

                    $combined = $this->sortCombined($combined);
                }
                if ($view == "instance") {
                    foreach ($a as $backup){
                        $combined[] = $this->mergeInstanceView($backup, $b);

                    }
                    foreach($b as $archive) {
                        $catalogInstance = $this->findArchiveInstanceNoBackups($archive, $a);
                        if($catalogInstance !== false && $catalogInstance !== NULL) {
                            $combined[] = $catalogInstance;
                        }
                    }
                }
                if ($view == "system") {
                  //  var_dump($view);
                    foreach ($a as $backup){
                        $combined[] = $this->mergeSystemView($backup, $b);


                    }
                    foreach($b as $archive) {
                        $catalogInstance = $this->findArchiveInstanceNoBackups($archive, $a);
                        if($catalogInstance !== false) {
                            $combined[] = $catalogInstance;
                        }
                    }
                }
                $allCatalogs['catalog'] = $combined;
                break;

        }
        return $allCatalogs;
    }

    function getBackupCatalog($filter, $sid, $systems)
    {
        require_once('backups.php');
        $backups = new Backups($this->BP, $sid);
        $backupCatalog = $backups->get("catalog", $filter, $sid, $systems);

        return $backupCatalog;
    }

    function getArchiveCatalog($filter, $sid, $systems)
    {
        $which = array();
        $which[] = "catalog";

        require_once('archive.php');
        $archive = new Archive($this->BP, $sid);
        $archiveCatalog = $archive->get($which, $filter, $sid, $systems);

        return $archiveCatalog;
    }

    function mergeDayView($backup, $archives){
         foreach($archives as $archive){
                if(array_key_exists("day", $archive)){
                    $archiveDay = $archive['day'];
                }
                if($archiveDay == $backup['day']){
                    $backupInstances = $backup['instances'];
                    $archiveInstances = $archive['instances'];
                    for ($i=0; $i < count($backupInstances); $i++){
                        for ($j=0; $j < count($archiveInstances); $j++){
                            if($backupInstances[$i]['instance_name'] == $archiveInstances[$j]['instance_name']){
                                $archives = $archiveInstances[$j]['archives'];
                                $backupsArray = array_merge($backup['instances'][$i]['backups'], $archives);
                                $backups = $this->sortBackups($backupsArray);
                                $backup['instances'][$i]['backups'] = $backups;
                            }
                        }
                    }
                }
            }

        return $backup;
    }


    function findArchiveDayNoBackups($archive, $backups)
    {
        $result = false;
        $hasMatch = false;

        $count = count($backups);
        for ($i = 0; $i < $count && !$hasMatch; $i++) {
            $backup = $backups[$i];
            if ($archive['day'] == $backup['day'] && $archive['instances'][$i]['app_name'] == $backup['instances'][$i]['app_name']) {
                $hasMatch = true;
            }
        }
        if (!$hasMatch) {
                $instances = $archive['instances'];
                $count = count($instances);
                $new = 0;
                for ($i = 0; $i < $count; $i++) {
                    $app = $archive['instances'][$i]['app_name'];
                    if ($app != 'System Metadata') {
                        $archive['instances'][$new] = $archive['instances'][$i];
                        $archive['instances'][$new]['backups'] = $archive['instances'][$i]['archives'];
                        unset($archive['instances'][$new]['archives']);
                        if ($i != $new) {
                            unset($archive['instances'][$i]);
                        }
                        $new++;
                    } else {
                        unset($archive['instances'][$i]);
                    }
                }
                if ($new == 0) {
                    $archive = false;
                }
                $result = $archive;
            }


        return $result;

    }

    function mergeInstanceView($backup, $archives)
    {
       // var_dump("archives:  " . $archives);
        foreach ($archives as $archive) {
            if ($backup['instance_name'] == $archive['instance_name']) {
                $archives = $archive['archives'];
                if ($backup['instance_name'] == "file-level"){
                    if ($backup['client_id'] !== $archive['client_id']){
                        continue;
                    }
                }
                if ($backup['instance_name'] == "Farm"){
                    if ($backup['client_id'] !== $archive['client_id']){
                        continue;
                    }
                }
                $backupsArray = array_merge($backup['backups'], $archives);
                $backups = $this->sortBackups($backupsArray);
                $backup['backups'] = $backups;

            }
        }
        return $backup;
    }

    function findArchiveInstanceNoBackups($archive, $backups) {
      //  var_dump("find archives");
        $hasMatch = false;
        foreach($backups as $backup) {
            if($archive['instance_name'] == $backup['instance_name']){
                $hasMatch = true;
            }
        }

        if($hasMatch == false and $archive['app_name'] !== "System Metadata") {
            $archives = $archive['archives'];
            $archives = $this->sortBackups($archives);
            unset($archive['archives']);
            $archive['backups'] = $archives;
            $result = $archive;
        } else {
            $result = false;
        }
        return $result;
    }

    function mergeSystemView($backup, $archives)
    {
      // var_dump($archives);
        foreach ($archives as $archive) {
           // var_dump("bu instance:  " . $backup['instance_name'] . "archive  instance:  " . $archive['instance_name']);
            if ($backup['instance_name'] == $archive['instance_name']) {

                $archives = $archive['archives'];
                $backupsArray = array_merge($backup['backups'], $archives);
                $backups = $this->sortBackups($backupsArray);
                $backup['backups'] = $backups;

            }
        }
        return $backup;
    }

    function sortBackups($backupArr) {
        $backups = $backupArr;
        $orderByStartDate = array();
        foreach ($backups as $key => $row) {
            $orderByStartDate[$key] = strtotime($row['start_date']);
        }
        array_multisort($orderByStartDate, SORT_DESC, $backups);

        return $backups;
    }

    function sortCombined($combined){
        $orderByDay = array();
        foreach($combined as $key => $row){
            $orderByDay[$key] = $row['day'];
        }
        array_multisort($orderByDay, SORT_DESC, $combined);

        return $combined;
    }
}
