<?php
//IN PROGRESS
class Inventory
{
    private $BP;

    const INVENTORY_GET_TYPE_TREE      = 0;
    const INVENTORY_GET_TYPE_SETTINGS  = 1;
    const INVENTORY_GET_TYPE_STATUS    = 2;

    const INVENTORY_NODE_SEPARATOR = "_";

    const INVENTORY_STATUS_SUCCESS          = 0;
    const INVENTORY_STATUS_WARNINGS         = 1;
    const INVENTORY_STATUS_FAILURE          = 2;

    public function __construct($BP)
    {
        $this->BP = $BP;

        require_once('function.lib.php');
        $this->functions = new Functions($this->BP);
    }

    public function get($which, $data, $sid, $systems)
    {
        $returnArray = array();
        $returnArray['inventory'] = false;

        if ($which == -1)
        {
            // GET /api/inventory/?sid={sid}
            $returnArray['inventory'] = $this->getInventoryTree( $data, $sid );

        }
        else //if (is_string($which[0]))
        {
            switch ($which[0])
            {
                case 'settings':
                    // GET /api/inventory/settings/?sid={sid}
                    $returnArray['inventory'] = $this->getInventorySettings( $sid );
                    break;
                case 'status':
                    // GET /api/inventory/status/?sid={sid}
                    $returnArray['inventory'] = $this->getInventoryStatus( $data, $sid );
                    break;
                case 'sync':
                    // GET /api/inventory/sync/?sid={sid}
                    $returnArray = $this->getInventorySync( $sid );
                    break;
                case 'instance':
                    // GET /api/inventory/instance/?sid={sid}&instances=(a,b,c,d)
                    $returnArray = $this->getInventoryInstance( $sid );
                    break;
                case 'get_disk_info':
                    // GET /api/inventory/get_disk_info/?sid={sid}&?appid={appid}
                    $returnArray = $this->getDiskInfo( $sid );
                    break;
                default:
                    // GET /api/inventory/{id}/...
                    $nodeID = $which[0];
                    if ( count($which) > 1 )
                    {
                        switch ($which[1])
                        {
                            case 'settings':
                                // GET /api/inventory/{id}/settings?sid={sid}
                                $returnArray['inventory'] = $this->getInventorySettings( $sid, $nodeID ,$systems);
                                break;
                            case 'status':
                                // GET /api/inventory/{id}/status/?sid={sid}
                                /*require_once('inventory_status.php');
                                $inventoryStatus = new InventoryStatus($this->BP);
                                $returnArray['inventory'] = $inventoryStatus->get_inventory_status( $systems );*/
                                //$returnArray['inventory'] = $this->getInventoryStatus( $sid, $nodeID, NULL, $data );
                                $returnArray['inventory'] = $this->getInventoryStatus( $data, $sid );
                                break;
                            default:
                                $returnArray['inventory'] = $this->getInventoryNodeDisks( $nodeID );
                                break;
                        }
                    }
                    else
                    {
                        $returnArray['inventory'] = $this->getInventoryNodeDisks( $nodeID );
                    }
                    break;
            }

        }
        if ( $returnArray['inventory'] === false )
        {
            $returnArray = false;
        }
        return($returnArray);
    }

    public function put($which, $data) {
        $status = false;
        $filter = NULL;
        $doInventoryPut = true;
        if ( $which != -1 and is_array($which) )
        {
            switch ( $which[0] )
            {
                case 'VMware':
                case 'Hyper-V':
                    // PUT /api/inventory/{app}/?sid={id}
                    $filter = array( 'applications' => array($which[0]));
                    /* Not needed for first out
                    if (isset($which[1]) and is_numeric($which[1]))
                    {
                        // PUT /api/inventory/{app}/{id}/?sid={id}
                    }*/
                    break;
                default:
                    // (PUT) /api/inventory/{node_id}
                    $doInventoryPut = false;
                    if (isset($which[1]))
                    {
                        switch ( $which[1] )
                        {
                            case 'disks':
                                // (PUT) /api/inventory/{node_id}/disks
                                $status = $this->putInventoryDisks( $which[0], $data );
                                break;
                        }
                    }
                    break;
            }
        }
        if ( $doInventoryPut === true )
        {
            if (isset($data['sid']))
            {
                $sysID = $data['sid'];
                if($this->BP->put_inventory($filter, $sysID))
                {
                    $status = true;
                }
            }
            else
            {
                if($this->BP->put_inventory($filter))
                {
                    $status = true;
                }
            }
        }
        return $status;
    }

    private function getInventoryTree( $data, $sid )
    {
        $showSystemClient = false;
        if ($data !== NULL and array_key_exists('showSystemClient', $data))
        {
            $showSystemClient = ($data['showSystemClient'] === '1');
        }

        $getDisks = false;  //whether or not to get info about VM disks for VMware
        if ($data !== NULL and array_key_exists('disks', $data))
        {
            $getDisks = ((int)$data['disks'] === 1);
        }

        $systems = $this->functions->selectSystems( $sid, false );

        $inventoryArray = array();

        foreach ( $systems as $systemID => $systemName )
        {
            $systemNodeArray = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_TREE,
                Constants::INVENTORY_TYPE_FAMILY_SYSTEM,
                $systemID,
                $systemName,
                Constants::INVENTORY_ID_SYSTEM);

            $clients = $this->BP->get_client_list($systemID);
            if ( $clients !== false )
            {
                foreach ($clients as $clientID => $clientName)
                {
                    if ( $showSystemClient === true or $clientName !== $systemName )
                    {
                        $clientInfo = $this->BP->get_client_info($clientID, $systemID);
                        if ($clientInfo !== false)
                        {
                            if ( $clientInfo['os_type_id'] !== Constants::OS_GENERIC and $clientName !== Constants::CLIENT_NAME_VCENTER_RRC )
                            {
                                $clientNodeArray = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_TREE,
                                    Constants::INVENTORY_TYPE_FAMILY_CLIENT,
                                    $this->buildInventoryNodeID($systemID, $clientID, Constants::APPLICATION_ID_FILE_LEVEL, $clientInfo['file_level_instance_id']),
                                    $clientInfo['name'],
                                    $this->getInventoryIDForAClientFromOSFamily($clientInfo['os_family']));
                            }

                            foreach ($clientInfo['applications'] as $applicationID => $applicationArray)
                            {
                                switch ( $applicationArray['type'] )
                                {
                                    case Constants::APPLICATION_TYPE_NAME_FILE_LEVEL:
                                    case Constants::APPLICATION_TYPE_NAME_ARCHIVE:
                                    case Constants::APPLICATION_TYPE_NAME_SYSTEM_METADATA:
                                    case Constants::APPLICATION_TYPE_NAME_UCS_SERVICE_PROFILE:
                                    case Constants::APPLICATION_TYPE_NAME_VOLUME:
                                    case Constants::APPLICATION_TYPE_NAME_NDMP_DEVICE:
                                        break;  // Don't do anything in this inventory for any of these types

                                    case Constants::APPLICATION_TYPE_NAME_EXCHANGE:
                                        $exchangeNodeArray = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_TREE,
                                            Constants::INVENTORY_TYPE_FAMILY_EXCHANGE,
                                            $this->buildInventoryNodeID($systemID, $clientID, $applicationID),
                                            $clientName . "'s " . $applicationArray['name'],
                                            Constants::INVENTORY_ID_EXCHANGE_APPLICATION);

                                        $exchangeInfo = $this->BP->get_exchange_info($clientID, true, $systemID);
                                        // Sort VMs alphabetically
                                        $exchangeInfo = $this->sort($exchangeInfo);

                                        foreach ($exchangeInfo as $exchangeInstance)
                                        {
                                            $exchangeNodeArray['nodes'][] = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_TREE,
                                                Constants::INVENTORY_TYPE_FAMILY_EXCHANGE,
                                                $this->buildInventoryNodeID($systemID, $clientID, $applicationID, $exchangeInstance['instance_id']),
                                                $exchangeInstance['name'],
                                                Constants::INVENTORY_ID_EXCHANGE_DATABASE);
                                        }
                                        $clientNodeArray['nodes'][] = $exchangeNodeArray;
                                        break;

                                    case Constants::APPLICATION_TYPE_NAME_SQL_SERVER:
                                        $sqlServerNodeArray = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_TREE,
                                            Constants::INVENTORY_TYPE_FAMILY_SQL,
                                            $this->buildInventoryNodeID($systemID, $clientID, $applicationID),
                                            $clientName . "'s " . $applicationArray['name'],
                                            Constants::INVENTORY_ID_SQL_SERVER);

                                        $sqlInfo = $this->BP->get_sql_info($clientID, $applicationID, true, $systemID);
                                        // Sort VMs alphabetically
                                        $sqlInfo = $this->sort($sqlInfo);

                                        $sqlInstanceNodesByInstanceName = array();

                                        foreach ($sqlInfo as $sqlInstance)
                                        {
                                            $offline = $sqlInstance['online'] == false ? " (offline)" : null;
                                            // give the SQL instance a unique ID.
                                            $instance_uuid = substr($sqlInstance['instance'], strpos($sqlInstance['instance'], "\\") + 1);
                                            if ( array_key_exists( $sqlInstance['instance'], $sqlInstanceNodesByInstanceName ) == false )
                                            {
                                                $sqlInstanceNodesByInstanceName[ $sqlInstance['instance'] ] = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_TREE,
                                                    Constants::INVENTORY_TYPE_FAMILY_SQL,
                                                    $this->buildInventoryNodeID($systemID, $clientID, $applicationID, NULL, $instance_uuid),
                                                    $sqlInstance['instance'],
                                                    Constants::INVENTORY_ID_SQL_INSTANCE);
                                            }
                                            $sqlInstanceNodesByInstanceName[ $sqlInstance['instance'] ]['nodes'][] = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_TREE,
                                                Constants::INVENTORY_TYPE_FAMILY_SQL,
                                                $this->buildInventoryNodeID($systemID, $clientID, $applicationID, $sqlInstance['instance_id'], $instance_uuid),
                                                $sqlInstance['database'] . $offline, //Figure out if this should be instance or database
                                                Constants::INVENTORY_ID_SQL_DATABASE);
                                        }
                                        $sqlServerNodeArray['nodes'] = array_values($sqlInstanceNodesByInstanceName);
                                        $clientNodeArray['nodes'][] = $sqlServerNodeArray;
                                        break;

                                    case Constants::APPLICATION_TYPE_NAME_HYPER_V:
                                        $hyperVNodeArray = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_TREE,
                                            Constants::INVENTORY_TYPE_FAMILY_HYPER_V,
                                            $this->buildInventoryNodeID($systemID, $clientID, $applicationID),
                                            $clientName . "'s " . $applicationArray['name'],
                                            Constants::INVENTORY_ID_HYPER_V_SERVER);

                                        $hyperVInfo = $this->BP->get_hyperv_info($clientID, true, $systemID);
                                        // Sort VMs alphabetically
                                        $hyperVInfo = $this->sort($hyperVInfo);

                                        foreach ($hyperVInfo as $hyperVVM)
                                        {
                                            $hyperVNodeArray['nodes'][] = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_TREE,
                                                Constants::INVENTORY_TYPE_FAMILY_HYPER_V,
                                                $this->buildInventoryNodeID($systemID, $clientID, $applicationID, $hyperVVM['instance_id']),
                                                $hyperVVM['name'],
                                                Constants::INVENTORY_ID_HYPER_V_VM);
                                        }
                                        $clientNodeArray['nodes'][] = $hyperVNodeArray;
                                        break;

                                    case Constants::APPLICATION_TYPE_NAME_ORACLE:
                                        $oracleNodeArray = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_TREE,
                                            Constants::INVENTORY_TYPE_FAMILY_ORACLE,
                                            $this->buildInventoryNodeID($systemID, $clientID, $applicationID),
                                            $clientName . "'s " . $applicationArray['name'],
                                            Constants::INVENTORY_ID_ORACLE_APPLICATION);

                                        $oracleInfo = $this->BP->get_oracle_info($clientID, $applicationID, true, $systemID);
                                        // Sort VMs alphabetically
                                        $oracleInfo = $this->sort($oracleInfo);

                                        foreach ($oracleInfo as $oracleInstance)
                                        {
                                            $offline = $oracleInstance['online'] == false ? " (offline)" : null;
                                            $oracleNodeArray['nodes'][] = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_TREE,
                                                Constants::INVENTORY_TYPE_FAMILY_ORACLE,
                                                $this->buildInventoryNodeID($systemID, $clientID, $applicationID, $oracleInstance['instance_id']),
                                                $oracleInstance['name'] . $offline,
                                                Constants::INVENTORY_ID_ORACLE_DATABASE);
                                        }
                                        $clientNodeArray['nodes'][] = $oracleNodeArray;
                                        break;

                                    case Constants::APPLICATION_TYPE_NAME_SHAREPOINT:
                                        $sharePointNodeArray = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_TREE,
                                            Constants::INVENTORY_TYPE_FAMILY_SHAREPOINT,
                                            $this->buildInventoryNodeID($systemID, $clientID, $applicationID),
                                            $clientName . "'s " . $applicationArray['name'],
                                            Constants::INVENTORY_ID_SHAREPOINT_APPLICATION);

                                        $sharepointInfo = $this->BP->get_sharepoint_info($clientID, $applicationID, true, $systemID);
                                        // Sort VMs alphabetically
                                        $sharepointInfo = $this->sort($sharepointInfo);

                                        foreach ($sharepointInfo as $sharepointInstance)
                                        {
                                            $sharePointNodeArray['nodes'][] = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_TREE,
                                                Constants::INVENTORY_TYPE_FAMILY_SHAREPOINT,
                                                $this->buildInventoryNodeID($systemID, $clientID, $applicationID, $sharepointInstance['instance_id']),
                                                $sharepointInstance['name'],
                                                Constants::INVENTORY_ID_SHAREPOINT_FARM);
                                        }
                                        $clientNodeArray['nodes'][] = $sharePointNodeArray;
                                        break;

                                    case Constants::APPLICATION_TYPE_NAME_XEN:
                                        /*$xenNodeArray = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_TREE,
                                            Constants::INVENTORY_TYPE_FAMILY_XEN,
                                            $this->buildInventoryNodeID($systemID, $clientID, $applicationID),
                                            $clientName,
                                            Constants::INVENTORY_ID_XEN_POOL_MASTER);*/

                                        $xenInfo = $this->BP->get_xen_vm_info($clientID, true, $getDisks, $systemID);
                                        // Sort VMs alphabetically
                                        $xenInfo = $this->sort($xenInfo);

                                        $xenServerNodesbyServerUUID = array();

                                        foreach ($xenInfo as $xenVM)
                                        {
                                            if ( array_key_exists( $xenVM['server_uuid'], $xenServerNodesbyServerUUID ) == false )
                                            {
                                                $xenServerNodesbyServerUUID[ $xenVM['server_uuid'] ] = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_TREE,
                                                    Constants::INVENTORY_TYPE_FAMILY_XEN,
                                                    $this->buildInventoryNodeID($systemID, $clientID, $applicationID, NULL, $xenVM['server_uuid']),  //Maybe in the future, give a Xen Host its own Node ID
                                                    $clientName . "'s " . $xenVM['server_name'],
                                                    Constants::INVENTORY_ID_XEN_SERVER_IN_A_POOL);;
                                            }
                                            if ( $xenVM['is_template'] === true )
                                            {
                                                $xenServerNodesbyServerUUID[ $xenVM['server_uuid'] ]['nodes'][] = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_TREE,
                                                    Constants::INVENTORY_TYPE_FAMILY_XEN,
                                                    $this->buildInventoryNodeID($systemID, $clientID, $applicationID, $xenVM['instance_id'], $xenVM['server_uuid']),
                                                    $xenVM['name'],
                                                    Constants::INVENTORY_ID_XEN_CUSTOM_TEMPLATE);
                                            }
                                            else
                                            {
                                                $tempNode = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_TREE,
                                                    Constants::INVENTORY_TYPE_FAMILY_XEN,
                                                    $this->buildInventoryNodeID($systemID, $clientID, $applicationID, $xenVM['instance_id'], $xenVM['server_uuid']),
                                                    $xenVM['name'],
                                                    Constants::INVENTORY_ID_XEN_VM);
                                                if ($getDisks === true and array_key_exists('disks', $xenVM) and count($xenVM['disks']) > 0)
                                                {
                                                    foreach ($xenVM['disks'] as $disk)
                                                    {
                                                        $tempDiskNode = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_TREE,
                                                            Constants::INVENTORY_TYPE_FAMILY_XEN,
                                                            $this->buildInventoryNodeID($systemID, $clientID, $applicationID, $xenVM['instance_id'], $xenVM['server_uuid'], NULL, $disk['user_device']),
                                                            $disk['name'],
                                                            Constants::INVENTORY_ID_XEN_VM_DISK);
                                                        $tempDiskNode['is_excluded'] = $disk['is_excluded'];
                                                        $tempNode['nodes'][] = $tempDiskNode;
                                                    }
                                                }
                                                $xenServerNodesbyServerUUID[ $xenVM['server_uuid'] ]['nodes'][] = $tempNode;
                                            }
                                        }
                                        if ( count($xenServerNodesbyServerUUID) === 1 )
                                        {
                                            foreach ( $xenServerNodesbyServerUUID as $xenServerUUID => $tempXenServerNodeArray )
                                            {
                                                $tempXenServerNodeArray['type'] = Constants::INVENTORY_ID_XEN_STANDALONE_SERVER;  // If there are multiple servers, but one server has no VMs on it, then this logic is wrong.  Since it is just for icons, a little inaccuracy is accetable at this time.
                                                $systemNodeArray['nodes'][] = $tempXenServerNodeArray;
                                            }
                                        }
                                        else
                                        {
                                            foreach ( $xenServerNodesbyServerUUID as $xenServerUUID => $tempXenServerNodeArray )
                                            {
                                                $systemNodeArray['nodes'][] = $tempXenServerNodeArray;
                                            }
                                        }
                                        break;

                                    case Constants::APPLICATION_TYPE_NAME_VMWARE:
                                        foreach ($applicationArray['servers'] as $esxServerUUID => $esxServerName)
                                        {
                                            $esxServer = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_TREE,
                                                Constants::INVENTORY_TYPE_FAMILY_VMWARE,
                                                $this->buildInventoryNodeID($systemID, $clientID, $applicationID, NULL, $esxServerUUID),
                                                $esxServerName,
                                                Constants::INVENTORY_ID_VMWARE_ESX_SERVER);  // This could also be a vCenter, but the UI cannot tell the difference

                                            $vmList = $this->BP->get_vm_info($esxServerUUID, NULL, true, $getDisks, $systemID);
                                            $resourcePools = $this->BP->get_resource_pool_info($esxServerUUID, $systemID);
                                            $vApps = $this->BP->get_vApp_info($esxServerUUID, $systemID);

                                            $resourcePoolAndVAppArray = array();
                                            if (count($resourcePools) > 0)
                                            {
                                                foreach ($resourcePools as $resourcePool)
                                                {
                                                    $resourcePoolAndVAppArray[$resourcePool['key']] = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_TREE,
                                                        Constants::INVENTORY_TYPE_FAMILY_VMWARE,
                                                        $this->buildInventoryNodeID($systemID, $clientID, $applicationID, NULL, $esxServerUUID, $resourcePool['key']),
                                                        $resourcePool['name'],
                                                        Constants::INVENTORY_ID_VMWARE_RESOURCE_POOL);
                                                    $resourcePoolAndVAppArray[$resourcePool['key']]['parentKey'] = $resourcePool['parentKey'];
                                                    $resourcePoolAndVAppArray[$resourcePool['key']]['parentType'] = $resourcePool['parentType'];
                                                    $resourcePoolAndVAppArray[$resourcePool['key']]['resourcePoolOrVApp'] = array();
                                                }
                                            }
                                            if (count($vApps) > 0)
                                            {
                                                foreach ($vApps as $vApp)
                                                {
                                                    $resourcePoolAndVAppArray[$vApp['key']] = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_TREE,
                                                        Constants::INVENTORY_TYPE_FAMILY_VMWARE,
                                                        $this->buildInventoryNodeID($systemID, $clientID, $applicationID, NULL, $esxServerUUID, $vApp['key']),
                                                        $vApp['name'],
                                                        Constants::INVENTORY_ID_VMWARE_V_APP);
                                                    $resourcePoolAndVAppArray[$vApp['key']]['parentKey'] = $vApp['parentKey'];
                                                    $resourcePoolAndVAppArray[$vApp['key']]['parentType'] = $vApp['parentType'];
                                                    $resourcePoolAndVAppArray[$vApp['key']]['resourcePoolOrVApp'] = array();
                                                }
                                            }
                                            // Sorts VMs alphabetically
                                            $vmList = $this->sort($vmList);
                                            if (count($vmList) > 0)
                                            {
                                                foreach ($vmList as $vm)
                                                {
                                                    if ($vm['template'] === true)
                                                    {
                                                        $esxServer['nodes'][] = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_TREE,
                                                            Constants::INVENTORY_TYPE_FAMILY_VMWARE,
                                                            $this->buildInventoryNodeID($systemID, $clientID, $applicationID, $vm['instance_id'], $esxServerUUID),
                                                            $vm['name'],
                                                            Constants::INVENTORY_ID_VMWARE_TEMPLATE);
                                                    }
                                                    else
                                                    {
                                                        $tempNode = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_TREE,
                                                            Constants::INVENTORY_TYPE_FAMILY_VMWARE,
                                                            $this->buildInventoryNodeID($systemID, $clientID, $applicationID, $vm['instance_id'], $esxServerUUID),
                                                            $vm['name'],
                                                            Constants::INVENTORY_ID_VMWARE_VM);
                                                        if ($getDisks === true and array_key_exists('disks', $vm) and count($vm['disks']) > 0)
                                                        {
                                                            foreach ($vm['disks'] as $disk)
                                                            {
                                                                $tempDiskNode = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_TREE,
                                                                    Constants::INVENTORY_TYPE_FAMILY_VMWARE,
                                                                    $this->buildInventoryNodeID($systemID, $clientID, $applicationID, $vm['instance_id'], $esxServerUUID, NULL, $disk['key']),
                                                                    $disk['name'],
                                                                    Constants::INVENTORY_ID_VMWARE_VM_DISK);
                                                                $tempDiskNode['is_excluded'] = $disk['is_excluded'];
                                                                $tempNode['nodes'][] = $tempDiskNode;
                                                            }
                                                        }
                                                        switch ($vm['parentType'])
                                                        {
                                                            case 0: //ESXhost
                                                                $esxServer['nodes'][] = $tempNode;
                                                                break;
                                                            case 1: //resourcePool
                                                            case 2: //vApp
                                                                /*$resourcePoolAndVAppArray[$vm['parentKey']]['VMs'][$vm['instance_id']] = $this->buildInventoryNodeArray( Inventory::INVENTORY_GET_TYPE_TREE,
                                                                    Constants::HV_VMWARE,
                                                                    $this->buildInventoryNodeID( $systemID, $VMwareClient['id'], $applicationID, $vm['instance_id'], $esxServerUUID ),
                                                                    $vm['name'],
                                                                    Constants::NODE_TYPE_VM );*/
                                                                $resourcePoolAndVAppArray[$vm['parentKey']]['nodes'][] = $tempNode;
                                                                break;
                                                            case (-1): //template
                                                                // Nothing should ever come here
                                                                break;
                                                        }
                                                    }
                                                }

                                                $esxServerResourcePoolOrVApp = array();
                                                if (count($resourcePoolAndVAppArray) > 0)
                                                {
                                                    $nestedResourcePoolOrVAppArray = array();
                                                    foreach ($resourcePoolAndVAppArray as $resourcePoolOrVAppKey => $resourcePoolOrVApp)
                                                    {
                                                        if ($resourcePoolOrVApp['parentType'] === 0) //ESX is the Parent
                                                        {
                                                            unset($resourcePoolOrVApp['parentKey']);
                                                            unset($resourcePoolOrVApp['parentType']);
                                                            $esxServerResourcePoolOrVApp[$resourcePoolOrVAppKey] = $resourcePoolOrVApp;
                                                        }
                                                        else
                                                        {
                                                            unset($resourcePoolOrVApp['parentType']);
                                                            $nestedResourcePoolOrVAppArray[$resourcePoolOrVAppKey] = $resourcePoolOrVApp;
                                                        }
                                                    }
                                                    if (count($nestedResourcePoolOrVAppArray) > 0)
                                                    {
                                                        $returnedArray = $this->recursiveResourcePoolAndVAppAssignment($esxServerResourcePoolOrVApp, $nestedResourcePoolOrVAppArray);
                                                        $esxServer['nodes'] = array_values(array_merge($returnedArray['parents'], $esxServer['nodes']));
                                                    }
                                                    elseif (count($esxServerResourcePoolOrVApp) > 0)
                                                    {
                                                        $newNodesArray = array();
                                                        foreach ( $esxServerResourcePoolOrVApp as $esxServerNodeArray )
                                                        {
                                                            unset($esxServerNodeArray['resourcePoolOrVApp']);
                                                            $newNodesArray[] = $esxServerNodeArray;
                                                        }
                                                        $esxServer['nodes'] = array_values(array_merge($newNodesArray, $esxServer['nodes']));
                                                    }
                                                }
                                            }
                                            $systemNodeArray['nodes'][] = $esxServer;
                                        }
                                        break;
                                }
                            }

                            if ( $clientInfo['os_type_id'] !== Constants::OS_GENERIC and $clientName !== Constants::CLIENT_NAME_VCENTER_RRC )
                            {
                                $systemNodeArray['nodes'][] = $clientNodeArray;
                            }
                        }
                    }
                }
            }
            $inventoryArray[] = $systemNodeArray;
        }

        return $inventoryArray;
    }

    private function getInventoryNodeDisks( $nodeID )
    {
        $result = false;

        $nodeArray = $this->getNodeIDArrayFromInventoryNodeID($nodeID);
        if ( array_key_exists('systemID', $nodeArray) )
        {
            if ( array_key_exists('clientID', $nodeArray) )
            {
                if ( array_key_exists('applicationID', $nodeArray) )
                {
                    if ( $nodeArray['applicationID'] == Constants::APPLICATION_ID_VMWARE )
                    {
                        if ( array_key_exists('esxServerUUID', $nodeArray) )
                        {
                            if ( array_key_exists('instanceID', $nodeArray) )
                            {
                                $vmList = $this->BP->get_vm_info($nodeArray['esxServerUUID'], $nodeArray['instanceID'], true, true, $nodeArray['systemID']);
                                if ($vmList !== false)
                                {
                                    foreach ($vmList as $vm)
                                    {
                                        $result = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_TREE,
                                            Constants::INVENTORY_TYPE_FAMILY_VMWARE,
                                            $this->buildInventoryNodeID($nodeArray['systemID'], $nodeArray['clientID'], $nodeArray['applicationID'], $vm['instance_id'], $nodeArray['esxServerUUID']),
                                            $vm['name'],
                                            Constants::INVENTORY_ID_VMWARE_VM);
                                        foreach ($vm['disks'] as $disk)
                                        {
                                            $tempDiskNode = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_TREE,
                                                Constants::INVENTORY_TYPE_FAMILY_VMWARE,
                                                $this->buildInventoryNodeID($nodeArray['systemID'], $nodeArray['clientID'], $nodeArray['applicationID'], $vm['instance_id'], $nodeArray['esxServerUUID'], NULL, $disk['key']),
                                                $disk['name'],
                                                Constants::INVENTORY_ID_VMWARE_VM_DISK);
                                            $tempDiskNode['is_excluded'] = $disk['is_excluded'];
                                            $result['nodes'][] = $tempDiskNode;
                                        }
                                    }
                                }
                            }
                            else
                            {
                                $result = array();
                                $result['error'] = 500;
                                $result['message']= "The inventory id must specify an instance id in order to get the vm disks.";
                                return $result;
                            }
                        }
                        else
                        {
                            $result = array();
                            $result['error'] = 500;
                            $result['message']= "The inventory id must specify a esx server id in order to get the vm disks.";
                            return $result;
                        }
                    }
                    elseif ( $nodeArray['applicationID'] == Constants::APPLICATION_ID_XEN )
                    {
                        if ( array_key_exists('instanceID', $nodeArray) )
                        {
                            $xenVMList = $this->BP->get_xen_vm_info($nodeArray['clientID'], true, true, $nodeArray['systemID']);
                            if ($xenVMList !== false)
                            {
                                foreach ($xenVMList as $xenVM)
                                {
                                    if ($xenVM['instance_id'] != $nodeArray['instanceID']) {
                                        // Skip instances that do not match the node.
                                        continue;
                                    }
                                    $result = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_TREE,
                                        Constants::INVENTORY_TYPE_FAMILY_XEN,
                                        $this->buildInventoryNodeID($nodeArray['systemID'], $nodeArray['clientID'], $nodeArray['applicationID'], $xenVM['instance_id'], $xenVM['server_uuid']),
                                        $xenVM['name'],
                                        Constants::INVENTORY_ID_XEN_VM);
                                    foreach ($xenVM['disks'] as $disk)
                                    {
                                        $tempDiskNode = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_TREE,
                                            Constants::INVENTORY_TYPE_FAMILY_XEN,
                                            $this->buildInventoryNodeID($nodeArray['systemID'], $nodeArray['clientID'], $nodeArray['applicationID'], $xenVM['instance_id'], $xenVM['server_uuid'], NULL, $disk['user_device']),
                                            $disk['name'],
                                            Constants::INVENTORY_ID_XEN_VM_DISK);
                                        $tempDiskNode['is_excluded'] = $disk['is_excluded'];
                                        $result['nodes'][] = $tempDiskNode;
                                    }
                                }
                            }
                        }
                        else
                        {
                            $result = array();
                            $result['error'] = 500;
                            $result['message']= "The inventory id must specify an instance id in order to get the vm disks.";
                            return $result;
                        }
                    }
                }
                else
                {
                    $result = array();
                    $result['error'] = 500;
                    $result['message']= "The inventory id must specify an application id in order to get the vm disks.";
                    return $result;
                }
            }
            else
            {
                $result = array();
                $result['error'] = 500;
                $result['message']= "The inventory id must specify a client id in order to get the vm disks.";
                return $result;
            }
        }
        else
        {
            $result = array();
            $result['error'] = 500;
            $result['message']= "The inventory id must specify a system id in order to get the vm disks.";
            return $result;
        }
        return $result;
    }

    private function getInventoryStatus($data, $sid)
    {
        $showSystemClient = false;
        if ($data !== NULL and array_key_exists('showSystemClient', $data))
        {
            $showSystemClient = ($data['showSystemClient'] === '1');
        }

        $systems = $this->functions->selectSystems( $sid, false );

        $inventoryStatusArray = array();
        // date("w",

        foreach ( $systems as $systemID => $systemName )
        {
            $assetsByInstanceID = array(); //instance_id is the key
            $fileLevelInstanceIDByClientID = array();  //client_id is the key and the file-level instance id is the value

            $clients = $this->BP->get_client_list($systemID);
            if ( $clients !== false )
            {
                foreach ($clients as $clientID => $clientName)
                {
                    if ( $showSystemClient === true or $clientName !== $systemName )
                    {
                        $clientInfo = $this->BP->get_client_info($clientID, $systemID);
                        if ($clientInfo !== false)
                        {
                            if ( $clientInfo['os_type_id'] !== Constants::OS_GENERIC and $clientName !== Constants::CLIENT_NAME_VCENTER_RRC )
                            {
                                $file_level_instance_id = $clientInfo['file_level_instance_id'];
                                $fileLevelInstanceIDByClientID[$clientID] = $file_level_instance_id;

                                $assetsByInstanceID[$file_level_instance_id] = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_STATUS,
                                    Constants::INVENTORY_TYPE_FAMILY_CLIENT,
                                    $this->buildInventoryNodeID($systemID, $clientID, Constants::APPLICATION_ID_FILE_LEVEL, $file_level_instance_id),
                                    $clientInfo['name'],
                                    $this->getInventoryIDForAClientFromOSFamily($clientInfo['os_family']));
                            }

                            foreach ($clientInfo['applications'] as $applicationID => $applicationArray)
                            {
                                switch ( $applicationArray['type'] )
                                {
                                    case Constants::APPLICATION_TYPE_NAME_FILE_LEVEL:
                                    case Constants::APPLICATION_TYPE_NAME_ARCHIVE:
                                    case Constants::APPLICATION_TYPE_NAME_SYSTEM_METADATA:
                                    case Constants::APPLICATION_TYPE_NAME_UCS_SERVICE_PROFILE:
                                    case Constants::APPLICATION_TYPE_NAME_VOLUME:
                                    case Constants::APPLICATION_TYPE_NAME_NDMP_DEVICE:
                                        break;  // Don't do anything in this inventory for any of these types

                                    case Constants::APPLICATION_TYPE_NAME_EXCHANGE:

                                        $exchangeInfo = $this->BP->get_exchange_info($clientID, true, $systemID);
                                        // Sort VMs alphabetically
                                        $exchangeInfo = $this->sort($exchangeInfo);

                                        foreach ($exchangeInfo as $exchangeInstance)
                                        {
                                            $assetsByInstanceID[$exchangeInstance['instance_id']] = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_STATUS,
                                                Constants::INVENTORY_TYPE_FAMILY_EXCHANGE,
                                                $this->buildInventoryNodeID($systemID, $clientID, $applicationID, $exchangeInstance['instance_id']),
                                                $exchangeInstance['name'],
                                                Constants::INVENTORY_ID_EXCHANGE_DATABASE);
                                        }
                                        break;

                                    case Constants::APPLICATION_TYPE_NAME_SQL_SERVER:

                                        $sqlInfo = $this->BP->get_sql_info($clientID, $applicationID, true, $systemID);
                                        // Sort VMs alphabetically
                                        $sqlInfo = $this->sort($sqlInfo);

                                        foreach ($sqlInfo as $sqlInstance)
                                        {
                                            // give the SQL instance a unique ID.
                                            $instance_uuid = substr($sqlInstance['instance'], strpos($sqlInstance['instance'], "\\") + 1);
                                            $assetsByInstanceID[$sqlInstance['instance_id']] = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_STATUS,
                                                Constants::INVENTORY_TYPE_FAMILY_SQL,
                                                $this->buildInventoryNodeID($systemID, $clientID, $applicationID, $sqlInstance['instance_id'], $instance_uuid),
                                                $sqlInstance['database'], //Figure out if this should be instance or database
                                                Constants::INVENTORY_ID_SQL_DATABASE);
                                        }
                                        break;

                                    case Constants::APPLICATION_TYPE_NAME_HYPER_V:

                                        $hyperVInfo = $this->BP->get_hyperv_info($clientID, true, $systemID);
                                        // Sort VMs alphabetically
                                        $hyperVInfo = $this->sort($hyperVInfo);

                                        foreach ($hyperVInfo as $hyperVVM)
                                        {
                                            $assetsByInstanceID[$hyperVVM['instance_id']] = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_STATUS,
                                                Constants::INVENTORY_TYPE_FAMILY_HYPER_V,
                                                $this->buildInventoryNodeID($systemID, $clientID, $applicationID, $hyperVVM['instance_id']),
                                                $hyperVVM['name'],
                                                Constants::INVENTORY_ID_HYPER_V_VM);
                                        }
                                        break;

                                    case Constants::APPLICATION_TYPE_NAME_ORACLE:

                                        $oracleInfo = $this->BP->get_oracle_info($clientID, $applicationID, true, $systemID);
                                        // Sort VMs alphabetically
                                        $oracleInfo = $this->sort($oracleInfo);

                                        foreach ($oracleInfo as $oracleInstance)
                                        {
                                            $assetsByInstanceID[$oracleInstance['instance_id']] = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_STATUS,
                                                Constants::INVENTORY_TYPE_FAMILY_ORACLE,
                                                $this->buildInventoryNodeID($systemID, $clientID, $applicationID, $oracleInstance['instance_id']),
                                                $oracleInstance['name'],
                                                Constants::INVENTORY_ID_ORACLE_DATABASE);
                                        }
                                        break;

                                    case Constants::APPLICATION_TYPE_NAME_SHAREPOINT:

                                        $sharepointInfo = $this->BP->get_sharepoint_info($clientID, $applicationID, true, $systemID);
                                        // Sort VMs alphabetically
                                        $sharepointInfo = $this->sort($sharepointInfo);

                                        foreach ($sharepointInfo as $sharepointInstance)
                                        {
                                            $assetsByInstanceID[$sharepointInstance['instance_id']] = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_STATUS,
                                                Constants::INVENTORY_TYPE_FAMILY_SHAREPOINT,
                                                $this->buildInventoryNodeID($systemID, $clientID, $applicationID, $sharepointInstance['instance_id']),
                                                $sharepointInstance['name'],
                                                Constants::INVENTORY_ID_SHAREPOINT_FARM);
                                        }
                                        break;

                                    case Constants::APPLICATION_TYPE_NAME_XEN:

                                        $xenInfo = $this->BP->get_xen_vm_info($clientID, true, false, $systemID);
                                        // Sort VMs alphabetically
                                        $xenInfo = $this->sort($xenInfo);

                                        foreach ($xenInfo as $xenVM)
                                        {
                                            $assetsByInstanceID[$xenVM['instance_id']] = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_STATUS,
                                                Constants::INVENTORY_TYPE_FAMILY_XEN,
                                                $this->buildInventoryNodeID($systemID, $clientID, $applicationID, $xenVM['instance_id'], $xenVM['server_uuid']),
                                                $xenVM['name'],
                                                Constants::INVENTORY_ID_XEN_VM);
                                        }
                                        break;

                                    case Constants::APPLICATION_TYPE_NAME_VMWARE:
                                        foreach ($applicationArray['servers'] as $esxServerUUID => $esxServerName)
                                        {
                                            $vmList = $this->BP->get_vm_info($esxServerUUID, NULL, true, false, $systemID);
                                            // Sorts VMs alphabetically
                                            $vmList = $this->sort($vmList);

                                            if ($vmList !== false and count($vmList) > 0)
                                            {
                                                foreach ($vmList as $vm)
                                                {
                                                    if ($vm['template'] === true)
                                                    {
                                                        $assetsByInstanceID[$vm['instance_id']] = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_STATUS,
                                                            Constants::INVENTORY_TYPE_FAMILY_VMWARE,
                                                            $this->buildInventoryNodeID($systemID, $clientID, $applicationID, $vm['instance_id'], $esxServerUUID),
                                                            $vm['name'],
                                                            Constants::INVENTORY_ID_VMWARE_TEMPLATE);
                                                    }
                                                    else
                                                    {
                                                        $assetsByInstanceID[$vm['instance_id']] = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_STATUS,
                                                            Constants::INVENTORY_TYPE_FAMILY_VMWARE,
                                                            $this->buildInventoryNodeID($systemID, $clientID, $applicationID, $vm['instance_id'], $esxServerUUID),
                                                            $vm['name'],
                                                            Constants::INVENTORY_ID_VMWARE_VM);
                                                    }
                                                }
                                            }
                                        }
                                        break;
                                }
                            }
                        }
                    }
                }
            }

            // ----Backups Logic----

            $backup_status_result_format = array();
            $backup_status_result_format['system_id'] = $systemID;
            $backup_status_result_format['type'] = array(
                Constants::BACKUP_TYPE_MASTER,
                Constants::BACKUP_TYPE_DIFFERENTIAL,
                Constants::BACKUP_TYPE_INCREMENTAL,
                Constants::BACKUP_TYPE_BAREMETAL,
                Constants::BACKUP_TYPE_SELECTIVE,
                Constants::BACKUP_TYPE_MSSQL_FULL,
                Constants::BACKUP_TYPE_MSSQL_DIFFERENTIAL,
                Constants::BACKUP_TYPE_MSSQL_TRANSACTION,
                Constants::BACKUP_TYPE_EXCHANGE_FULL,
                Constants::BACKUP_TYPE_EXCHANGE_DIFFERENTIAL,
                Constants::BACKUP_TYPE_EXCHANGE_INCREMENTAL,
                Constants::BACKUP_TYPE_LEGACY_MSSQL_FULL,
                Constants::BACKUP_TYPE_LEGACY_MSSQL_DIFF,
                Constants::BACKUP_TYPE_LEGACY_MSSQL_TRANS,
                Constants::BACKUP_TYPE_VMWARE_FULL,
                Constants::BACKUP_TYPE_VMWARE_DIFFERENTIAL,
                Constants::BACKUP_TYPE_VMWARE_INCREMENTAL,
                Constants::BACKUP_TYPE_HYPER_V_FULL,
                Constants::BACKUP_TYPE_HYPER_V_INCREMENTAL,
                Constants::BACKUP_TYPE_HYPER_V_DIFFERENTIAL,
                Constants::BACKUP_TYPE_ORACLE_FULL,
                Constants::BACKUP_TYPE_ORACLE_INCR,
                Constants::BACKUP_TYPE_SHAREPOINT_FULL,
                Constants::BACKUP_TYPE_SHAREPOINT_DIFF,
                Constants::BACKUP_TYPE_XEN_FULL); //,  The following backup types are not needed for 9.0
            //Constants::BACKUP_TYPE_SYSTEM_METADATA,  // Do NOT include system metadata in this report
            //Constants::BACKUP_TYPE_UCS_SERVICE_PROFILE_FULL,
            //Constants::BACKUP_TYPE_NDMP_FULL,
            //Constants::BACKUP_TYPE_NDMP_DIFF,
            //Constants::BACKUP_TYPE_NDMP_INCR );
            $backup_status_result_format['start_time'] = strtotime('today -6 days');
            $backup_status_result_format['grandclients'] = false;
            /*
            if ( array_key_exists('finish_interval_start', $data) )
            {
                $backup_status_result_format['finish_interval_start'] = $data['finish_interval_start'];
            }
            if ( array_key_exists('Finish_interval_end', $data) )
            {
                $backup_status_result_format['Finish_interval_end'] = $data['Finish_interval_end'];
            }
            */

            $backup_status_result_array = $this->BP->get_backup_status($backup_status_result_format);

            if ($backup_status_result_array !== false)
            {
                foreach ($backup_status_result_array as &$backup)
                {
                    $backupInstanceID = NULL;
                    $day = date("w", $backup['start_time']);

                    switch ( $backup['type'] )
                    {
                        case Constants::BACKUP_TYPE_MASTER:
                        case Constants::BACKUP_TYPE_DIFFERENTIAL:
                        case Constants::BACKUP_TYPE_INCREMENTAL:
                        case Constants::BACKUP_TYPE_BAREMETAL:
                        case Constants::BACKUP_TYPE_SELECTIVE:
                            $backupInstanceID = $fileLevelInstanceIDByClientID[$backup['client_id']];
                            break;
                        default:
                        /*case Constants::BACKUP_TYPE_MSSQL_FULL:
                        case Constants::BACKUP_TYPE_EXCHANGE_FULL:
                        case Constants::BACKUP_TYPE_LEGACY_MSSQL_FULL:
                        case Constants::BACKUP_TYPE_VMWARE_FULL:
                        case Constants::BACKUP_TYPE_HYPER_V_FULL:
                        case Constants::BACKUP_TYPE_ORACLE_FULL:
                        case Constants::BACKUP_TYPE_SHAREPOINT_FULL:
                        case Constants::BACKUP_TYPE_MSSQL_DIFFERENTIAL:
                        case Constants::BACKUP_TYPE_EXCHANGE_DIFFERENTIAL:
                        case Constants::BACKUP_TYPE_LEGACY_MSSQL_DIFF:
                        case Constants::BACKUP_TYPE_VMWARE_DIFFERENTIAL:
                        case Constants::BACKUP_TYPE_HYPER_V_DIFFERENTIAL:
                        case Constants::BACKUP_TYPE_SHAREPOINT_DIFF:
                        case Constants::BACKUP_TYPE_EXCHANGE_INCREMENTAL:
                        case Constants::BACKUP_TYPE_VMWARE_INCREMENTAL:
                        case Constants::BACKUP_TYPE_HYPER_V_INCREMENTAL:
                        case Constants::BACKUP_TYPE_ORACLE_INCR:
                        case Constants::BACKUP_TYPE_MSSQL_TRANSACTION:
                        case Constants::BACKUP_TYPE_LEGACY_MSSQL_TRANS:
                        case Constants::BACKUP_TYPE_XEN_FULL:*/
                            $backupInstanceID = $backup['instance_id'];
                            break;
                    }

                    if ( $backup['complete'] === true )
                    {
                        switch ( $backup['status'] )
                        {
                            case Constants::BACKUP_STATUS_SUCCESS:
                                $assetsByInstanceID[$backupInstanceID]['last_backups'][$day]['successes']['count'] += 1;
                                $assetsByInstanceID[$backupInstanceID]['last_backups'][$day]['successes']['ids'][] = $backup['id'];
                                break;
                            case Constants::BACKUP_STATUS_WARNINGS:
                                $assetsByInstanceID[$backupInstanceID]['last_backups'][$day]['warnings']['count'] += 1;
                                $assetsByInstanceID[$backupInstanceID]['last_backups'][$day]['warnings']['ids'][] = $backup['id'];
                                break;
                            case Constants::BACKUP_STATUS_FAILURE:
                                $assetsByInstanceID[$backupInstanceID]['last_backups'][$day]['failures']['count'] += 1;
                                $assetsByInstanceID[$backupInstanceID]['last_backups'][$day]['failures']['ids'][] = $backup['id'];
                                break;
                        }
                    }
                    else
                    {
                        $assetsByInstanceID[$backupInstanceID]['last_backups'][$day]['incomplete']['count'] += 1;
                        $assetsByInstanceID[$backupInstanceID]['last_backups'][$day]['incomplete']['ids'][] = $backup['id'];
                    }
                }
            }

            // ----Replication Backup Copy Logic----

            $backup_status_result_format['type'] = array(
                Constants::BACKUP_TYPE_SECURESYNC_MASTER,
                Constants::BACKUP_TYPE_SECURESYNC_DIFFERENTIAL,
                Constants::BACKUP_TYPE_SECURESYNC_INCREMENTAL,
                Constants::BACKUP_TYPE_SECURESYNC_BAREMETAL,
                //Constants::BACKUP_TYPE_SECURESYNC_DPU_STATE, // Do NOT include system metadata in this report
                //Constants::BACKUP_TYPE_SECURESYNC_LOCAL_DIRECTORY, // Do NOT include system metadata in this report
                Constants::BACKUP_TYPE_SECURESYNC_MS_SQL,
                Constants::BACKUP_TYPE_SECURESYNC_EXCHANGE,
                Constants::BACKUP_TYPE_SECURESYNC_MSSQL_FULL,
                Constants::BACKUP_TYPE_SECURESYNC_MSSQL_DIFFERENTIAL,
                Constants::BACKUP_TYPE_SECURESYNC_MSSQL_TRANSACTION,
                Constants::BACKUP_TYPE_SECURESYNC_EXCHANGE_FULL,
                Constants::BACKUP_TYPE_SECURESYNC_EXCHANGE_DIFFERENTIAL,
                Constants::BACKUP_TYPE_SECURESYNC_EXCHANGE_INCREMENTAL,
                Constants::BACKUP_TYPE_SECURESYNC_VMWARE_FULL,
                Constants::BACKUP_TYPE_SECURESYNC_VMWARE_DIFFERENTIAL,
                Constants::BACKUP_TYPE_SECURESYNC_VMWARE_INCREMENTAL,
                Constants::BACKUP_TYPE_SECURESYNC_HYPER_V_FULL,
                Constants::BACKUP_TYPE_SECURESYNC_HYPER_V_INCREMENTAL,
                Constants::BACKUP_TYPE_SECURESYNC_HYPER_V_DIFFERENTIAL,
                Constants::BACKUP_TYPE_SECURESYNC_ORACLE_FULL,
                Constants::BACKUP_TYPE_SECURESYNC_ORACLE_INCR,
                Constants::BACKUP_TYPE_SECURESYNC_SHAREPOINT_FULL,
                Constants::BACKUP_TYPE_SECURESYNC_SHAREPOINT_DIFF,
                Constants::BACKUP_TYPE_SECURESYNC_XEN_FULL ); //,  The following backup types are not needed for 9.0
            //Constants::BACKUP_TYPE_SECURESYNC_UCS_SERVICE_PROFILE_FULL,
            //Constants::BACKUP_TYPE_SECURESYNC_NDMP_FULL,
            //Constants::BACKUP_TYPE_SECURESYNC_NDMP_DIFF,
            //Constants::BACKUP_TYPE_SECURESYNC_NDMP_INCR);

            $backup_status_result_array = $this->BP->get_backup_status($backup_status_result_format);

            if ($backup_status_result_array !== false)
            {
                foreach ($backup_status_result_array as &$backup)
                {
                    $backupInstanceID = NULL;
                    $targetName = $backup['destination'];
                    $day = date("w", $backup['start_time']);

                    switch ( $backup['type'] )
                    {
                        case Constants::BACKUP_TYPE_SECURESYNC_MASTER:
                        case Constants::BACKUP_TYPE_SECURESYNC_DIFFERENTIAL:
                        case Constants::BACKUP_TYPE_SECURESYNC_INCREMENTAL:
                        case Constants::BACKUP_TYPE_SECURESYNC_BAREMETAL:
                            $backupInstanceID = $fileLevelInstanceIDByClientID[$backup['client_id']];
                            break;
                        default:
                        /*case Constants::BACKUP_TYPE_SECURESYNC_MS_SQL:
                        case Constants::BACKUP_TYPE_SECURESYNC_EXCHANGE:
                        case Constants::BACKUP_TYPE_SECURESYNC_EXCHANGE_FULL:
                        case Constants::BACKUP_TYPE_SECURESYNC_MSSQL_FULL:
                        case Constants::BACKUP_TYPE_SECURESYNC_VMWARE_FULL:
                        case Constants::BACKUP_TYPE_SECURESYNC_HYPER_V_FULL:
                        case Constants::BACKUP_TYPE_SECURESYNC_ORACLE_FULL:
                        case Constants::BACKUP_TYPE_SECURESYNC_SHAREPOINT_FULL:
                        case Constants::BACKUP_TYPE_SECURESYNC_MSSQL_DIFFERENTIAL:
                        case Constants::BACKUP_TYPE_SECURESYNC_EXCHANGE_DIFFERENTIAL:
                        case Constants::BACKUP_TYPE_SECURESYNC_VMWARE_DIFFERENTIAL:
                        case Constants::BACKUP_TYPE_SECURESYNC_HYPER_V_DIFFERENTIAL:
                        case Constants::BACKUP_TYPE_SECURESYNC_SHAREPOINT_DIFF:
                        case Constants::BACKUP_TYPE_SECURESYNC_EXCHANGE_INCREMENTAL:
                        case Constants::BACKUP_TYPE_SECURESYNC_VMWARE_INCREMENTAL:
                        case Constants::BACKUP_TYPE_SECURESYNC_HYPER_V_INCREMENTAL:
                        case Constants::BACKUP_TYPE_SECURESYNC_ORACLE_INCR:
                        case Constants::BACKUP_TYPE_SECURESYNC_MSSQL_TRANSACTION:
                        case Constants::BACKUP_TYPE_SECURESYNC_XEN_FULL:*/
                            $backupInstanceID = $backup['instance_id'];
                            break;
                    }

                    if ( array_key_exists( $targetName, $assetsByInstanceID[$backupInstanceID]['last_backup_copies'][$day]['backup_copy_targets']) === false )
                    {
                        $assetsByInstanceID[$backupInstanceID]['last_backup_copies'][$day]['backup_copy_targets'][$targetName] = array(
                            'successes' => array('count' => 0, 'ids' => array()),
                            'failures' => array('count' => 0, 'ids' => array()),
                            'incomplete' => array('count' => 0, 'ids' => array()) );
                    }

                    if ( $backup['complete'] === true )
                    {
                        switch ( $backup['status'] )
                        {
                            case Constants::BACKUP_STATUS_SUCCESS:
                                $assetsByInstanceID[$backupInstanceID]['last_backup_copies'][$day]['successes']['count'] += 1;
                                $assetsByInstanceID[$backupInstanceID]['last_backup_copies'][$day]['successes']['ids'][] = $backup['id'];
                                $assetsByInstanceID[$backupInstanceID]['last_backup_copies'][$day]['backup_copy_targets'][$targetName]['successes']['count'] += 1;
                                $assetsByInstanceID[$backupInstanceID]['last_backup_copies'][$day]['backup_copy_targets'][$targetName]['successes']['ids'][] = $backup['id'];
                                break;
                            case Constants::BACKUP_STATUS_FAILURE:
                                $assetsByInstanceID[$backupInstanceID]['last_backup_copies'][$day]['failures']['count'] += 1;
                                $assetsByInstanceID[$backupInstanceID]['last_backup_copies'][$day]['failures']['ids'][] = $backup['id'];
                                $assetsByInstanceID[$backupInstanceID]['last_backup_copies'][$day]['backup_copy_targets'][$targetName]['failures']['count'] += 1;
                                $assetsByInstanceID[$backupInstanceID]['last_backup_copies'][$day]['backup_copy_targets'][$targetName]['failures']['ids'][] = $backup['id'];
                                break;
                        }
                    }
                    else
                    {
                        $assetsByInstanceID[$backupInstanceID]['last_backup_copies'][$day]['incomplete']['count'] += 1;
                        $assetsByInstanceID[$backupInstanceID]['last_backup_copies'][$day]['incomplete']['ids'][] = $backup['id'];
                        $assetsByInstanceID[$backupInstanceID]['last_backup_copies'][$day]['backup_copy_targets'][$targetName]['incomplete']['count'] += 1;
                        $assetsByInstanceID[$backupInstanceID]['last_backup_copies'][$day]['backup_copy_targets'][$targetName]['incomplete']['ids'][] = $backup['id'];
                    }
                }
            }


            //----Archiving Backup Copy Logic----


            $archive_status_result_format = array();
            $archive_status_result_format['type'] = array(
                Constants::BACKUP_TYPE_MASTER,
                Constants::BACKUP_TYPE_DIFFERENTIAL,
                Constants::BACKUP_TYPE_INCREMENTAL,
                Constants::BACKUP_TYPE_BAREMETAL,
                Constants::BACKUP_TYPE_SELECTIVE,
                Constants::BACKUP_TYPE_MSSQL_FULL,
                Constants::BACKUP_TYPE_MSSQL_DIFFERENTIAL,
                Constants::BACKUP_TYPE_MSSQL_TRANSACTION,
                Constants::BACKUP_TYPE_EXCHANGE_FULL,
                Constants::BACKUP_TYPE_EXCHANGE_DIFFERENTIAL,
                Constants::BACKUP_TYPE_EXCHANGE_INCREMENTAL,
                Constants::BACKUP_TYPE_LEGACY_MSSQL_FULL,  // Not listed in the definition of bp_get_archive_status
                Constants::BACKUP_TYPE_LEGACY_MSSQL_DIFF,  // Not listed in the definition of bp_get_archive_status
                Constants::BACKUP_TYPE_LEGACY_MSSQL_TRANS,  // Not listed in the definition of bp_get_archive_status
                Constants::BACKUP_TYPE_VMWARE_FULL,
                Constants::BACKUP_TYPE_VMWARE_DIFFERENTIAL,
                Constants::BACKUP_TYPE_VMWARE_INCREMENTAL,
                Constants::BACKUP_TYPE_HYPER_V_FULL,
                Constants::BACKUP_TYPE_HYPER_V_INCREMENTAL,
                Constants::BACKUP_TYPE_HYPER_V_DIFFERENTIAL,  // Not listed in the definition of bp_get_archive_status
                Constants::BACKUP_TYPE_ORACLE_FULL,
                Constants::BACKUP_TYPE_ORACLE_INCR,
                Constants::BACKUP_TYPE_SHAREPOINT_FULL,
                Constants::BACKUP_TYPE_SHAREPOINT_DIFF,
                Constants::BACKUP_TYPE_XEN_FULL ); //,  The following backup types are not needed for 9.0
            //Constants::BACKUP_TYPE_SYSTEM_METADATA,  // Do NOT include system metadata in this report
            //Constants::BACKUP_TYPE_UCS_SERVICE_PROFILE_FULL,
            //Constants::BACKUP_TYPE_NDMP_FULL,
            //Constants::BACKUP_TYPE_NDMP_DIFF,
            //Constants::BACKUP_TYPE_NDMP_INCR );

            $archive_status_result_format['job_start_time'] = $backup_status_result_format['start_time'];

            $archive_status_result_format = $this->BP->get_archive_status($archive_status_result_format, $systemID);

            if ($archive_status_result_format !== false)
            {
                foreach ($archive_status_result_format as &$archive_backup)
                {
                    if ( $archive_backup['is_imported'] === false and array_key_exists('client_id', $archive_backup) )
                    {
                        $backupInstanceID = NULL;
                        $targetName = $archive_backup['target'];
                        $day = date("w", $archive_backup['job_start_time']);

                        switch ( $archive_backup['type'] )
                        {
                            case Constants::BACKUP_TYPE_MASTER:
                            case Constants::BACKUP_TYPE_DIFFERENTIAL:
                            case Constants::BACKUP_TYPE_INCREMENTAL:
                            case Constants::BACKUP_TYPE_BAREMETAL:
                            case Constants::BACKUP_TYPE_SELECTIVE:
                                $backupInstanceID = $fileLevelInstanceIDByClientID[$archive_backup['client_id']];
                                break;
                            default:
                            /*case Constants::BACKUP_TYPE_MSSQL_FULL:
                            case Constants::BACKUP_TYPE_EXCHANGE_FULL:
                            case Constants::BACKUP_TYPE_LEGACY_MSSQL_FULL:
                            case Constants::BACKUP_TYPE_VMWARE_FULL:
                            case Constants::BACKUP_TYPE_HYPER_V_FULL:
                            case Constants::BACKUP_TYPE_ORACLE_FULL:
                            case Constants::BACKUP_TYPE_SHAREPOINT_FULL:
                            case Constants::BACKUP_TYPE_MSSQL_DIFFERENTIAL:
                            case Constants::BACKUP_TYPE_EXCHANGE_DIFFERENTIAL:
                            case Constants::BACKUP_TYPE_LEGACY_MSSQL_DIFF:
                            case Constants::BACKUP_TYPE_VMWARE_DIFFERENTIAL:
                            case Constants::BACKUP_TYPE_HYPER_V_DIFFERENTIAL:
                            case Constants::BACKUP_TYPE_SHAREPOINT_DIFF:
                            case Constants::BACKUP_TYPE_EXCHANGE_INCREMENTAL:
                            case Constants::BACKUP_TYPE_VMWARE_INCREMENTAL:
                            case Constants::BACKUP_TYPE_HYPER_V_INCREMENTAL:
                            case Constants::BACKUP_TYPE_ORACLE_INCR:
                            case Constants::BACKUP_TYPE_MSSQL_TRANSACTION:
                            case Constants::BACKUP_TYPE_LEGACY_MSSQL_TRANS:
                            case Constants::BACKUP_TYPE_XEN_FULL:*/
                                $backupInstanceID = $archive_backup['instance_id'];
                                break;
                        }

                        if ( array_key_exists( $targetName, $assetsByInstanceID[$backupInstanceID]['last_backup_copies'][$day]['backup_copy_targets']) === false )
                        {
                            $assetsByInstanceID[$backupInstanceID]['last_backup_copies'][$day]['backup_copy_targets'][$targetName] = array(
                                'successes' => array('count' => 0, 'ids' => array()),
                                'failures' => array('count' => 0, 'ids' => array()),
                                'incomplete' => array('count' => 0, 'ids' => array()) );
                        }
                        if ( $archive_backup['success'] === true )
                        {
                                $assetsByInstanceID[$backupInstanceID]['last_backup_copies'][$day]['successes']['count'] += 1;
                                $assetsByInstanceID[$backupInstanceID]['last_backup_copies'][$day]['successes']['ids'][] = $archive_backup['archive_id'].'a';
                                $assetsByInstanceID[$backupInstanceID]['last_backup_copies'][$day]['backup_copy_targets'][$targetName]['successes']['count'] += 1;
                                $assetsByInstanceID[$backupInstanceID]['last_backup_copies'][$day]['backup_copy_targets'][$targetName]['successes']['ids'][] = $archive_backup['archive_id'];
                        }
                        else
                        {
                                $assetsByInstanceID[$backupInstanceID]['last_backup_copies'][$day]['failures']['count'] += 1;
                                $assetsByInstanceID[$backupInstanceID]['last_backup_copies'][$day]['failures']['ids'][] = $archive_backup['archive_id'].'a';
                                $assetsByInstanceID[$backupInstanceID]['last_backup_copies'][$day]['backup_copy_targets'][$targetName]['failures']['count'] += 1;
                                $assetsByInstanceID[$backupInstanceID]['last_backup_copies'][$day]['backup_copy_targets'][$targetName]['failures']['ids'][] = $archive_backup['archive_id'];
                        }
                    }
                }
            }


            $inventoryStatusArray = array_merge( $inventoryStatusArray, array_values($assetsByInstanceID) );
        }

        return $inventoryStatusArray;

    }

    public function getInventoryIDForAClientFromOSFamily( $os_family )
    {
        $inventoryID = Constants::INVENTORY_ID_CLIENT_OTHER;
        switch ( $os_family )
        {
            case Constants::OS_FAMILY_DOS:
                $inventoryID = Constants::INVENTORY_ID_CLIENT_DOS;
                break;
            case Constants::OS_FAMILY_OES:
                $inventoryID = Constants::INVENTORY_ID_CLIENT_OES;
                break;
            case Constants::OS_FAMILY_OS2:
                $inventoryID = Constants::INVENTORY_ID_CLIENT_OS2;
                break;
            case Constants::OS_FAMILY_UNIX:
                $inventoryID = Constants::INVENTORY_ID_CLIENT_UNIX;
                break;
            case Constants::OS_FAMILY_SCO:
                $inventoryID = Constants::INVENTORY_ID_CLIENT_SCO;
                break;
            case Constants::OS_FAMILY_SOLARIS:
                $inventoryID = Constants::INVENTORY_ID_CLIENT_SOLARIS;
                break;
            case Constants::OS_FAMILY_AIX:
                $inventoryID = Constants::INVENTORY_ID_CLIENT_AIX;
                break;
            case Constants::OS_FAMILY_SGI:
                $inventoryID = Constants::INVENTORY_ID_CLIENT_SGI;
                break;
            case Constants::OS_FAMILY_HPUX:
                $inventoryID = Constants::INVENTORY_ID_CLIENT_HPUX;
                break;
            case Constants::OS_FAMILY_FREE_BSD:
                $inventoryID = Constants::INVENTORY_ID_CLIENT_FREE_BSD;
                break;
            case Constants::OS_FAMILY_MAC_OS:
                $inventoryID = Constants::INVENTORY_ID_CLIENT_MAC;
                break;
            case Constants::OS_FAMILY_LINUX:
                $inventoryID = Constants::INVENTORY_ID_CLIENT_LINUX;
                break;
            case Constants::OS_FAMILY_I_SERIES:
                $inventoryID = Constants::INVENTORY_ID_CLIENT_I_SERIES;
                break;
            case Constants::OS_FAMILY_NOVELL_NETWARE:
                $inventoryID = Constants::INVENTORY_ID_CLIENT_NETWARE;
                break;
            case Constants::OS_FAMILY_WINDOWS:
                $inventoryID = Constants::INVENTORY_ID_CLIENT_WINDOWS;
                break;
            case Constants::OS_FAMILY_GENERIC:  // There shouldn't be an Inventory Node for a Generic Client.
                $inventoryID = Constants::INVENTORY_ID_CLIENT_OTHER;
                break;
        }
        return $inventoryID;
    }

    private function getInventorySettings( $sid = false , $node_id = NULL , $systems = NULL)
    {
        $relevantClients = $this->getRelevantClients($sid, $node_id , $systems);
        $settingsReturnArray = array();


        $specifiedApplicationID = NULL;
        $specifiedInstanceID = NULL;
        $specifiedEsxServerUUID = NULL;
        $specifiedVMwareKey = NULL;
        if ($node_id !== NULL)
        {
            // Because getRelevantClients filters on $systemID and $clientID, they are not needed here
            // Because getRelevantClients does not throw out any applications, $applicationID is still needed
            $inventoryNodeIDArray = $this->getNodeIDArrayFromInventoryNodeID($node_id);
            if (array_key_exists('applicationID', $inventoryNodeIDArray))
            {
                $specifiedApplicationID = $inventoryNodeIDArray['applicationID'];
                if (array_key_exists('instanceID', $inventoryNodeIDArray))
                {
                    $specifiedInstanceID = $inventoryNodeIDArray['instanceID'];
                }
                elseif (array_key_exists('esxServerUUID', $inventoryNodeIDArray))
                {
                    $specifiedEsxServerUUID = $inventoryNodeIDArray['esxServerUUID'];
                    if (array_key_exists('instanceID', $inventoryNodeIDArray))
                    {
                        $specifiedInstanceID = $inventoryNodeIDArray['instanceID'];
                    }
                    elseif (array_key_exists('VMwareKey', $inventoryNodeIDArray))
                    {
                        $specifiedVMwareKey = $inventoryNodeIDArray['VMwareKey'];
                    }
                }
            }
        }

        foreach ( $relevantClients as $systemID => $system )
        {
            if ( count($system['windowsClients']) > 0 )
            {
                foreach ( $system['windowsClients'] as $windowsClient )
                {
                    if ( $specifiedApplicationID === NULL )
                    {
                        $tempSettingsInventoryNodeArray = $this->buildInventoryNodeArray( Inventory::INVENTORY_GET_TYPE_SETTINGS,
                            Constants::HV_WINDOWS,
                            $this->buildInventoryNodeID( $systemID, $windowsClient['id'], Constants::APPLICATION_ID_FILE_LEVEL, $windowsClient['file_level_instance_id'] ),
                            $windowsClient['name'],
                            Constants::NODE_TYPE_COMPUTER );
                        $tempSettingsInventoryNodeArray['credentials'] = isset($windowsClient['credentials']) ? $windowsClient['credentials'] : array();
                        $settingsReturnArray[] = $tempSettingsInventoryNodeArray;
                    }

                    foreach ($windowsClient['applications'] as $applicationID => $windowsApplication)
                    {
                        if ( $specifiedApplicationID === NULL or $specifiedApplicationID === $applicationID )
                        {
                            if ( $windowsApplication['type'] == Constants::APPLICATION_TYPE_NAME_HYPER_V )
                            {
                                /* //Don't need Hyper-V Hosts at the moment
                                $tempSettingsInventoryNodeArray = $this->buildInventoryNodeArray( Inventory::INVENTORY_GET_TYPE_SETTINGS,
                                    Constants::HV_HYPER_V,
                                    $this->buildInventoryNodeID( $systemID, $hyperVClient['id'], $applicationID ),
                                    $hyperVClient['name']."'s ".$hyperVApplication['name'],
                                    Constants::NODE_TYPE_HOST );
                                $tempSettingsInventoryNodeArray['retention'] = $this->getRetentionType( $systemID, $hyperVClient['id'], $applicationID) ;
                                $settingsReturnArray[] = $tempSettingsInventoryNodeArray; */

                                $hyperVInfo = $this->BP->get_hyperv_info($windowsClient['id'], true, $systemID);
                                // Sort VMs alphabetically
                                $hyperVInfo = $this->sort($hyperVInfo);

                                foreach ( $hyperVInfo as $hyperVVM )
                                {
                                    //Is instance_id the right value or should it be guid?
                                    if ( $specifiedInstanceID === NULL or $specifiedInstanceID === $hyperVVM['instance_id'] )
                                    {
                                        $tempSettingsInventoryNodeArray = $this->buildInventoryNodeArray( Inventory::INVENTORY_GET_TYPE_SETTINGS,
                                            Constants::HV_HYPER_V,
                                            $this->buildInventoryNodeID( $systemID, $windowsClient['id'], $applicationID, $hyperVVM['instance_id'] ),
                                            $hyperVVM['name'],
                                            Constants::NODE_TYPE_VM );
                                        $tempSettingsInventoryNodeArray['is_standalone'] = $hyperVVM['is_standalone'];
                                        $tempSettingsInventoryNodeArray['cluster_name'] = $hyperVVM['cluster_name'];
                                        $settingsReturnArray[] = $tempSettingsInventoryNodeArray;
                                    }
                                }
                            }
                        }
                    }
                }
            }
            if ( count($system['VMwareClients']) > 0 )
            {
                foreach ( $system['VMwareClients'] as $VMwareClient )
                {
                    foreach ( $VMwareClient['applications'] as $applicationID => $VMwareApplication )
                    {
                        if ( $specifiedApplicationID === NULL or $specifiedApplicationID === $applicationID )
                        {
                            if ( $VMwareApplication['type'] == Constants::APPLICATION_TYPE_NAME_VMWARE )
                            {
                                foreach ( $VMwareApplication['servers'] as $esxServerUUID => $esxServerName )
                                {
                                    if ($specifiedEsxServerUUID === NULL or $specifiedEsxServerUUID === $esxServerUUID)
                                    {
                                        $relevantResourcePoolAndVAppKeys = NULL;
                                        if ( $specifiedVMwareKey !== NULL )
                                        {
                                            $relevantResourcePoolAndVAppKeys = array();
                                            $notRelevantYet = array();
                                            $resourcePoolAndVAppArray = $this->BP->get_resource_pool_info($esxServerUUID, $systemID);
                                            $resourcePoolAndVAppArray = array_merge( $resourcePoolAndVAppArray, $this->BP->get_vApp_info($esxServerUUID, $systemID) );
                                            foreach ( $resourcePoolAndVAppArray as $resourcePoolAndVApp )
                                            {
                                                if ( $resourcePoolAndVApp['key'] === $specifiedVMwareKey or $resourcePoolAndVApp['parentKey'] === $specifiedVMwareKey  )
                                                {
                                                    $relevantResourcePoolAndVAppKeys[] = $resourcePoolAndVApp['key'];
                                                }
                                                elseif ( $resourcePoolAndVApp['parentType'] !== 0 )
                                                {
                                                    $notRelevantYet[] = $resourcePoolAndVApp;
                                                }
                                            }
                                            $changesMade = (count($notRelevantYet) > 0);
                                            $iterator = 0;
                                            while ( $changesMade === true or $iterator !== 0 )
                                            {
                                                if( $iterator === 0)
                                                {
                                                    $changesMade = false;
                                                    $workingArray = $notRelevantYet;
                                                    unset($notRelevantYet);
                                                    $notRelevantYet = array();
                                                }
                                                if ( in_array($workingArray[$iterator]['parentKey'], $relevantResourcePoolAndVAppKeys)  )
                                                {
                                                    $relevantResourcePoolAndVAppKeys[] = $workingArray[$iterator]['key'];
                                                    $changesMade = true;
                                                }
                                                else
                                                {
                                                    $notRelevantYet[] = $workingArray[$iterator];
                                                }
                                                $iterator = $iterator + 1;
                                                if ( $iterator === count($workingArray) )
                                                {
                                                    $iterator = 0;
                                                    $changesMade = ($changesMade and (count($notRelevantYet) > 0));
                                                }
                                            }
                                        }
                                        // Only need settings info for VMs, not disks, vApps, nor Resource Pools
                                        if ($specifiedInstanceID !== NULL)
                                        {
                                            //$get_disks is false because disks aren't needed
                                            $vmList = $this->BP->get_vm_info($esxServerUUID, (string)$specifiedInstanceID, true, false, $systemID);
                                        } else
                                        {
                                            //$get_disks is false because disks aren't needed
                                            $vmList = $this->BP->get_vm_info($esxServerUUID, NULL, true, false, $systemID);
                                        }
                                        // Sorts VMs alphabetically
                                        $vmList = $this->sort($vmList);
                                        if (count($vmList) > 0)
                                        {
                                            foreach ($vmList as $vm)
                                            {
                                                if ( $relevantResourcePoolAndVAppKeys === NULL or in_array($vm['parentKey'], $relevantResourcePoolAndVAppKeys)  )
                                                {
                                                    $tempSettingsInventoryNodeArray = $this->buildInventoryNodeArray(Inventory::INVENTORY_GET_TYPE_SETTINGS,
                                                        Constants::HV_VMWARE,
                                                        $this->buildInventoryNodeID($systemID, $VMwareClient['id'], $applicationID, $vm['instance_id'], $esxServerUUID),
                                                        $vm['name'],
                                                        Constants::NODE_TYPE_VM);
                                                    $tempSettingsInventoryNodeArray['credentials'] = $vm['credentials'];
                                                    $tempSettingsInventoryNodeArray['app_aware'] = $vm['app_aware'];
                                                    $tempSettingsInventoryNodeArray['template'] = $vm['template'];
                                                    $settingsReturnArray[] = $tempSettingsInventoryNodeArray;
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        return $settingsReturnArray;
    }

    private function getInventorySync( $sid )
    {
        require_once('summary.php');
        $summary = new Summary( $this->BP, $sid );
        return $summary->get("current", "");
    }

    private function putInventoryDisks( $node_id, $data = NULL  )
    {
        $status = false;

        $is_excluded = true;  // True excludes the disk, False includes the disk
        if ( array_key_exists('is_excluded', $data) )
        {
            $is_excluded = (bool)$data['is_excluded'];
        }


        if ($node_id !== NULL)
        {
            $inventoryNodeIDArray = $this->getNodeIDArrayFromInventoryNodeID($node_id);
            $specifiedSystemID = NULL;
            if ( array_key_exists('systemID', $inventoryNodeIDArray) )
            {
                $specifiedSystemID = $inventoryNodeIDArray['systemID'];
                if (array_key_exists('instanceID', $inventoryNodeIDArray))
                {
                    $specifiedInstanceID = $inventoryNodeIDArray['instanceID'];
                    if (array_key_exists('diskKey', $inventoryNodeIDArray))
                    {
                        $specifiedDiskKey = $inventoryNodeIDArray['diskKey'];

                        if ( $specifiedDiskKey !== NULL )
                        {
                            if ( array_key_exists('applicationID', $inventoryNodeIDArray) )
                            {
                                $specifiedApplicationID = $inventoryNodeIDArray['applicationID'];
                                if ( $specifiedApplicationID == Constants::APPLICATION_ID_VMWARE )
                                {
                                    $status = $this->BP->set_vm_disks( array( 0=>array('instance_id'=>(int)$specifiedInstanceID, 'key'=>(int)$specifiedDiskKey, 'is_excluded'=>$is_excluded) ), $specifiedSystemID );
                                }
                                else
                                {
                                    $status = $this->BP->set_xen_vm_disks( array( 0=>array('instance_id'=>(int)$specifiedInstanceID, 'key'=>(int)$specifiedDiskKey, 'is_excluded'=>$is_excluded) ), $specifiedSystemID );
                                }
                            }

                        }
                    }
                    else
                    {
                        //A node_id with diskKey needs to be specified
                        var_dump('here');
                    }
                }
                else
                {
                    //A node_id with instanceID needs to be specified
                    var_dump('ouch');
                }
            }
            else
            {
                //incorrect node_id format
                var_dump('there');
            }
        }
        else
        {
            //node_id must be present
            var_dump('where');
        }

        return $status;
    }

    public function buildInventoryNodeArray( $inventoryGetType, $type_family, $id, $name, $type )
    {
        $inventoryNodeArray = array();
        $inventoryNodeArray['type_family']  = $type_family;
        $inventoryNodeArray['id']           = $id;
        $inventoryNodeArray['name']         = $name;
        $inventoryNodeArray['type']         = $type;
        switch ($inventoryGetType)
        {
            case (Inventory::INVENTORY_GET_TYPE_TREE):
                $inventoryNodeArray['nodes']  = array();
                break;
            case (Inventory::INVENTORY_GET_TYPE_SETTINGS):
                $inventoryNodeArray['credentials']  = array();  //TBD = NULL;
                $inventoryNodeArray['is_standalone']  = false;
                $inventoryNodeArray['app_aware']  = false;
                $inventoryNodeArray['template']  = false;
                $inventoryNodeArray['cluster_name'] = "";
                break;
            case (Inventory::INVENTORY_GET_TYPE_STATUS):
                $empty_day = array( 'day' => 0, 'successes' => array('count' => 0, 'ids' => array()), 'failures' => array('count' => 0, 'ids' => array()), 'warnings' => array('count' => 0, 'ids' => array()), 'incomplete' => array('count' => 0, 'ids' => array()) );
                $empty_day_backup_copy = array( 'day' => 0, 'successes' => array('count' => 0, 'ids' => array()), 'failures' => array('count' => 0, 'ids' => array()), 'incomplete' => array('count' => 0, 'ids' => array()), 'backup_copy_targets' => array() );
                $inventoryNodeArray['last_backups'] = array( 0=>$empty_day, 1=>$empty_day, 2=>$empty_day, 3=>$empty_day, 4=>$empty_day, 5=>$empty_day, 6=>$empty_day );
                $inventoryNodeArray['last_backup_copies'] = array( 0=>$empty_day_backup_copy, 1=>$empty_day_backup_copy, 2=>$empty_day_backup_copy, 3=>$empty_day_backup_copy, 4=>$empty_day_backup_copy, 5=>$empty_day_backup_copy, 6=>$empty_day_backup_copy );
                for ( $i=1; $i<7; $i++ )
                {
                    $inventoryNodeArray['last_backups'][$i]['day'] = $i;
                    $inventoryNodeArray['last_backup_copies'][$i]['day'] = $i;
                }
                break;
        }

        return $inventoryNodeArray;
    }


    //Three options for a NodeID - VMware Resource Pool or vApp, VMware vm, or not VMware
    //Not VMware option: $systemID_$clientID_$applicationID_$instanceID_$diskKey
    //VMware VM option: $systemID_$clientID_$applicationID_$esxServerUUID_$instanceID_$diskKey
    //VMware Resource Pool or vApp option: $systemID_$clientID_$applicationID_$esxServerUUID_$VMwareKey
    //Do NOT give both a $VMwareKey and an $instanceID
    public function getNodeIDArrayFromInventoryNodeID( $inventoryNodeId )
    {
        $returnArray = array();
        if ( $inventoryNodeId !== NULL )
        {
            $tempArray = explode( Inventory::INVENTORY_NODE_SEPARATOR, $inventoryNodeId );
            if ( count($tempArray) > 0 and is_numeric($tempArray[0]) )
            {
                $returnArray['systemID'] = (int)$tempArray[0];
                if ( count($tempArray) > 1 and is_numeric($tempArray[1]) )
                {
                    $returnArray['clientID'] = (int)$tempArray[1];
                    if ( count($tempArray) > 2 and is_numeric($tempArray[2]) )//and (int)$tempArray[2] !== Constants::APPLICATION_ID_FILE_LEVEL )  //Don't show application ID for file-level
                    {
                        $returnArray['applicationID'] = (int)$tempArray[2];
                        if ( count($tempArray) > 3 )
                        {
                            if ( $returnArray['applicationID'] === Constants::APPLICATION_ID_VMWARE ||
                                 $returnArray['applicationID'] === Constants::APPLICATION_ID_XEN)
                            {
                                $returnArray['esxServerUUID'] = (string)$tempArray[3];
                                if ( count($tempArray) > 4 )
                                {
                                    //VMware VM option: $systemID_$clientID_$applicationID_$esxServerUUID_$instanceID_$diskKey
                                    // Xen VM option: $systemID_$clientID_$applicationID_$ServerUUID_$instanceID_$diskKey
                                    if ( is_numeric($tempArray[4]) )
                                    {
                                        $returnArray['instanceID'] = (int)$tempArray[4];
                                        if ( count($tempArray) > 5  and is_numeric($tempArray[5]) )
                                        {
                                            $returnArray['diskKey'] = $tempArray[5];
                                        }
                                    }
                                    //VMware Resource Pool or vApp option: $systemID_$clientID_$applicationID_$esxServerUUID_$VMwareKey
                                    //Make sure that $VMwareKey are never numeric
                                    else
                                    {
                                        $returnArray['VMwareKey'] = (string)$tempArray[4];
                                    }
                                }
                            }
                            //Not VMware option: $systemID_$clientID_$applicationID_$instanceID
                            else
                            {
                                $returnArray['instanceID'] = (int)$tempArray[3];
                                if ( count($tempArray) > 4 )
                                {
                                    $returnArray['diskKey'] = $tempArray[4];
                                }
                            }
                        }
                    }
                }
            }
        }
        return $returnArray;
    }

    //Three options for a NodeID - VMware Resource Pool or vApp, VMware vm, or not VMware
    //Not VMware option: $systemID_$clientID_$applicationID_$instanceID
    //VMware VM option: $systemID_$clientID_$applicationID_$esxServerUUID_$instanceID_$diskKey
    //VMware Resource Pool or vApp option: $systemID_$clientID_$applicationID_$esxServerUUID_$VMwareKey
    //Do NOT give both a $VMwareKey and an $instanceID
    // SQL can have an instanceID that is mapped to serverUUID
    // Xen can also have a server UUID
    private function buildInventoryNodeID( $systemID,
                                           $clientID = NULL,
                                           $applicationID = NULL,
                                           $instanceID = NULL,
                                           $serverUUID = NULL,
                                           $VMwareKey = NULL ,
                                           $diskKey = NULL )
    {
        $returnID = "";
        if ( $systemID !== NULL )
        {
            $returnID = (string)$systemID;
            if ( $clientID !== NULL )
            {
                $returnID = $returnID.(Inventory::INVENTORY_NODE_SEPARATOR).(string)$clientID;
                if ( $applicationID !== NULL )
                {
                    $returnID = $returnID.(Inventory::INVENTORY_NODE_SEPARATOR).(string)$applicationID;
                    if (((int)$applicationID === Constants::APPLICATION_ID_VMWARE ||
                            (int)$applicationID === Constants::APPLICATION_ID_XEN ||
                            (int)$applicationID === Constants::APPLICATION_ID_SQL_SERVER_2005 ||
                            (int)$applicationID === Constants::APPLICATION_ID_SQL_SERVER_2008 ||
                            (int)$applicationID === Constants::APPLICATION_ID_SQL_SERVER_2008_R2 ||
                            (int)$applicationID === Constants::APPLICATION_ID_SQL_SERVER_2012 ||
                            (int)$applicationID === Constants::APPLICATION_ID_SQL_SERVER_2014) and $serverUUID !== NULL )
                    {
                        $returnID = $returnID.(Inventory::INVENTORY_NODE_SEPARATOR).(string)$serverUUID;
                        //VMware VM option: $systemID_$clientID_$applicationID_$esxServerUUID_$instanceID_$diskKey
                        if ( $instanceID !== NULL )
                        {
                            $returnID = $returnID.(Inventory::INVENTORY_NODE_SEPARATOR).(string)$instanceID;
                            if ( $diskKey !== NULL )
                            {
                                $returnID = $returnID.(Inventory::INVENTORY_NODE_SEPARATOR).(string)$diskKey;
                            }
                        }
                        //VMware Resource Pool or vApp option: $systemID_$clientID_$applicationID_$esxServerUUID_$VMwareKey
                        elseif ( $VMwareKey !== NULL )
                        {
                            $returnID = $returnID.(Inventory::INVENTORY_NODE_SEPARATOR).(string)$VMwareKey;
                        }
                    }
                    //Not VMware option: $systemID_$clientID_$applicationID_$instanceID
                    elseif ( $instanceID !== NULL )
                    {
                        $returnID = $returnID.(Inventory::INVENTORY_NODE_SEPARATOR).(string)$instanceID;
                        if ( $diskKey !== NULL )
                        {
                            $returnID = $returnID.(Inventory::INVENTORY_NODE_SEPARATOR).(string)$diskKey;
                        }
                    }
                }
            }
        }
        return $returnID;
    }

    // $do_status_arrays adds empty arrays to be filled in by GET /inventory/status
    private function getRelevantClients( $sid = false , $node_id = NULL, $systems= NULL, $do_status_arrays = false, $showSystemClient = '0' )
    {
        $specifiedSystemID = NULL;
        $specifiedClientID = NULL;
        if ( $node_id !== NULL )
        {
            $inventoryNodeIDArray = $this->getNodeIDArrayFromInventoryNodeID($node_id);
            if ( array_key_exists('systemID', $inventoryNodeIDArray) )
            {
                $specifiedSystemID = $inventoryNodeIDArray['systemID'];
                if ( array_key_exists('clientID', $inventoryNodeIDArray) )
                {
                    $specifiedClientID = $inventoryNodeIDArray['clientID'];
                }
            }
        }
        if ( $sid !== false  )
        {
            //Add system Name - Do this
            $systemList = array($sid => '');
        }
        elseif ( $specifiedSystemID !== NULL )
        {
            //Add system Name - Do this
            $systemList = array($specifiedSystemID => '');
        }
        else
        {
            $systemList = $systems;
        }
        foreach ($systemList as $systemID => $systemName)
        {
            $systems[$systemID] = array();
            //$systems[$systemID]['clients'] = array();  //Not needed at the moment, used if underlying function needs a list of clients
            $systems[$systemID]['systemName'] = $systemName;
            $systems[$systemID]['windowsClients'] = array();
            $systems[$systemID]['VMwareClients'] = array();

            if ( $specifiedClientID !== NULL )
            {
                $clients = array($specifiedClientID => '');
            }
            else
            {
                $clients = $this->BP->get_client_list($systemID);
            }
            foreach ($clients as $clientID => $clientName)
            {
                //$isClientRelevant = false;
                $clientInfo = $this->BP->get_client_info($clientID, $systemID);
                if ( $do_status_arrays )
                {
                    $empty_day = array( 'successes' => array('count' => 0, 'ids' => array()), 'failures' => array('count' => 0, 'ids' => array()), 'warnings' => array('count' => 0, 'ids' => array()), 'incomplete' => array('count' => 0, 'ids' => array()) );
                    $empty_day_archive = array( 'successes' => array('count' => 0, 'ids' => array()), 'failures' => array('count' => 0, 'ids' => array()) );
                    $clientInfo['client_backups'] = array( 0=>$empty_day, 1=>$empty_day, 2=>$empty_day, 3=>$empty_day, 4=>$empty_day, 5=>$empty_day, 6=>$empty_day );
                    $clientInfo['client_replications'] = array( 0=>$empty_day, 1=>$empty_day, 2=>$empty_day, 3=>$empty_day, 4=>$empty_day, 5=>$empty_day, 6=>$empty_day );
                    $clientInfo['client_archives'] = array( 0=>$empty_day_archive, 1=>$empty_day_archive, 2=>$empty_day_archive, 3=>$empty_day_archive, 4=>$empty_day_archive, 5=>$empty_day_archive, 6=>$empty_day_archive );
                    $clientInfo['vm_backups'] = array();
                    $clientInfo['vm_replications'] = array();
                    $clientInfo['vm_archives'] = array();
                }

                if ( $clientInfo['name'] == Constants::CLIENT_NAME_VCENTER_RRC )
                {
                    $systems[$systemID]['VMwareClients'][$clientID] = $clientInfo;
                }
                elseif ( $clientInfo['name'] != $systemName ) //Exclude the system client
                {
                    $systems[$systemID]['windowsClients'][$clientID] = $clientInfo;
                }
                elseif ( $showSystemClient === '1' )
                {
                    $systems[$systemID]['windowsClients'][$clientID] = $clientInfo;
                }
                //Commenting out all of this code temporarily in order to start showing everything in inventory.  Refactoring will need to be done later.
                /*
                if (   $clientInfo['os_type_id'] == Constants::OS_WIN_16
                    or $clientInfo['os_type_id'] == Constants::OS_WINDOWS_95
                    or $clientInfo['os_type_id'] == Constants::OS_WINDOWS_2000
                    or $clientInfo['os_type_id'] == Constants::OS_WINDOWS_XP
                    or $clientInfo['os_type_id'] == Constants::OS_WINDOWS_2003
                    or $clientInfo['os_type_id'] == Constants::OS_WINDOWS_VISTA
                    or $clientInfo['os_type_id'] == Constants::OS_WINDOWS_2008
                    or $clientInfo['os_type_id'] == Constants::OS_WIN_2008_R2
                    or $clientInfo['os_type_id'] == Constants::OS_WINDOWS_7
                    or $clientInfo['os_type_id'] == Constants::OS_WINDOWS_8
                    or $clientInfo['os_type_id'] == Constants::OS_WINDOWS_2012
                    or $clientInfo['os_type_id'] == Constants::OS_WINDOWS_8_1
                    or $clientInfo['os_type_id'] == Constants::OS_WINDOWS_2012_R2 )
                {
                    $systems[$systemID]['windowsClients'][$clientID] = $clientInfo;
                    //$isClientRelevant = true;
                }
                //This is unnecessary because hyperv clusters are all Windows Clients
                elseif ( $clientInfo['is_hyperv_cluster'] === true )
                {
                    $systems[$systemID]['windowsClients'][$clientID] = $clientInfo;
                    //$isClientRelevant = true;
                }
                else
                {
                    foreach ($clientInfo['applications'] as $applicationID => $applicationInfo)
                    {
                        if ( $applicationInfo['type'] === Constants::APPLICATION_TYPE_NAME_VMWARE )
                        {
                            $systems[$systemID]['VMwareClients'][$clientID] = $clientInfo;
                            //$isClientRelevant = true;
                            break;
                        }
                    }
                }
                */


                /*if ( $isClientRelevant == true )
                {
                    $systems[$systemID]['clients'][] = $clientID;
                }*/
            }
        }
        return($systems);

    }

    //Double check this logic with multi tiers of recursion.
    private function recursiveResourcePoolAndVAppAssignment($parents, $children)
    {
        $newChildren = array();
        if ( count($children) > 0 )
        {
            foreach ( $children as $childKey => $child )
            {
                if ( array_key_exists($child['parentKey'], $parents) )
                {
                    $parents[$child['parentKey']]['resourcePoolOrVApp'][$childKey] = $child;
                    unset($parents[$child['parentKey']]['resourcePoolOrVApp'][$childKey]['parentKey']);
                }
                else
                {
                    $newChildren[$childKey] = $child;
                }
            }
            if ( count($newChildren) > 0 )
            {
                foreach ( $parents as $parentKey => $parent )
                {
                    if ( count($parent['resourcePoolOrVApp']) > 0 )
                    {
                        $returnedArray = $this->recursiveResourcePoolAndVAppAssignment( $parent['resourcePoolOrVApp'], $newChildren );
                        $parents[$parentKey]['resourcePoolOrVApp'] = $returnedArray['parents'];
                        $newChildren = $returnedArray['children'];
                    }
                    /*else
                    {
                        unset($parents[$parentKey]['resourcePoolOrVApp']);
                    }*/
                }
            }
            else
            {
                foreach ( $parents as $parentKey => $parent )
                {
                    foreach ( $parent['resourcePoolOrVApp'] as $childKey => $child )
                    {
                        $parents[$parentKey]['resourcePoolOrVApp'][$childKey]['nodes'] = array_values(array_merge($parents[$parentKey]['resourcePoolOrVApp'][$childKey]['resourcePoolOrVApp'], $parents[$parentKey]['resourcePoolOrVApp'][$childKey]['nodes']));
                        unset($parents[$parentKey]['resourcePoolOrVApp'][$childKey]['resourcePoolOrVApp']);
                    }
                }
            }
        }
        foreach ( $parents as $parentKey => $parent )
        {
            $parents[$parentKey]['nodes'] = array_values(array_merge($parents[$parentKey]['resourcePoolOrVApp'], $parents[$parentKey]['nodes']));
            unset($parents[$parentKey]['resourcePoolOrVApp']);
        }

        return( array('parents' => $parents, 'children' => $newChildren) );
    }

    private function getInventoryInstance( $sid ){
        $instances = $_GET['instances'];
        $instancesArray = explode(",", $instances);
        foreach($instancesArray as $key => $instance){
            $Instanceinfo = $this->BP->get_appinst_info($instance,$sid);
            foreach($Instanceinfo as &$val){
                if($val['app_type'] === "VMware") {
                    $val['client_name'] = $val['primary_name'];
                    $val['vm_name'] = $val['secondary_name'];
                    unset($val['primary_name']);
                    unset($val['secondary_name']);
                }
                elseif($val['app_type'] === "Hyper-V"){
                    $val['vm_name'] = $val['primary_name'];
                    unset($val['primary_name']);
                    unset($val['secondary_name']);
                }
            }
          $info['instances'][] = $Instanceinfo;

        }
        return $info;
    }

    // Get disk exclusion status
    private function getDiskInfo ( $sid ) {
        $appid = $_GET['appid'];

        $instanceInfo = $this->BP->get_appinst_info($appid, $sid);
        if ( $instanceInfo['app_type'] == Constants::APPLICATION_TYPE_NAME_XEN ) {
            $result = $this->BP->get_xen_vm_disks($appid, $sid);
        } else {
            $result = $this->BP->get_vm_disks($appid, $sid);
        }

        $returnArray = array();
        foreach( $result as $diskinfo ) {
            $returnArray['instance_id'] = $result['instance_id'];
            $returnArray['name'] = $result['name'];
            $returnArray['is_excluded'] = $result['is_excluded'];
        }
        return $returnArray;
    }

    // Set disks to be excluded
    //XenServer may need to be added to this, but no one is currently consuming this
    private function setDiskInfo ( $sid ) {
        $appid = $_GET['appid'];
        $key = $_GET['key'];
        $setDiskResult = $this->BP->set_vm_disks( $appid, $key, $sid );
        return $setDiskResult;
    }


    // Sorts the Array alphabetically
    private function sort($Array) {
        $Info = $Array;
        $orderByName = array();
        foreach ($Info as $key => $row) {
            $orderByName[$key] = strtolower($row['name']);
        }
        array_multisort($orderByName, SORT_STRING, $Info);
        return $Info;
    }

}

?>