<?php
// defines BP, xml, action, cookie
require '../header.php';

$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();

switch ($action) {				
		
	case "list":	// Get list of configurable archive media
			$result = $BP->get_configurable_archive_media($dpuID);
			if ($result !== false) {
				$xml->push('root');
				foreach ($result as $media) {
					displayConfigurableMedia($xml, $media);
				}
				$xml->pop(); // root
			} else {
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;
			
	case "load":	// Get configurable media details
			$deviceName = isset($_GET['name']) ? $_GET['name'] : "unknown";
			$result = $BP->get_archive_media_settings($deviceName, $dpuID);
			if ($result !== false) {
				$xml->push('root');
				foreach ($result as $setting) {
					displayMediaSetting($xml, $setting);
				}
				$xml->pop(); // root
			} else {
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;
			
	case "save":	// Save configurable media setting
			$deviceName = isset($_GET['name']) ? $_GET['name'] : "unknown";
			
			$dataType = $_GET['setting_type'];
			if (isset($_GET['field']) && isset($_GET['value'])) {
				$key = $_GET['field'];
				$value = $_GET['value'];
				
				if($value === '(none)') {
					$value = "";
				}
				/*
				switch($dataType) {
				  case "string":
				  case "command":
					  break;
				  case "boolean":
					  $value = (bool)$value;
					  break;
				  case "integer":
					  $value = (int)$value;
					  break;
				}
				*/
				$settings = array($key => $value);
				$BP->buildResult($xml, $BP->save_archive_media_settings($deviceName, $settings, $dpuID));
			} else {
				$BP->buildResult($xml, false, 'must specify field and value to change an archive setting.');
			}
			echo($xml->getXml());
			break;
}

//
// Builds the XML that corresponds to the configurable media return.
//
function displayConfigurableMedia($xml, $media) {
	
	$xml->push('Media');
	if (isset($media['name'])) {
		$xml->element('Name', $media['name']);
	}
	if (isset($media['vendor'])) {
		$xml->element("Vendor", $media['vendor']);
	}
	if (isset($media['model'])) {
		$xml->element("Model", $media['model']);
	}
	if (isset($media['serial'])) {
		$xml->element("Serial", $media['serial']);
	}
	if (isset($media['type'])) {
		$xml->element("Type", $media['type']);
	}
	if (isset($media['is_available'])) {
		$xml->element("Available", $media['is_available'] ? "1" : "0");
	}
	$xml->pop();	// Media
}

//
// Builds the XML that corresponds to the media settings.
//
function displayMediaSetting($xml, $setting) {
	$xml->push('Setting');
	if (isset($setting['name'])) {
		$xml->element('Name', $setting['name']);
	}
	if (isset($setting['type'])) {
		$xml->element("Type", $setting['type']);
	}
	if (isset($setting['value'])) {
		if($setting['name'] == "parent_changer" && $setting['value'] == "") {
			$value = '(none)';
		}else {
			$value = $setting['value'];
		}
		$xml->element("Value", $value);
	}
	if (isset($setting['description'])) {
		$xml->element("Description", $setting['description']);
	}
	$xml->pop();	// Setting
}

$BP->destroyCookie();
?>
