<?php
// defines BP, xml, action, cookie
require 'header.php';

// defines functions for URL parsing.
require('urloptions.php');

// defines functions for backup status processing.
require('basebackupstatus.php');

$localID = $BP->get_local_system_id();
$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $localID;

// figure out which sysID to used based on view.
$sysID = $grandClientView ? $localID : $dpuID;

switch ($action) {
	case "failure":
	case "backup":
	case "restore":
	case "vrestore":
	case "sql":
	case "sync":
			$cid = isset($_GET['cid']) ? (int)$_GET['cid'] : -1;

			// Default is to retrieve all backup types.
			$backupTypes = $GLOBAL_BACKUP_REPORT_TYPES;
			
			$result_format = array();
			
			if ($action == 'sync') {
				$attributes = getTimeArguments(true);
			} else {
				$attributes = getTimeArguments();
			}
					
			//   Override the default backup types for SQL and securesync reports.
			if ($action == 'sql') {
				$backupTypes = $GLOBAL_SQL_TYPES;
			} else if ($action == 'sync') {
				$backupTypes = $GLOBAL_SS_TYPES;
			} else if ($action == 'restore') {
				$backupTypes = array("restore");
			} else if ($action == 'vrestore') {
				$backupTypes = array("virtual restore");
			}
			
			$result_format = array_merge($result_format, $attributes, array('type' => $backupTypes));
			if ($action == "sync") {
				$result_format = array_merge($result_format, array('sync_msg' => 1));
			}
						
			// Loop through all systems.  Will be only one in the list for a DPU, multiple systems on a Vault.
			$systems = $BP->get_system_list();	
			$originalFormat = $result_format;
			$localID = $BP->get_local_system_id();
			$bVault = $BP->local_system_is_vault();
			
			if ($systems === false) {
				$BP->buildResult($xml, false);
				echo($xml->getXml());
				break;
			}
			
			$bManager = $BP->local_system_is_mgr();
			$bMDPU = isset($_GET['mdpu']) ? true : false;
			
			$targetDpuID = NULL;
			if ($bVault) {
				$targetDpuID = getCrossVaultDpuID($BP, $systems[$localID], $systems);
			}
			
			//$bError = false;
			// If an error occurs, skip this DPU and continue.
			$xml->push('BackupInformation');
			foreach ($systems as $systemID => $systemName) {
				if ($systemID == $dpuID || $dpuID == $localID) {				
					// If this system is a vault and we are looking at this system, skip it and go to the next.
					if ($bVault && ($systemID == $localID)) {
						;
					// If this system is a manager and we are not running on the MDPU node nor are
					// not looking at the selected system, skip it.
					} else if (!$bVault && $bManager && !$bMDPU && ($systemID != $dpuID)) {
						;
					} else {
						// Build the client and device lists once per system.						
						$deviceList = $grandClientView ? $BP->get_device_list($localID) : $BP->get_device_list($systemID);
						// for restore report and the target.dpu system call get_client_list to get the system client
						if ($targetDpuID==$systemID && $action == 'restore') {
							$clientList = $BP->get_client_list($systemID);
						}
						else {
							$clientList = $grandClientView ? $BP->get_grandclient_list($systemID) : $BP->get_client_list($systemID);
						}

						$result_format = array_merge($originalFormat, array('system_id' => $systemID));
						if ($cid != -1) {
							$result_format = array_merge($result_format, array('client_id' => $cid));
						}
						
						// If grand client view, get grand client backups from the local system.
						if ($grandClientView) {
							$systemID = $localID;
							$result_format['system_id'] = $systemID;
							$backupStatusArray = array();
							foreach ($clientList as $client_id => $client_name) {
								// if cid is specified, only find backup status for that particular client
								if ($cid != -1 && $client_id !== $cid) {
									continue;
								}
								$result_format['client_id'] = $client_id;
								$backups = $BP->get_backup_status($result_format);
								$backupStatusArray = array_merge($backupStatusArray, $backups);
							}
						} else {
							if ($cid == -1 && $action != 'vrestore') {
								$result_format['grandclients'] = false;
							}
							$backupStatusArray = $BP->get_backup_status($result_format);
						}
						
						if ($backupStatusArray !== false) {
							if (count($backupStatusArray) > 0) {
								$backupIDs = array();
								$i = 0;
								foreach ($backupStatusArray as &$backupStatus) {
									if ($action == 'failure') {
										// Only gather failed backups.
										if ($backupStatus['status'] == STATUS_FAILURE) {
											$backupIDs[$i++] = $backupStatus['id'];
										}
									} else if ($action == 'sync') {
										// Not all syncs will have backup ID's.  Only process those that do.
										if (isset($backupStatus['id'])) {
											$backupIDs[$i++] = $backupStatus['id'];
										}
									} else {
										$backupIDs[$i++] = $backupStatus['id'];
									}
								}
								if ($bVault && $action == "sync") {
									$backupArray = array();
								} else {
									$result_format = array('system_id' => $systemID, 'backup_ids' => $backupIDs);
									// Only call the info API if we have backup IDs to process.
									if (count($backupIDs) > 0) {
										$backupArray = $BP->get_backup_info($result_format);
									} else {
										$backupArray = array();
									}
								}
							} else {
								$backupArray = array();
							}
							
							if ($backupArray !== false) {
								// Merge the two results (backup status and info) into one array and output as XML.	
								$result = array();
								foreach ($backupStatusArray as &$backup) {
									// If not a vault merge the status and info API results.
									// If a vault and NOT the vaulting report, merge the status and info API results.
									// If a vault and we are running the vaulting report, only use the bp_backup_status results.
									if ((!$bVault || ($bVault && $action != 'sync')) && isset($backup['id'])) {
										foreach ($backupArray as &$backupInfo) {
											if ($backupInfo['id'] == $backup['id']) {
												$result = &$backupInfo;
													
												$attributes = array(	'type', 'complete', 'id', 'client_id',
																		'start_time', 'elapsed_time',
																		'status', 'size', 'sync_size', 'files', 'encrypted',
																		'database_name', 'server_instance_name',
																		'oracle_sid', 'sharepoint_guid',
																		'instance_id', 'app_name', 'vm_name', 'vmware_template', 'support_vss_diff',
																		'sync_status', 'verify_status', 'sync_message',
																		'synthesized', 'disk_metadata', 'client_config', 'is_cluster', 'guid',
																		'restored_bkup_type', 'replicated', STATUS_CERTIFY_API_KEY);
												
												foreach ($attributes as $attribute) {
													if (isset($backup[$attribute])) {
														$result[$attribute] = &$backup[$attribute];
													}
												}
												createBackupExpandedStatusXML($xml, $result, $deviceList, $clientList,
																			  $systemID, $systemName);
												break;
											}
										}
									} else {
										createBackupExpandedStatusXML($xml, $backup, $deviceList, $clientList,
																	  $systemID, $systemName);
									}
								}
							} else {
								createDPUErrorXML($xml, $BP, $systemName);
							}
						} else {
							createDPUErrorXML($xml, $BP, $systemName);
						}
					}
				}
			}
			//if (!$bError) {
				$xml->pop(); // BackupInformation
			//}
			echo($xml->getXml());
			break;	

	case "device":
			$cid = isset($_GET['cid']) ? (int)$_GET['cid'] : -1;			
			// Don't need to specify type, as we will specify device, then backup ID's and time window.
			$result_format = getTimeArguments();	
			// Loop through all systems.  Will be only one in the list for a DPU, multiple systems on a Vault.
			$systems = $BP->get_system_list();
		
			$originalFormat = $result_format;
			$bVault = $BP->local_system_is_vault();
			$localID = $BP->get_local_system_id();
			
			$bManager = $BP->local_system_is_mgr();
			$bMDPU = isset($_GET['mdpu']) ? true : false;
				
			if ($systems === false) {
				$BP->buildResult($xml, false);
				echo($xml->getXml());
				break;
			}
			
			//$bError = false;
			// If an error occurs, skip this DPU and continue.
			$xml->push('BackupInformation');
			foreach ($systems as $systemID => $systemName) {
				if ($systemID == $dpuID || $dpuID == $localID) {
					// If this system is a vault and we are looking at this system, skip it and go to the next.
					if ($bVault && $systemID == $localID) {
						;
					// If this system is a manager and we are not running on the MDPU node nor are
					// not looking at the selected system, skip it.
					} else if (!$bVault && $bManager && !$bMDPU && ($systemID != $dpuID)) {
						;
					} else {							
						// Build the client and device lists once per system.
						$deviceList = $BP->get_device_list($systemID);
						$clientList = $grandClientView ? $BP->get_grandclient_list($systemID) : $BP->get_client_list($systemID);						
						$devicesForBackup = array();
						$i = 0;
						if ($deviceList !== false) {
							foreach ($deviceList as $id => $name) {
								$devicesForBackup[$i++] = $id;
							}
						}			
						$backupDeviceArray = $BP->get_backup_device_info($devicesForBackup, $systemID);
						if ($backupDeviceArray !== false) {
							if (count($backupDeviceArray) > 0) {
								$backupIDs = array();
								$i = 0;
								foreach ($backupDeviceArray as $backup) {
									$backupIDs[$i++] = $backup['backup_id'];
								}
								$result_format = array_merge($originalFormat, array('system_id' => $systemID,
																					'backup_ids' => $backupIDs));
								if ($cid != -1) {
									$result_format = array_merge($result_format, array('client_id' => $cid));
								}						
								$backupInfoArray = $BP->get_backup_info($result_format);
							} else {
								$backupInfoArray = array();
							}
							
							if ($backupInfoArray === false) {
								global $Log;
								$message = " Could not get backup information to report last backup for this device.";
								$message = $BP->getError() . ":" . $message;
								$Log->writeError($message, true);
							}
							$nInfoItems = count($backupInfoArray);
		
							$backupStatusArray = $BP->get_backup_status($result_format);												
							if ($backupStatusArray !== false) {
								// Merge the results (backup status, device, info (last)) into one array and output as XML.							
								$result = array();			
								foreach ($backupDeviceArray as $backupDevice) {
									foreach ($backupStatusArray as $backup) {
										if ($backupDevice['backup_id'] == $backup['id']) {
											$result = &$backupDevice;
											$attributes = array(	'type', 'complete', 'id', 'client_id', 'start_time',
																	'elapsed_time', 'status', 'sync_size', 'files', 'encrypted',
																	'database_name', 'server_instance_name',
																	'oracle_sid', 'sharepoint_guid',
																	'sync_status', 'verify_status', 'replicated');
											foreach ($attributes as $attribute) {
												if (array_key_exists($attribute, $backup)) {
													$result[$attribute] = $backup[$attribute];
												}
											}											
											$bFound = false;
											for ($n = 0; $n < $nInfoItems && !$bFound; $n++) {
												if ($backupInfoArray[$n]['id'] == $backup['id']) {
													$bFound = true;
													$result['last'] = $backupInfoArray[$n]['last'];
												}
											}										
											createBackupExpandedStatusXML($xml, $result, $deviceList, $clientList,
																		 $systemID, $systemName);
											break;
										}
									}
								}
							} else {
								//$xml->clear(false);
								//$bError = true;
								//$BP->buildResult($xml, false);
								createDPUErrorXML($xml, $BP, $systemName);
								break;
							}
						} else {
							//$xml->clear(false);
							//$bError = true;
							//$BP->buildResult($xml, false);
							createDPUErrorXML($xml, $BP, $systemName);
							break;
						}
					}
				}
			}	
			//if (!$bError) {
				$xml->pop(); // BackupInformation
			//}
			echo($xml->getXml());
			break;	
						
	case "info":
			$result_format = array();
			$attributes = getTimeArguments();		

			$backupIDs = array();
			if (isset($_REQUEST['bid'])) {
				$backupList = $_REQUEST['bid'];
				$backupIDs = explode(',', $backupList);
				for ($i = 0; $i < count($backupIDs); $i++) {
					$backupIDs[$i] = (int)$backupIDs[$i];
					$i++;
				}
			}	
			if (count($backupIDs) > 0) {				
				$attributes = array_merge($attributes, array('backup_ids' => $backupIDs));
			}
		
			$systemID = $sysID;
			$attributes = array_merge($attributes, array('system_id' => $systemID));
			$result_format = array_merge($result_format, $attributes);
		
			$backupArray = $BP->get_backup_info($result_format);
			if ($backupArray === false || count($backupArray) == 0) {
				// Since we are not erroring out totally, log in the error log.
				// We either returned an error in backup status, or no status entries returned.
				// The CMC will pick up on the empty Backup Status XML and warn the user.
				global $Log;
				$message = " Could not get backup information for these backup ID's ";
				foreach ($backupIDs as $backupID) {
					$message .= $backupID . ", ";
				}
				$message .= "\n";
				$message = $BP->getError() . ":" . $message;
				$Log->writeError($message, true);
			} else {	
				$xml->push('BackupInformation');
				$dpuName = getSystemName($BP, $dpuID);
				
				//
				// Build the device list for this system.
				//
				$deviceList = $BP->get_device_list($sysID);
				
				$result_format = array(	'system_id' => $systemID,
										'backup_ids' => $backupIDs);

				foreach ($backupArray as $backupInfo) {
					createBackupInfoXML($xml, $backupInfo, $deviceList, $dpuID, $dpuName);
				}
				
				$xml->pop(); // BackupInformation
			}
			echo($xml->getXml());
			break;
}


//
// Creates the XML for the backup status node used in multiple php files.  The caller
// specifies the tag name to be used (so that the same routine can generate SDS statuses.
//
function createBackupInfoXML($xml, &$backup, &$deviceList, $dpuID, $dpuName)
{
	$xml->push("Backup");
	$xml->element("System", $dpuName);
	
	if (array_key_exists('id', $backup)) {
		$xml->element("ID", $backup['id']);
	}
		
	if (array_key_exists('device_id', $backup)) {
		$attributes = array('ID' => $backup['device_id']);
		if ($deviceList !== false) {
			$attributes = array_merge($attributes, array('Name' => deviceNameOf($backup['device_id'], $deviceList)));
		}
		$xml->emptyelement('Device', $attributes);
	}
	
	if (array_key_exists('command', $backup)) {
		$xml->element('Command', $backup['command']);
	}
	
	if (array_key_exists('output', $backup)) {
		$xml->push("Output");
		$xml->cData($backup['output']);	
		$xml->pop(); // Output
	}
	
	if (array_key_exists('comment', $backup)) {
		$xml->element('Comment', $backup['comment']);
	}

	if (array_key_exists('purgeable', $backup)) {
		$xml->element('Purgeable', $backup['purgeable'] == true ? "1" : "0");
	}
	
	if (array_key_exists('last', $backup)) {
		$xml->element('Last', $backup['last'] == true ? "1" : "0");
	}
	
	// If an MSSQL Type, get group number and order.
	if (array_key_exists('group_number', $backup)) {
		$xml->element('GroupNumber', $backup['group_number']);
	}
	if (array_key_exists('group_order', $backup)) {
		$xml->element('GroupOrder', $backup['group_order']);
	}
	
	// If VMware Template
	if (array_key_exists( 'vmware_template', $backup )) {
		$xml->element('Template', ( $backup['vmware_template'] == true ) ? 1 : 0 );
	}
	
	// VSS Support
	if (array_key_exists( 'support_vss_diff', $backup )) {
		$xml->element('VSSDiff', ( $backup['support_vss_diff'] == true ) ? 1 : 0 );
	}
			
	$xml->pop(); // BackupInfo
}


//
// This function displays an error message for the row if the DPU is not accessible. 
function createDPUErrorXML($xml, $BP, $dpuName)
{

	global $Log;
	$message = " Could not get backup information for dpu: " . $dpuName;
	$message = $BP->getError() . ":" . $message;
	$Log->writeError($message, true);
							
	$xml->push("Backup", array('Type' => '', "Identification" => '', "DPUName" => $dpuName, "ClientName" => '{system offline}'));
	$xml->element('Date', '');
	$xml->element('Time', '');
	$xml->pop(); // Backup
}

$BP->destroyCookie();
?>
