<?php
// defines BP, xml, action, cookie
//require 'header.php';

//
// this code is designed to be called from a "driver" browse function (clients, archive).
//
// $target,$filesAPI, $MAX_ITEMS must be defined by the caller.
//

// If replicated/grand client view, we are browsing replicated backups on the local system.  Otherwise, check for the sid.
$dpuID = (isset($_GET['sid']) && !$grandClientView) ? (int)$_GET['sid'] : $BP->get_local_system_id();

// API parameters
$id = (int)$_GET['id'];
$startDir = isset($_REQUEST['dir']) ? $_REQUEST['dir'] : "";	// if  not specified, start at top.

switch ($action) {				
	case "initial":	// return the start list, usually of volumes unless startDir is not blank.
	case "list":	// return the list of all files in the target (id), directory (dir & fid) specified
	case "levels":	// at $levels levels.
		if ($target == 'synthesis') {
			$synthesisGroup = $_GET['fid'];
			$fileList = $BP->$filesAPI($synthesisGroup, $id, $startDir, "", 0, $dpuID);
		} else {
			$fid = ($target == 'backup') ? "" : NULL;
			$fileList = $BP->$filesAPI($id, $startDir, $fid, "", 0, $dpuID);
		}
		if ($fileList === false) {
			$BP->buildResult($xml, false);
		} else {
			$xml->push('root');
			if (isset($_GET['levels'])) {
				// get multiple levels of files/dirs.
				$levels = $_GET['levels'];
				$displayAPI($xml, $BP, $fileList, $dpuID, $id, $levels);
			} else {
				$displayAPI($xml, $BP, $fileList, $dpuID, $id, 0, $ShowBranch);
			}
			$xml->pop();
		}
		echo($xml->getXml());
		break;
			
	case "branch":	// return the list of all files in the target (id), directory (dir & fid) specified
	case "more":	// start at last name = last and get files in the specified directory
		$lastFile = isset($_GET['last']) ? $_GET['last'] : "";
		if ($target == 'synthesis') {
			$synthesisGroup = $_GET['fid'];
			$fileList = $BP->$filesAPI($synthesisGroup, $id, $startDir, $lastFile, MAX_ITEMS, $dpuID);
		} else {
			$fid = $_GET['fid'];
			$fileList = $BP->$filesAPI($id, $startDir, $fid, $lastFile, MAX_ITEMS, $dpuID);
		}
		if ($fileList === false) {
			$BP->buildResult($xml, false);
		} else {
			$xml->push('root');
			$displayAPI($xml, $BP, $fileList, $dpuID, $id, 0, $ShowBranch);
			$xml->pop();
		}
		echo($xml->getXml());
		break;
		
	case "group":	// get the list of id's for the synthesized view.
		$idGroup = $BP->get_synthesis_group($id, $dpuID);
		if ($idGroup !== false) {
			$xml->push('root');
			$xml->element('Group', $idGroup);
			$xml->pop();
		} else {
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());
		break;		
}
?>