<?php

// Parse command line arguments.  Arguments are passed to the buildtree utility in the
// following form:  buildtree.php?arguments=argname1:value1,argname2:value2, etc.
require('urloptions.php');
// defines BP, xml, action, cookie, grandClientView
require 'header.php';

$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
$bCache = (isset($_GET['cache']) and ($_GET['cache'] === '1') )? true : false;
$grandClientView = isset($_GET['gcv']) && ($_GET['gcv'] === '1') ? true : false;

// Get xml cache file - path in master.ini  -   /var/www/html/recoveryconsole/cache/UI-buildtree.xml
$statusCachePath = $BP->get_ini_value('CMC', 'StatusCacheFile', $dpuID);
$masterUseCache = $BP->get_ini_value('CMC', 'LoginCache', $dpuID);

// create temporary cache file
$tmpcache = $statusCachePath . ".new";

$useCache = true;
if (file_exists($statusCachePath)) {
    if ($bCache === false) {
        $useCache = false;
    }

    // check if using replication view - use cache if user has explicitly click to reload
    if ($grandClientView === true && $bCache === false) {
        $useCache = false;
    }

    // check master.ini cache setting
    if ($masterUseCache === "false") {
        $useCache = false;
    }

    // check file size, if zero do not use cache
    if (filesize($statusCachePath) < 300) {
        $useCache = false;
    }
} else {
    $useCache = false;
}

$cDays = isset($_GET['days']) ? (int)$_GET['days'] : 0;
$cLvl = isset($_GET['level']) ? $_GET['level'] : " ";
$cBs = isset($_GET['bs']) ? $_GET['bs'] : " ";;

if (($cLvl !== "DPU" || $cLvl !== "DPV") && $cBs !==  " ") {
    $useCache = false;
}

if ($useCache === true) {
    // Used cached xml file
    echo(file_get_contents($statusCachePath));
} else {
    $options = new Options();
    if (isset($_GET['arguments'])) {
        $options->parseCommandLine($_GET['arguments']);
    }
    if (isset($_GET['level'])) {
        $options->setlevel($_GET['level']);
    }
    if (isset($_GET['days'])) {
        $options->setDays($_GET['days']);
    }
    if (isset($_GET['start'])) {
        $options->setStartTime($_GET['start']);
    }
    if (isset($_GET['end'])) {
        $options->setEndTime($_GET['end']);
    }
    if (isset($_GET['networkID'])) {
        $options->setNetworkID($_GET['networkID']);
    }
    if (isset($_GET['auth'])) {
        $options->setAuthenticationString($_GET['auth']);
    }
    if (isset($_GET['bs'])) {
        $options->setStatusType($_GET['bs']);
    }

    $srcID = isset($_GET['src']) ? (int)$_GET['src'] : -1;
    $vuser = isset($_GET['vuser']) ? $_GET['vuser'] : "";
    $options->setView($grandClientView, $srcID, $vuser);

    $level = $options->getLevel();
    // if no level specified, detect it.
    if ($level == "") {
        if ($BP->LocalSystemIsVault()) {
            $options->setLevel("dpv");
        } else if ($BP->local_system_is_mgr()) {
            $options->setLevel("mdpu");
        } else {
            $options->setLevel("dpu");
        }
    }

    require('createxml.php');
    $xmlTree = buildXML($xml, $BP, $options);
    file_put_contents($tmpcache, $xmlTree);
    rename($tmpcache, $statusCachePath);
    printf($xmlTree);
}
$BP->destroyCookie();
?>
