<?php
// defines BP, xml, action, cookie
require 'header.php';

// general backup list operations.
require 'listsbase.php';
$ListBase = new ListBase();

// Initialize variables to be used in copy and save.
$calendarInfo = array();
$bValid = true;
$bCopy = false;

switch ($action) {

	case "list":
			$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
			$ListBase->buildCalendarList($BP, $xml, $dpuID);
			echo($xml->getXml());
			break;
					
	case "load":
			$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();						
			if (($id = $ListBase->getID($BP, 'get_calendar_list', $dpuID)) == -1) {
				$BP->buildResult($xml, false, "Error: cannot find calendar for loading.");
			} else {
				$iCalendarContent = $BP->get_calendar($id, $dpuID);
				if ($iCalendarContent === false) {
					$BP->buildResult($xml, false);
				} else {
					$xml->push("root");
					$xml->push("Calendar", array("ID" => $id));
					$xml->cData($iCalendarContent);
					$xml->pop(); // Calendar	
					$xml->pop(); // root
				}
			}
			echo($xml->getXml());
			break;
			
	case "copy":
			$bValid = false;
			$bCopy = true;
			$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
			$originalID = (int)$_GET['oid'];	
			$calendarList = $BP->get_calendar_list($dpuID);			
			if ($calendarList === false) {
				$BP->buildResult($xml, false);
			} else {
				foreach ($calendarList as $calendar) {
					if ($calendar['id'] == $originalID) {
						$calendarInfo = $calendar;						
						$iCalendarContent = $BP->get_calendar($originalID, $dpuID);
						if ($iCalendarContent === false) {
							$BP->buildResult($xml, false);
						} else {
							$calendarInfo['contents'] = $iCalendarContent;
							$bValid = true;
						}
						break;
					}
				}
			}		
			// Fall through to save the constructed calendar copy.		
					
	case "save":
			if ($bValid) {
				$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
				$id = $ListBase->getID($BP, 'get_calendar_list', $dpuID);
				if ($id == -1) {
					if (isset($_GET['name'])) {
						$calendarInfo = array_merge($calendarInfo, array("name" => $_GET['name']));
					} else {
						$BP->buildResult($xml, false, "Error: must specify either name or id of calendar to save.");
						$bValid = false;
					}
				} else {
					$calendarInfo = array("id" => $id);
					if (isset($_GET['name'])) {
						$calendarInfo = array_merge($calendarInfo, array("name" => $_GET['name']));
					}
				}
			}
			if ($bValid) {
				if ($bCopy) {
					unset($calendarInfo['id']);
					$calendarInfo['read_only'] = false;
				} else {											
					$options = array ('description' => 'desc',
									  'type' => 'stype',
									  'family' => 'family');
					$bOptions = array('read_only' => 'ro');		
					$calendarInfo = buildOptions($calendarInfo, $options, $bOptions);
				
					if (isset($_REQUEST['contents'])) {
						$calendarInfo['contents'] = $_REQUEST['contents'];
					}
				}
				$ListBase->buildListResult($xml, $BP->save_calendar($calendarInfo, $dpuID));
			}
			echo($xml->getXml());			
			break;
				
	case "delete":
			$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
			if (($id = $ListBase->getID($BP, 'get_calendar_list', $dpuID)) == -1) {
				$BP->buildResult($xml, false, "Error: cannot find calendar identifier for deletion.");
			} else {
				$BP->buildResult($xml, $BP->delete_calendar($id, $dpuID));
			}
			echo($xml->getXml());
			break;
}

$BP->destroyCookie();
?>