<?php
// defines BP, xml, action, cookie
require 'header.php';

// set DeviceInfoID ID to null (for update vs. add)
$deviceInfoID = NULL;
$deviceInfo = array();

// Storage functions object.
require 'functions/storagefunctions.php';
$Storage = new StorageFunctions();

$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();

switch ($action) {

	case "list":
		$devices = $BP->get_device_list($dpuID);
		if ($devices !== false) {
			$xml->push("root");
			$Storage->getDevicesDetails($BP, $xml, $devices, $dpuID);
			$xml->pop(); //root
		} else {
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());
		break;
					
	case "update":
		// if updating, specify id or map device name/system name to ID				
		if (isset($_GET['id'])) {
			$id = (int)$_GET['id'];
			$deviceInfoID = array("id" => $id);
		} else {
			$BP->buildResult($xml, false, "device update must have id specified.");
			echo($xml->getXml());
			break;
		}
		// fall through to add.
	
	case "add":	
		// Get the device definition from arguments.
		if (isset($_GET['name'])) {
			$name = $_GET['name'];
			$deviceInfo = array ("dev_name" => $name);
		}				
		if ($deviceInfoID != NULL) {
			$deviceInfo = array_merge($deviceInfoID, $deviceInfo);
		}
											
		$options = array ('dev_nr_name' => 'folder',
						  'dev_rw_name' => 'rwname',
						  'dev_cmd_name' => 'command',
						  'comment' => 'comment');
		$bOptions = array('is_online' => 'online',
						  'is_scsi' => 'scsi',
						  'use_juke' => 'juke',
						  'default' => 'default');
		$deviceInfo = buildOptions($deviceInfo, $options, $bOptions);
		$iOptions = array('maxcnt' => 'concurrent',
						  'blocksize' => 'bs',
						  'scsi_blocksize' => 'scsibs',
						  'storage_id' => 'stid');
		$deviceInfo = addIntegerOptions($deviceInfo, $iOptions);
		if (isset($_GET['capacity'])) {
			$deviceInfo['capacity'] = (float)$_GET['capacity'];
		}
		if (isset($_GET['dedup'])) {
			$deviceInfo['supports_dedup'] = $_GET['dedup'] == '1';
		}
		
		if (isset($_GET['name']) || isset($_GET['id'])) {
			if (!isset($_GET['sid']) || $dpuID == $BP->get_local_system_id()) {
				$BP->buildResult($xml, $BP->save_device_info($deviceInfo));
			} else {
				$BP->buildResult($xml, $BP->save_device_info($deviceInfo, $dpuID));
			}
			echo($xml->getXml());
		} else {
			$BP->buildResult($xml, false,
					"device add/update: improper argument format; name or id must be specified.");
			echo($xml->getXml());
		}

		break;
					
	case "delete":
		if (isset($_GET['id'])) {
			$deviceID = (int)$_GET['id'];
		} else {
			// user specified name, translate to ID.
			$deviceName = $_GET['name'];
			$deviceID = getDeviceIDFromName($BP, $deviceName, $dpuID);
		}
		if ($deviceID != -1) {
			if (!isset($_GET['sid']) || $dpuID == $BP->get_local_system_id()) {
				$BP->buildResult($xml, $BP->delete_device($deviceID));
			} else {
				$BP->buildResult($xml, $BP->delete_device($deviceID, $dpuID));
			}
		} else {
			$stringError = sprintf("device delete: could not determine id from name %s.", $deviceName);
			$BP->buildResult($xml, false, $stringError);
		}
		echo($xml->getXml());
		break;
}


function getDeviceIDFromName($BP, $deviceName, $dpuID)
{
	$deviceID = -1;
	
	if (!isset($_GET['sid']) || $dpuID == $BP->get_local_system_id()) {
		$devices = $BP->get_device_list();
	} else {
		$devices = $BP->get_device_list($dpuID);
	}
	
	foreach ($devices as $id => $name) {
		if ($deviceName == $name) {
			$deviceID = $id;
			break;
		}
	}
	return $deviceID;
}
$BP->destroyCookie();
?>
