<?php
// defines BP, xml, action, cookie
require 'header.php';

// VCenter-RRC is a special client.
define("VCENTER_RRC", "vCenter-RRC");

// general library functions
require 'library.php';
$lib = new Library();

$localID = $BP->get_local_system_id();
$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $localID;

// figure out which sysID to used based on view.
$sysID = $grandClientView ? $localID : $dpuID;

switch ($action) {

	case "start":	// start disk image creation.
	case "create":
			$backupIDs = isset($_GET['ids']) ? $_GET['ids'] : "";
			$BP->buildResult($xml, $BP->create_disk_image($backupIDs, $sysID));
			echo($xml->getXml());			
			break;
			
	case "status":	// get disk image creation status.
			$imageStatus = $BP->get_disk_image_status($sysID);
			$image_statuses = array();
			
			if ($imageStatus !== false) {
				$xml->push('Images');	
				foreach ($imageStatus as $image_statuses) {	
					$xml->push('Image');
					$instanceID = 'unknown';
					if (isset($image_statuses['id'])) {
						$instanceID = $image_statuses['id'];
						$xml->element('ID', $instanceID);
						$AppNameArray = $BP->get_application_clients($image_statuses['id'], $sysID);
						
						$sClient = "unknown";
						if ($AppNameArray !== false) {
							$xml->element('AppName', $AppNameArray['app_name']);
							$clientsArray = $AppNameArray['clients'];
							$sClient = array_pop($clientsArray);
						}
						
						$appInstName = $BP->get_appinst_name($image_statuses['id'], $sysID);
						//need to check for existence of "|" if so take it apart						
						$pipechar = "|";
						if (strlen(strstr($appInstName, $pipechar)) > 0) {
							 $a = explode($pipechar, $appInstName);
							 $vm = "unknown";
							 if ($sClient == VCENTER_RRC) {
								 // VMware instance format:  <ESX or VCenter name> | <VM name>
								 // Replace client with Host name.
								 $sClient = $a[0];
								 $vm = $a[1];
							 } else {
								 // Hyper-V uses: <VM name> | <GUID>
								 $vm = $a[0];
							 }
							$xml->element('VM', $vm);
						}
						$xml->element('ClientName', $sClient);
					}
					if (isset($image_statuses['status'])) {
						$xml->element('Status', $image_statuses['status']);
					}
					if (isset($image_statuses['available_since'])) {
						$xml->element('AvailableSince', $image_statuses['available_since']);
					}
					if (isset($image_statuses['available_targets'])) {
						$xml->element('Targets', $image_statuses['available_targets']);
						$hostName = $BP->get_hostname($sysID);
						if ($hostName != false && isset($hostName['name'])) {
							$hostInfo = $BP->get_host_info($hostName['name'], $sysID);
							if ($hostInfo != false) {
								if (isset($hostInfo['ip'])) {
									$xml->element('IP', $hostInfo['ip']);
									// construct path using host IP and instance ID.
									$path = "\\\\" . $hostInfo['ip'] . "\\flr" . $instanceID;
									$xml->element('Path', $path);
								}
							}
						}
					}
					if (isset($image_statuses['message'])) {
						$xml->element('Message', $image_statuses['message']);
					}
					if (isset($image_statuses['percentage'])) {
						$xml->element('Percentage', $image_statuses['Percentage']);
					}
					if (isset($image_statuses['time'])) {
						$xml->element('Time', $image_statuses['Time']);
					}
				$xml->pop(); // Image
				}
			$xml->pop(); // Images
			} else {
				$BP->buildResult($xml, false);
			}				
			echo($xml->getXml());			
			break;
			
	case "stop":	// Destroy disk image.
	case "destroy":
			$instanceID = (int)$_GET['ins_id'];
			$BP->buildResult($xml, $BP->destroy_disk_image($instanceID, $sysID));
			echo($xml->getXml());			
			break;
			
	case "cancel":	// Cancel disk image creation
			$BP->buildResult($xml, $BP->cancel_disk_image($sysID));
			echo($xml->getXml());			
			break;
			
	case "createApp": // Create application share
			$backupIDs = isset($_GET['ids']) ? $_GET['ids'] : "";
			$pathName = isset($_GET['path']) ? $_GET['path'] : " ";
			$jobID = $BP->create_application_share($backupIDs, $pathName, $sysID);
			if ($jobID !== false) {
				$xml->push('root');
				$xml->emptyElement("Job", array("ID" => $jobID));
				$xml->pop();
			} else {
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;	
			
	case "appStatus": // Status of application shares
			$imageStatus = $BP->get_application_share_status($sysID);	
			if ($imageStatus !== false) {
				$instances = array();
				$xml->push('AppImages');
				foreach ($imageStatus as $image_statuses) {
					$xml->push('AppImage');
					$instanceID = 'unknown';
					$name = "";
					if (isset($image_statuses['appinst_id'])) {
						$instanceID = (int)$image_statuses['appinst_id'];
						$instances[] = $instanceID;
						$name = $BP->get_appinst_name($instanceID, $sysID);
						$xml->element('ID', $instanceID);
											
						$appInfo = $BP->get_application_clients($instanceID, $sysID);
						$xml->element('AppName', $appInfo !== false ? $appInfo['app_name'] : "unknown");
					}
					
					$instanceName = isset($image_statuses['name']) ? $image_statuses['name'] : "";
					$clientName = "";
					if (isset($image_statuses['client_id'])) {
						$cid = (int)$image_statuses['client_id'];
						$clients = $grandClientView ? $BP->get_grandclient_list($dpuID) : $BP->get_client_list($sysID);
						if ($clients !== false) {
							$clientName = $clients[$cid];
						}
					}
					$xml->element('Client', $clientName);
					//$xml->element('Name', $displayName);
					$xml->element('Instance', $name);
					
					$xml->element('Info', isset($image_statuses['appinfo']) ? $image_statuses['appinfo'] : 'N/A');
						
					// build the path base, once.
					if (!isset($IPAddress)) {
						$hostName = $BP->get_hostname($sysID);
						if ($hostName != false && isset($hostName['name'])) {
							$hostInfo = $BP->get_host_info($hostName['name'], $sysID);
							if ($hostInfo != false) {
								if (isset($hostInfo['ip'])) {
									$IPAddress = $hostInfo['ip'];
								}
							}
						}
					}
					
					// output IP address and path					
					if (isset($IPAddress)) {
						$xml->element('IP', $IPAddress);
						// construct path using host IP and instance ID.
						$path = "\\\\" . $IPAddress . "\\" . $instanceName;
					} else {
						$xml->element('IP', 'unknown');
						$path = "\\\\" . 'system IP' . "\\" . $instanceName;
					}
					$xml->element('Path', $path);	
					
					if (isset($image_statuses['size'])) {
						$xml->element('Size', $image_statuses['size']);
					}
					$type = isset($image_statuses['type']) ? $image_statuses['type'] : "unknown";
					$xml->element('Type', $type);
					$xml->element('Message', $type == 'restore' ? 'Available' :
											 ($type == 'backup' ? 'In use for backup' : 'Available (' . $type . ')'));
					$xml->pop(); // AppImage
				}
				// see if any jobs passed in.
				if (isset($_GET['ids'])) {
					$ids = $_GET['ids'];
					$jobs = $lib->getIDs($ids);
					if (is_array($jobs) && count($jobs) > 0) {
						foreach ($jobs as $jobID) {
							$jobInfo = $BP->get_job_info($jobID, $sysID);
							if ($jobInfo !== false) {
								$instanceID = isset($jobInfo['instance_id']) ? (int)$jobInfo['instance_id'] : -1;
								$status = isset($jobInfo['status']) ? $jobInfo['status'] : 'N/A';
								if (!in_array($instanceID, $instances) && !strstr($status, 'SUCCESS')) {
									$xml->push('AppImage');
									$xml->element('ID', $instanceID);
									$name = $BP->get_appinst_name($instanceID, $sysID);
									$xml->element('Instance', $name !== false ? $name : $jobInfo['name']);
									//$xml->element('Name', isset($jobInfo['name']) ? $jobInfo['name'] : "unknown");
									$xml->element('Type', isset($jobInfo['type']) ? getBackupTypeString($jobInfo['type']) : "unknown");
									$xml->element('Message', 'Share Status: ' . $status);
									$xml->element('Path', '');
									$xml->pop();
								}
							}
						}
					}
				}
				$xml->pop(); // AppImages
			} else {
				$BP->buildResult($xml, false);
			}				
			echo($xml->getXml());			
			break;

				
	case "deleteApp": // Delete appplication share
			$instanceID = (int)$_GET['ins_id'];
			$BP->buildResult($xml, $BP->delete_application_share($instanceID, $sysID));
			echo($xml->getXml());
			break;
			
}

$BP->destroyCookie();
?>
