<?php
// defines BP, xml, action, cookie
require '../header.php';

//dpu restore functions
require 'dpurestorefunctions.php';

$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
$media = $_GET['media'];

global $Log;

$Log->writeVariable("in arrestore.php ");
$restoreClientListAll = xmlToClients($_REQUEST['clients']);
$bReplace = $_GET['breplacestorage'] == '1' ? true : false;

if($restoreClientListAll !== false){
	$restoreClientList = array();
	foreach($restoreClientListAll as $restoreClient){
		$clientPresent = in_array($restoreClient['client_name'], $restoreClientList);
		if(!$clientPresent) {
			$restoreClientList[] = $restoreClient['client_name'];
			if($bReplace){
				$deviceName[] = $restoreClient['device_name'];
			}
		}
	}
}

$setImported = false;
$failureCount = 0;			
$filter = array();
while (!$setImported && $failureCount < 10) {
	$archive_sets = $BP->get_archive_sets($filter, $dpuID);
	foreach ($archive_sets as $set) {
		if (strcmp($set['status'], "import success") == 0) {
			$Log->writeVariable(count($archive_sets));
			$Log->writeVariable("Actual import of the archive set ". $set['archive_set_id']. " succeeded.");
			$setImported = true;
			continue;
		} else if(strcmp($set['status'], "import failed") == 0) {
			$Log->writeVariable("Actual import of the archive set ". $set['archive_set_id']. " failed.");
			$setImported = false;
			$failureCount++;
		} else if(strcmp($set['status'], "import in progress") == 0) {
			$Log->writeVariable("Actual import in progress for set ". $set['archive_set_id']. ".");
			$setImported = false;
		} else {
			$setImported = false;
			$failureCount++;
		}
		sleep(2);
	}
	sleep(15);
}
$Log->writeVariable('done with import');


			
// temporary - lmc, pass in from RRC.
// DPU is special, used for local directory archives.  We need to make that clear.
if ($restoreClientList !== false || $restoreClientList !== NULL) {	
	$archiveMap = getClientMap($BP, $xml, $media);	
	if ($archiveMap !== false || $archiveMap !== NULL){
		$xml->push('root');
		gatherAndRestoreArchives($BP, $xml, $restoreClientList, $archiveMap);
		$xml->pop(); // root
	} else {
		$BP->buildResult($xml, false);
	}
} else {
	$BP->buildResult($xml, false);
}

echo($xml->getXml());

function getClientMap($BP, $xml, $media){
	global $Log;
	$archiveMap = array();
	$filter['target'] = $media;
	$archiveList = $BP->get_archive_status($filter);
	if ($archiveList !== false) {
		foreach($archiveList as $archive) {	
			$clientPresent = isset($archiveMap[$archive['client_name']]);
			//$clientPresent = in_array($archive['client_name'], $archiveMap);
			if($clientPresent) {
				$aList = $archiveMap[$archive['client_name']];
				$aList[] = $archive;
				$archiveMap[$archive['client_name']] = $aList;

			} else {
				
				$aList = array();
				$aList[] = $archive;
				$archiveMap[$archive['client_name']] = $aList;
			}
		}
	}
	
	return $archiveMap;
	
	
}

function gatherAndRestoreArchives($BP, $xml, $restoreClientList, $archiveMap) {
	$media = $_GET['media'];
	
	global $Log;
	$Log->writeVariable("in gather and restore");
	 foreach($restoreClientList as $client) {
	$instanceList = array();
	
	if (!isset($archiveMap[$client])) {
		$Log->writeVariable('Skip client');
		$Log->writeVariable($client);
		continue;
	}
	$archiveList = $archiveMap[$client];
	usort($archiveList, "compare_date");
	$mastIncrList = array();
	$selectiveList = array();
	$sql          = array();
	$exchange     = array();
	$vm           = array();
	$hyperv		  = array();
	$xen		  = array();
	$exchangeList = array();
	$sqlList      = array();
	$hypervList   = array();
	$vmList       = array();
	$oracleList   = array();
	$sharepointList = array();
	$xenList = array();
	$bareMetalList = array(); // will always be of size 1
	unset($localDirRestore);
	unset($CEPRestore);

	
	foreach ($archiveList as $archive) {
	$Log->writeVariable("in archive list loop, dumping archive....");
	$Log->writeVariable($archive);

		if ($archive['success'] == 0) {
			$Log->writeVariable($archive);
			   continue;
		}
	// group backup types to restore and restore only each of the last group per instance
		if ($archive['type'] == "baremetal") {
				$bareMetalList = array();
				$bareMetalList[] = $archive;
		} else if ($archive['type'] == "selective") {
				$selectiveList[] = $archive;
		} else if ($archive['type'] == "CEP") {
				$CEPRestore = $archive;
		} else if ($archive['type'] == "localdir") {
				$localDirRestore = $archive; // check if this is correct?
		} else if ($archive['type'] == "master") {
				$mastIncrList = array();
				$mastIncrList[] = $archive;
		} else if ($archive['type'] == "differential") {
				$mastIncrList[] = $archive;
		} else if ($archive['type'] == "exchange full") {
				$exchangeList = array();
				$exchangeList[] = $archive;
				$exchange[$archive['instance_id']] = $exchangeList;
		} else if ($archive['type'] == "exchange differential" || $archive['type'] == "exchange incremental") {
				$exchangeList = $exchange[$archive['instance_id']];
				$exchangeList[] = $archive;
				$exchange[$archive['instance_id']] = $exchangeList;
		} else if ($archive['type'] == "mssql full") {
				$sqlList = array();
				$sqlList[] = $archive;
				$sql[$archive['instance_id']] = $sqlList;
		} else if ($archive['type'] == "mssql differential" || $archive['type'] == "mssql incremental") {
				$sqlList = $sql[$archive['instance_id']];
				$sqlList[] = $archive;
				$sql[$archive['instance_id']] = $sqlList;
		} else if ($archive['type'] == "vmware full") {
				$vmList = array();
				$vmList[] = $archive;
				$vm[$archive['instance_id']] = $vmList;
		} else if ($archive['type'] == "vmware differential" || $archive['type'] == "vmware incremental") {
				$vmList = $vm[$archive['instance_id']];
				$vmList[] = $archive;
				$vm[$archive['instance_id']] = $vmList;
		} else if ($archive['type'] == "hyperv full") {
				$hypervList = array();
				$hypervList[] = $archive;
				$hyperv[$archive['instance_id']] = $hypervList;
		} else if ($archive['type'] == "hyperv incremental") {
				$hypervList = $hyperv[$archive['instance_id']];
				$hypervList[] = $archive;
				$hyperv[$archive['instance_id']] = $hypervList;
		} else if ($archive['type'] == "oracle full") {
				$oracleList = array();
				$oracleList[] = $archive;
				$oracle[$archive['instance_id']] = $oracleList;
		} else if ($archive['type'] == "oracle incr") {
				$oracleList = $oracle[$archive['instance_id']];
				$oracleList[] = $archive;
				$oracle[$archive['instance_id']] = $oracleList;
		} else if ($archive['type'] == "sharepoint full") {
				$sharepointList = array();
				$sharepointList[] = $archive;
				$sharepoint[$archive['instance_id']] = $sharepointList;
		} else if ($archive['type'] == "sharepoint diff") {
				$sharepointList = $sharepoint[$archive['instance_id']];
				$sharepointList[] = $archive;
				$sharepoint[$archive['instance_id']] = $sharepointList;
		} else if ($archive['type'] == "xen full") {
				$xenList = $xen[$archive['instance_id']];
				$xenList[] = $archive;
			 	$xen[$archive['instance_id']] = $xenList;
		 }

	 }

	 // call restore_archive here for all backup types of a client
	if (count($bareMetalList)) {
			foreach ($bareMetalList as $key => $ar) {
					restore_archive($BP, $xml, $ar);
			}
	} if (count($selectiveList)) {
			foreach($selectiveList as $key => $ar) {
					restore_archive($BP, $xml, $ar);
			}
	} if (count($mastIncrList)) {
			foreach($mastIncrList as $key => $ar) {
					restore_archive($BP, $xml, $ar);
			}
	} if (isset($CEPRestore)) {
			restore_archive($BP, $xml, $CEPRestore);
	} if (isset($localDirRestore)) {
			restore_archive($BP, $xml, $localDirRestore);
	} if (count($exchange)) {
			$result = array();
			foreach($exchange as $key => $list) {
					$result = array_merge($result, $list);
			}
			usort($result, "compare_date");
			foreach ($result as $key => $ar) {
					restore_archive($BP, $xml, $ar);
			}
	} if (count($sql)) {
			$result = array();
			foreach($sql as $key => $list) {
					$result = array_merge($result, $list);
			}
			usort($result, "compare_date");
			foreach ($result as $key => $ar) {
					restore_archive($BP, $xml, $ar);
			}
	} if (count($vm)) {
			$result = array();
			foreach($vm as $key => $list) {
					$result = array_merge($result, $list);
			}
			usort($result, "compare_date");
			foreach ($result as $key => $ar) {
					restore_archive($BP, $xml, $ar);
			}
		}
	} if (count($hyperv)) {
			$result = array();
			foreach($hyperv as $key => $list) {
					$result = array_merge($result, $list);
			}
			usort($result, "compare_date");
			foreach ($result as $key => $ar) {
					restore_archive($BP, $xml, $ar);
			}
	}	if (count($xen)) {
			$result = array();
			foreach($xen as $key => $list) {
				$result = array_merge($result, $list);
			}
			usort($result, "compare_date");
			foreach ($result as $key => $ar) {
				restore_archive($BP, $xml, $ar);
			}
	}
		
}

function restore_archive($BP, $xml, $archive) {
global $Log;	
global $restoreClientList;
global $deviceName;
global $bReplace;
global $deviceID;

	if ($bReplace) {
		$clientName = $archive['client_name'];
		for ($i = 0; $i < count($restoreClientList); $i++) {
			if ($clientName == $restoreClientList[$i]) {
				$devName = $deviceName[$i];
				$deviceID = $BP->get_device_id($devName);
			}
		}
	}
	
	$restoreOptions = array();
	$restoreOptions['association'] = "dr";
	if ($bReplace && isset($deviceID)) {
		$restoreOptions['device_id'] = $deviceID;
	}
	
	$returnValue = $BP->restore_archived_files($archive['archive_id'], $restoreOptions);
	if ($returnValue !== false) {
		$xml->element("JobID", $returnValue);
	} else {
		$xml->element("RestoreError", $BP->getError());
	}      
}

// sort in ascending order of backup time
function compare_date($a, $b) {
        if($a['backup_time'] == $b['backup_time']) {
                return 0;
        }
        return ($a['backup_time'] < $b['backup_time']) ? -1 : 1;
}

$BP->destroyCookie();

?>
