<?php
// defines BP, xml, action, cookie
require 'header.php';

// defines functions for URL parsing.
require('urloptions.php');

$startTime = -1;
$endTime = -1;
$days = -1;

$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();

if (isset($_REQUEST['days']) || (isset($_REQUEST['start']) && isset($_REQUEST['end']))) {
	$returnValue = true;
	if (isset($_REQUEST['days'])) {
		$days = (int)$_REQUEST['days'];
		} else {
		$startTime = (int)$_REQUEST['start'];
		$endTime = (int)$_REQUEST['end'];
	}
}

// Loop through all systems.  Will be only one in the list for a DPU, multiple systems on a Vault or a Manager.
$systems = $BP->get_system_list();	
$localID = $BP->get_local_system_id();
$bVault = $BP->local_system_is_vault();
$bManager = $BP->local_system_is_mgr();
$bMDPU = isset($_GET['mdpu']) ? true : false;

if ($systems === false) {
	$BP->buildResult($xml, false);
	echo($xml->getXml());
	break;
} else {	
	$xml->push('root');
	foreach ($systems as $systemID => $systemName) {
		// Either we've specified one dpu ID or all.
		if ($systemID == $dpuID || $dpuID == $localID) {				
			// If this system is a vault and we are looking at this system, skip it and go to the next.
			if ($bVault && ($systemID == $localID)) {
				;
			// If this system is a manager and we are not running on the MDPU node nor are
			// not looking at the selected system, skip it.
			} else if (!$bVault && $bManager && !$bMDPU && ($systemID != $dpuID)) {
				;
			} else {
				$xml->push("DPU", array("Name" => $systemName, "ID" => $systemID));
				
				$arrayFilter = array('dpu' =>$systemID);
				$arrayFilter = array_merge($arrayFilter, addDaysFilter($days, $startTime, $endTime));
				$auditHistoryArray = $BP->get_audit_history($arrayFilter, $systemID);
				
				if ($auditHistoryArray !== false) {
					if ($systemID != -1) {
						if (count($auditHistoryArray) > 0) {
							foreach ($auditHistoryArray as $auditHistory) {
								createAuditHistoryXML($xml, $auditHistory, $systemID);
							}
						}
					}
				}
				$xml->pop();
			}
		}
	}
	$xml->pop();
	echo($xml->getXml());
}

function addDaysFilter($days, $startTime, $endTime)
{
	// see if the user specified start and end time.
	if ($startTime != -1) {
		if ($endTime == -1) {
			$endTime = time();
		}
	} else {
	
		//$days = -1;
		// default -1 (1 week)
		if ($days == -1) {
		// 6 days before today gives us 1 week of data.
			$days = 6;
	
			} else {
			// subtract 1 day since we are going back in time (inclusive).
			// we will also go back to midnight (below).
			$days = $days - 1;
		}
			
		$endTime = time();
		// convert to start and end times (days * 24 hr/day * 60 min/hr * 60 sec/min)
		$startTime = $endTime - ($days * 24 * 60 * 60);
		// adjust the start time back to midnight of x days ago.
		$dayOffset = date('H:i:s', $startTime);
		$pieces = explode(':', $dayOffset);
		$hour = (int)$pieces[0];
		$minute = (int)$pieces[1];
		$sec = (int)$pieces[2];
		$startTime -= (($hour * 60 * 60) + ($minute * 60) + $sec);
	}

	//printf("end time is %d and start time is %d<br/>", $endTime, $startTime);
	$filterArray = array('start_time' => $startTime, 'end_time' => $endTime);
	return $filterArray;
}

// Creates the XML for the kill activites
function createAuditHistoryXML($xml, $audit, $dpuID){
	$name = (array_key_exists('id', $audit)) ? $audit['id'] : "unknown";
	auditByID($xml, $audit, 'username','notification_id','event_time', 'category', 'message');
}

//
function auditByID($xml, $audit, $typeUser, $typeID, $typeDate, $typeCategory, $typeMessage)
{
	if (array_key_exists($typeID, $audit)) {
		$id = $audit[$typeID] !== 0 ? $audit[$typeID] : 'None';
		$attributes = array('ID' => $id);
		if (isset($audit[$typeUser])) {
			$attributes['User'] = $audit[$typeUser];
		}
		
		if (isset($audit[$typeDate])) {
			
			if (array_key_exists($typeDate, $audit)) {
				if ($audit[$typeDate] !== 0) {
				}
			}
			
			$dateString = $audit[$typeDate];
			$dotPos = stripos($dateString, '.');

			if ($dotPos !== false) {
				$dateString = substr($dateString, 0, $dotPos);
	
			//convert date string to timestamp
			$dateString = strtotime($dateString);

			$date = strftime('%m/%d/%Y', $dateString);
			$time = strftime('%r', $dateString);
			
			$attributes['Date'] = $date;
			$attributes['Time'] = $time;
		
			}
		}
			
		if (isset($audit[$typeCategory])) {
		$attributes['Category'] = $audit[$typeCategory];
		}
		
		if (isset($audit[$typeMessage])) {
			$attributes['Message'] = $audit[$typeMessage];
		}
				
		$xml->emptyElement('Audit', $attributes);
	}
}


$BP->destroyCookie();
?>