<?php
//problem with cacheing, IE, and SSL; so use argument url.
//header("Cache-Control: no-cache");
//error_reporting(E_ERROR);

// Include standard definitions/common functions.
require 'defines.php';
// Include the bpl.so API's. Defines must be included before this.
require 'bp.php';
// Include XML function
require 'xmlwriter.php';
// Include logging functions
require 'logger.php';
// Include ldap_authentication functions

// get login/password arguments.
$loginUsername = isset($_REQUEST['name']) ? $_REQUEST['name'] : NULL;
$password      = isset($_REQUEST['password']) ? $_REQUEST['password'] : NULL;

$b64Username = isset($_REQUEST['base64Username']) ? $_REQUEST['base64Username'] : NULL;
$b64Password = isset($_REQUEST['base64Password']) ? $_REQUEST['base64Password'] : NULL;

$b64Username = base64_decode( $b64Username );
$b64Password = base64_decode( $b64Password );

// Get Logging options
$logLevel =  isset($_REQUEST['lvl']) ? (int)$_REQUEST['lvl'] : 0;
$logDirectory = isset($_REQUEST['logdir']) ? $_REQUEST['logdir'] : LOG_DIRECTORY;

// Create standard objects for use in all BPL functions.
$Log = new Logger($logLevel, $logDirectory);
$xml = new ria_xmlWriter(false);
$BP = new BP();



// if the user did not refresh their cache after an update to 7.2 
// they might have a base64 encoded password send through the loginUsername and password 
// variables - this should handle that case before any attempts to URL decode.
//$decoded =  urldecode($password);	
//$transitionalUsername = base64_decode( $_REQUEST['name'] );
//$transitionalPassword = base64_decode( $_REQUEST['password'] );
//$Log->writeVariable( "Username is $loginUsername - password is $password" );
//$Log->writeVariable( "Username is $loginUsername - decoded password is $decoded" );
//$Log->writeVariable( "B64Username is $b64Username - B64Password is $b64Password" );
//$Log->writeVariable( "transitional is $transitionalUsername - B64Password is $transitionalPassword" );

//necessary for bp_get_ini_section
$BP->bypass_cookie(2);
$dpuID = $BP->get_local_system_id();

$ActiveDirectory = $BP->get_ini_section("Active Directory", $dpuID);

if($ActiveDirectory !== false) {
	$ADsettings = array();
	foreach($ActiveDirectory as $ADsection){
		$key = $ADsection['field'];
		$value = $ADsection['value'];
		
		$result = array($key => $value);
		$ADsettings = array_merge($ADsettings, $result);
	}

	$useAD = $ADsettings['AD_AuthenticationEnabled'] == 'Yes' ? true : false;  
	$server = $ADsettings['AD_ServerName'];
	$fqdn = $ADsettings['AD_DomainName'];
	$useADSSL = $ADsettings['AD_UseSSL'] == 'Yes' ? true : false; 
	$SuperUserGroup = $ADsettings['AD_Superuser'];
	$AdministratorGroup = $ADsettings['AD_Admin'];
	$manageGroup = $ADsettings['AD_Manage'];
	$monitorGroup = $ADsettings['AD_Monitor'];
	
	if($useAD){
		global $Log;
		$Log->writevariable("useAD?"  . $useAD);
		if($fqdn == NULL) {
			$message = "Active Directory Server not specified.";
			$Log->writeVariable($message);
			$BP->send_notification(125, "login" , $message);
		} 
		
		// if the user did not refresh their cache after an update to 7.2 
		// they might have a base64 encoded password send through the loginUsername and password 
		// variables - this should handle that case before any attempts to URL decode.
		$transitionalUsername = base64_decode( $loginUsername );
		$transitionalPassword = base64_decode( $password );
		
		//decode password to handle special chars
		$adPassword = urldecode($password);	
	
		$Log->writeVariable("RRC: Base64 login for LDAP ...");
		$result = LDAPAuthenticate($BP, $b64Username, $b64Password, $fqdn, $useADSSL);
		
		if ( !is_array($result) || $result === false ) {
			$Log->writeVariable("RRC: Straight login for LDAP ...");
			$result = LDAPAuthenticate($BP, $loginUsername, $adPassword, $fqdn, $useADSSL);
		}
		
		if ( !is_array($result) || $result === false ) {
			$Log->writeVariable("RRC: Base 64 transitional for LDAP ...");
			//$Log->writeVariable("RRC: $transitionalUsername  $transitionalPassword ");
			$result = LDAPAuthenticate($BP, $transitionalUsername, $transitionalPassword, $fqdn, $useADSSL);
		}
		
		if (is_array($result) && $result !== false) {
			$Log->writeVariable("AD Result");
			$Log->writeVariable($result);
	
			$users = getADPermissions($result);
			
			if($users !== false) {
				$ad_permissions = mapPermissions($users, $SuperUserGroup, $AdministratorGroup, $manageGroup, $monitorGroup);
				
				$Log->writeVariable("permissions");
				$Log->writeVariable($ad_permissions);
			}
			$ad_authentication_cookie = $BP->get_ad_cookie($result['rrclogin'], $ad_permissions);
			
			if($ad_authentication_cookie !== false) {
				setUserCookie($BP, $xml, $ad_authentication_cookie, $result['rrclogin'], $ad_permissions);
			} else {
				$BP->send_notification(125, "login", "Active Directory Authentication Failed.");
			}
		} else {
			//AD authentication failed - try appliance log in
			$Log->writeVariable($result);
			//	$BP->send_notification(125, "login", "Active Directory Authentication Failed.  Attempting Appliance user authentication.");
			
			rrcAuthenticate($BP, $xml, $loginUsername, $password, $b64Username, $b64Password );
		}
	} else {
		//AD authentication is not enabled - try appliance log in
		rrcAuthenticate($BP, $xml, $loginUsername, $password, $b64Username, $b64Password );
	}
} else {
	//AD section is not present in master.ini - try appliance log in.
	rrcAuthenticate($BP, $xml, $loginUsername, $password, $b64Username, $b64Password);
}


function rrcAuthenticate($BP, $xml, $loginUsername, $password, $b64UserName, $b64Password ){
	global $Log;
	$bSuccess = false;
	
	$Log->writeVariable("RRC: Base 64...");
	$authentication_cookie = $BP->authenticate( $b64UserName, $b64Password );
	
	// if the user did not refresh their cache after an update to 7.2 
	// they might have a base64 encoded password send through the loginUsername and password 
	// variables - this should handle that case before any attempts to URL decode.
	$transitionalUsername = base64_decode( $loginUsername );
	$transitionalPassword = base64_decode( $password );
	
	if ($authentication_cookie !== false) {
		$bSuccess = true;
	} else {
		$Log->writeVariable("RRC: Straight login ...");
		$authentication_cookie = $BP->authenticate( $loginUsername, $password );
		
		if ($authentication_cookie !== false) {
			$bSuccess = true;
		} else {
			$Log->writeVariable("RRC: decoding password...");
			$password = urldecode($password);
			$authentication_cookie = $BP->authenticate($loginUsername, $password);
			if ($authentication_cookie !== false) {
				$bSuccess = true;
			} else {
				$Log->writeVariable("RRC: encoding password...");
				$password = urlencode($password);
				$authentication_cookie = $BP->authenticate($loginUsername, $password);
				if ($authentication_cookie !== false) {
					$bSuccess = true;
				}
			}
		}
	}
	
	// Additional attempt at login in with the base64 decoded password from the regular username and password
	// this is for situations where the user has upgraded - but did not refresh their cache
	if ( !$bSuccess ) { 
		$Log->writeVariable("RRC: Base 64 transitional...");
		$authentication_cookie = $BP->authenticate( $transitionalUsername, $transitionalPassword );
		if ($authentication_cookie !== false) {
			$bSuccess = true;
		} else {
			$Log->writeVariable("RRC:  Base 64 encoding after base64 password...");
			$transitionalPassword = urldecode($transitionalPassword);
			$authentication_cookie = $BP->authenticate($transitionalUsername, $transitionalPassword);
			if ($authentication_cookie !== false) {
				$bSuccess = true;
			} else {
				$Log->writeVariable("RRC:  Base 64 encoding password...");
				$transitionalPassword = urlencode($transitionalPassword);
				$authentication_cookie = $BP->authenticate($transitionalUsername, $transitionalPassword);
				if ($authentication_cookie !== false) {
					$bSuccess = true;
				}
			}
		}
	}
	
	if ( !$bSuccess ) {
		
		$xml->push("root");
		$xml->element("AuthenticationString", "");
		$errorString = $BP->getError();
		if (!is_null($errorString) && $errorString != "") {
			$xml->element("ErrorString", $errorString);
		}
		$xml->pop();
		echo($xml->getXml());

		//call this after bp_getERROR so correct error message is displayed to user.
		//this call will fail if db is inaccessible.
		$BP->send_notification(125, "login" , "");
		
	} else {
		setUserCookie($BP, $xml, $authentication_cookie);
	}
}

function LDAPAuthenticate($BP, $username, $password, $fqdn, $ADssl) {
	$rootdir = "/var/www/html/recoveryconsole";
	$ldapScript = $rootdir . '/system/ldap.php';

	// if this method is called more than one time - it will fail without require_once
	require_once $ldapScript;

	$ldap = new LDAPFunctions(); 

	$result = $ldap->authenticate($username, $password, $fqdn, $ADssl);

	if ($result !== false) {
		return $result;
	} else {
		return false;
	}
}

function getADPermissions($result){
	global $Log;
	$adUsers = array();
	
	foreach($result as $key => $value){
		if($key == "memberof" && $value !== NULL) {
			foreach($value as $innerkey => $innerValue) {
				if(is_array($innerValue)){
					if(array_key_exists("count", $innerValue)) {
						foreach($innerValue as $adUser) {
							array_push($adUsers, $adUser);
						}
					}
				}
			}
		}
	}
		
	return $adUsers;
}

function mapPermissions($users, $SuperUserGroup, $AdministratorGroup, $manageGroup, $monitorGroup) {
	$a = array();
	foreach($users as $x){
		$sArray = explode(",", $x);
		foreach($sArray as $item) {
			if(strstr($item, "CN=")){
				$s = str_replace("CN=", "", $item);	
				$a[] = $s;					
			}
		}
	}
		
	$permissionLevel = -1;		
	
	if(in_array($SuperUserGroup, $a)) {
			$permissionLevel = 4;
	} else if(in_array($AdministratorGroup, $a)) {
			$permissionLevel = 3;
	} else if(in_array($manageGroup, $a)) {
			$permissionLevel = 2;
	} else if(in_array($monitorGroup, $a)) {
			$permissionLevel = 1;
	} else if(in_array("Administrators", $a)) {
		$permissionLevel = 3;
	}
	
	return $permissionLevel;
		
}

function setUserCookie($BP, $xml, $authentication_cookie, $adUsername = NULL, $ad_permissions = NULL) {
	global $Log;
	$monitor = false;
	
	$BP->set_cookie($authentication_cookie, true);
	$userInfo = $BP->getUser();
		
	// Check non vault-users to see if they have monitor privileges, by running an API with privilege > monitor.
	// Vault users always have administrator privileges on their source system.
	$vaultUser = isset($userInfo['vault_user']) && $userInfo['vault_user'] == true;
	if (!$vaultUser) {
		$testPrivilege = $BP->get_calendar_list();
		if ($testPrivilege == false){
			$errorString = $BP->getError();
			$Log->writeVariable($errorString);
		} else {
			$errorString = "";
		}
		if (strstr($errorString, "Insufficient privileges") !== false) {
			$monitor = true;	
		}
		$Log->writeVariable("monitor " . $monitor);
	}
		
	$userID = isset($userInfo['id'])? $userInfo['id'] : -1;
	$userName = $adUsername == NULL ? $userInfo['name'] : $adUsername;
	$Administrator = isset($userInfo['administrator']) ? ($userInfo['administrator'] == true ? "true" : "false") : "";
	$Manager = isset($userInfo['ADprivilege_level']) ? ($userInfo['ADprivilege_level'] == "2" ? "true" : "false") : "";
	$Monitor = $monitor == true ? "true" : "false";

	if($userID == -1){
		$BP->send_notification(124, "login", "Active Directory user");
	} else {
		$BP->send_notification(124, "login", "");
	}
	
	$xml->push("root");
	$xml->element("AuthenticationString", $authentication_cookie);	
	$attributes = array( "ID" => $userID,
						 "Name" => $userName,
						 "ADUser" => $userInfo['ADuser'] == true ? "true" : "false",
						 "Superuser" => $userInfo['superuser'] == true ? "true" : "false",
						 "Administrator" => $Administrator,
						 "Manager" => $Manager,
						 "Monitor" => $Monitor);
		
	// Add vault user attributes and source ID if a vault user.
	$attributes['VaultUser'] = $vaultUser == true ? "true" : "false";
	if ($vaultUser) {
		$attributes['SourceID'] = $userInfo['source_id'];
	}
		
	$xml->emptyElement("User", $attributes);
	$xml->pop(); // root
	echo($xml->getXml());
}

$BP->destroy_cookie();

?>
