<?php
// defines BP, xml, action, cookie
require 'header.php';

switch ($action) {
	case "list":
			buildManagersList($BP, $xml);
			echo($xml->getXml());
			break;
		
	case "add":				
	case "grant":
			// If granting management access to another system, need it's IP or hostname.
			if (isset($_GET['ip'])) {
				$ip = $_GET['ip'];
				$BP->buildResult($xml, $BP->grant_mgr($ip));
			} else if (isset($_GET['hostname'])) {
				$hostName = $_GET['hostname'];
				$BP->buildResult($xml, $BP->grant_mgr($hostName));
			} else {
				$BP->buildResult($xml, false, "Improper argument format; hostname or IP must be specified when granting management access to another system.");
			}
			echo($xml->getXml());
			break;
					
	case "delete":
	case "revoke":
			// If revoking management access fron another system, need it's IP.
			if (isset($_GET['ip'])) {
				$ip = $_GET['ip'];
				$BP->buildResult($xml, $BP->revoke_mgr($ip));
			} else {
				$BP->buildResult($xml, false, "Improper argument format; IP address must be specified when revoking management access to another system.");
			}
			echo($xml->getXml());
			break;
}

function buildManagersList($BP, $xml)
{
	$managers = $BP->get_manager_list();
	if ($managers !== false) {
		$xml->push("root");
		foreach ($managers as $manager) {
			$xml->push("Manager");
			if (array_key_exists('hostname', $manager)) {
				$xml->element('Hostname', $manager['hostname']);
			}
			if (array_key_exists('ip', $manager)) {
				$xml->element('IP', $manager['ip']);
			}
			if (array_key_exists('version', $manager)) {
				$xml->element('Version', $manager['version']);
			}
			$xml->pop();
		}
		$xml->pop();
	} else {
		$BP->buildResult($xml, false);
	}
}

$BP->destroyCookie();
?>