<?php
// defines BP, xml, action, cookie
require 'header.php';

$networkInfo = array();

switch ($action) {

	case "list":	// list the networks on the system
					$bValid = true;
					$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
					if (!isset($_GET['sid']) || $dpuID == $BP->get_local_system_id()) {
						$networks = $BP->get_network_list();
					} else {
						$networks = $BP->get_network_list($dpuID);
					}
					if ($networks === false) {
						$bValid = false;
					} else {
						$xml->push("root");
						foreach ($networks as $network) {
							$networkName = $network;
							if (!isset($_GET['sid']) || $dpuID == $BP->get_local_system_id()) {
								$networkInfo = $BP->get_network_info($networkName);
							} else {
								$networkInfo = $BP->get_network_info($networkName, $dpuID);
							}
							if ($networkInfo === false) {
								// Since we are not erroring out, log in the error log.
								// The CMC will pick up on the unknown element to warn the user.
								global $Log;
								$message = $BP->getError() . " (network name = " . $networkName . ")";
								$Log->writeError($message, true);
								$dummyInfo = array ('unknown' => 'unknown');
								displayNetwork($xml, $networkName, $dummyInfo);
							} else {
								displayNetwork($xml, $networkName, $networkInfo);
							}
						}
						$xml->pop(); //root
					}
					if (!$bValid) {
						$xml->clear(false);
						$BP->buildResult($xml, false);
					}
					echo($xml->getXml());
					break;
						
	case "update":	// Get the network definition from arguments.
					if (isset($_GET['name'])) {
						$name = $_GET['name'];
						$networkInfo = array ("name" => $name);
					}
					$options = array ('ip' => 'ip',
									  'netmask' => 'netmask',
									  'gateway' => 'gateway');
					$bOptions = array('boot' => 'boot',
									  'auto_restore' => 'restore');			
					$networkInfo = buildOptions($networkInfo, $options, $bOptions);
					$iOptions = array('countdown_time' => 'countdown');
					$networkInfo = addIntegerOptions($networkInfo, $iOptions);			
					
					if (isset($_GET['name'])) {
						$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
						if (!isset($_GET['sid']) || $dpuID == $BP->get_local_system_id()) {
							$BP->buildResult($xml, $BP->save_network_info($networkInfo));
						} else {
							$BP->buildResult($xml, $BP->save_network_info($networkInfo, $dpuID));
						}
						echo($xml->getXml());
					} else {
						$BP->buildResult($xml, false,
									"networks: improper argument format: must specify name for update.");
						echo($xml->getXml());
					}
					break;
					
	case "stop":	// Stops the network auto-restore process
					$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
					if (!isset($_GET['sid']) || $dpuID == $BP->get_local_system_id()) {
						$BP->buildResult($xml, $BP->stop_network_restore());
					} else {
						$BP->buildResult($xml, $BP->stop_network_restore($dpuID));
					}
					echo($xml->getXml());
					break;
	
}

function displayNetwork($xml, $networkName, $networkInfo)
{	
	$xml->push("Network", array("Name" => $networkName));
	if (array_key_exists('ip', $networkInfo))
		$xml->element('IP', $networkInfo['ip']);
	if (array_key_exists('netmask', $networkInfo))
		$xml->element('Netmask', $networkInfo['netmask']);
	if (array_key_exists('gateway', $networkInfo))
		$xml->element('Gateway', $networkInfo['gateway']);
	if (array_key_exists('boot', $networkInfo))
		$xml->element('Boot', $networkInfo['boot'] == true ? "1" : "0");
	if (array_key_exists('link', $networkInfo))
		$xml->element('Link', $networkInfo['boot'] == true ? "1" : "0");
	if (array_key_exists('speed', $networkInfo))
		$xml->element('Speed', $networkInfo['speed']);
	if (array_key_exists('duplex', $networkInfo))
		$xml->element('Duplex', $networkInfo['duplex']);		
		
	// If an error occurred getting info, pass that back to caller.
	if (array_key_exists('unknown', $networkInfo)) {
		$xml->element('LoadError', $networkName);
	}
	$xml->pop(); // network
}

$BP->destroyCookie();
?>
