<?php
// defines BP, xml, action, cookie
require '../header.php';

switch ($action) {
	case "list":
		// see which client/grand client associations exist.
		if (isset($_GET['cid'])) {
			$cid = (int)$_GET['cid'];
			$result = $BP->get_grandclient_restores($cid);
			if ($result !== false) {
				$xml->push('root');
				buildGrandClientXML($xml, $BP, $result);
				$xml->pop(); // root
			} else {
				$BP->buildResult($xml, $result);
			}
		} else {
			$result = $BP->get_grandclient_restores_list();
			if ($result !== false) {
				$xml->push('root');
				foreach ($result as $association) {
					buildGrandClientXML($xml, $BP, $association);
				}
				$xml->pop();
			}
		}
		echo($xml->getXml());
		break;
						
	case "update":
		$from_cid = isset($_GET['from_cid']) ? (int)$_GET['from_cid'] : -1;
		$to_cid = isset($_GET['to_cid']) ? (int)$_GET['to_cid'] : -1;
		$backupID = isset($_GET['bid']) ? (int)$_GET['bid'] : -1;
		$result = $BP->chown_backup($from_cid, $to_cid, $backupID);
		$BP->buildResult($xml, $result);
		echo($xml->getXml());
		break;
		
	case "all":    // list possible backup candidates.
		$from_cid = isset($_GET['from_cid']) ? (int)$_GET['from_cid'] : -1;
		$to_cid = isset($_GET['to_cid']) ? (int)$_GET['to_cid'] : -1;
		$clientInfo = $BP->get_client_info($to_cid);
		if ($clientInfo !== false) {
			$osID = $clientInfo['os_type_id'];
			$types = array('baremetal');
			if (!isWindows($osID)) {
				$result_format[] = 'master';
			}
			$result_format['type'] = $types;
			$result_format['client_id'] = $from_cid;
			$status = $BP->get_backup_status($result_format);
			if ($status !== false) {
				$xml->push('root');
				foreach ($status as $backup) {
					// If complete and not a failure.
					if (isset($backup['complete']) && $backup['complete'] == true &&
					    isset($backup['status']) && $backup['status'] != STATUS_FAILURE) {
						createBackupStatusXML($xml, 'Backup', $backup, false);
					}
				}
				$xml->pop(); // root
			} else {
				$BP->buildResult($xml, false);
			}
		} else {
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());
		break;
}

//
// Builds a grandclient XML element.
//
function buildGrandClientXML($xml, $BP, $item) {
	$xml->push('Association');
	$client = $item['directclient'];
	$attributes = array('ID' => $client['client_id'], 'Name' => $client['name']);
	$xml->emptyElement('Client', $attributes);
	
	$grandClient = $item['grandclient'];
	$attributes = array('ID' => $grandClient['client_id'], 'Name' => $grandClient['name']);
	$xml->emptyElement('GrandClient', $attributes);
	
	$backupID = (int)$item['backup_id'];
	$result_format = array('backup_ids' => array($backupID));
	$status = $BP->get_backup_status($result_format);
	if ($status !== false  && count($status) > 0) {
		$thisStatus = $status[0];
		createBackupStatusXML($xml, 'Backup', $thisStatus, false);
	} else {
		$xml->emptyElement('Backup', array('Identification' => $backupID));
	}

	$date = date('m/d/Y', $item['assoc_time']);
	$time = date(TIME_FORMAT_12HR, $item['assoc_time']);
	$dateTime = $date . ' ' . $time;
	$xml->element('Date', $dateTime);

	$xml->pop(); // Assocation;
}

function isWindows($id) {
	$returnValue = true;
	if ($id >= 5 && $id <= 28) {
		$returnValue = false;
	} else if ($id >= 33 && $id <= 34) {
		$returnValue = false;
	}
	return $returnValue;
}

$BP->destroyCookie();
?>
