<?php
// defines BP, xml, action, cookie
require '../header.php';

$dpuID = isset($_GET['id']) ? (int)$_GET['id'] : $BP->get_local_system_id();
$sysId = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();

switch ($action) {
	case "list":
		$systems = $BP->get_system_list();
		
		$xml->push('root');
		foreach ($systems as $systemID => $systemName) {
			$source = $BP->get_system_info($systemID);
			if($source) {
				$sourceVersion = $source['version'];
			}
			$dpuIP = $BP->get_host_info($systemName);
			if($dpuIP !== false){
				$xml->push("DPU", array("Name" => $systemName, "ID" => $systemID, "IP" => $dpuIP['ip'], "version" => $sourceVersion));
				$xml->pop(); //DPU
			}
		}
		$xml->pop(); //root

		echo($xml->getXml());
		break;
		
	case "target":
		$targetName =  isset($_GET['targetname']) ? $_GET['targetname'] : "";
			$result = $BP->setup_dr_target($targetName);

			if( $result !== false) {
				$BP->buildResult($xml, true);
			} else {
				$BP->buildResult($xml, false, $BP->getError());	
			}
			
		echo($xml->getXml());
		break;
		
	case "clients":	
		$sourceID = $_GET['id'];
	
			$grandClients = $BP->get_grandclient_list($sourceID);
			
			if($grandClients !== false){  
				$names = array();
				$clientList = array();
				$i = 0;         
				$xml->push('root');

				foreach ($grandClients as $id => $name) {
					//$names[$i++] = $name;
					$clientList[$i++] = $id;
					$xml->push('Client');
					$xml->element("Name", $name);
					$xml->pop(); // client
				}
				
				//$clientList = buildClientList($BP, $names, $sourceID);
	
				if($clientList !== false) {
					$metadata = getMetadataBackup($BP, $clientList, $sysId);
					$xml->push("Metadata", array("metadata" => $metadata));
					$xml->pop(); //metadata
				}
				$xml->pop(); //root
			} else {
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;
			
	case "queue":
		$metadata = $_GET['metadata_id'];
		$targetName = $_GET['targetname'];
		
		//check if metadata backup is already in the queue.  If true, don't try to re-add.
		
		$exists = $BP->is_backup_in_replication_queue($metadata, $targetName, $dpuID);
		if($exists !== false) {
			$xml->push("root");
			global $Log;
			$Log->writeVariable("exists");
			$Log->writeVariable($exists);
			if($exists == "") {
				$result = $BP->add_to_replication_queue($metadata, $targetName);
			}
				$xml->push("QueueStatus", array("status" => $exists));
				$xml->pop(); //QueueStatus
				$xml->pop(); //root
			
		} else {
				$BP->buildResult($xml, false);
		}
		
		echo($xml->getXml());
		break;	
		
	case "metadata_check":
		$backupID = isset($_GET['metadata_id']) ? (int)$_GET['metadata_id'] : "";
		$bReplace = $_GET['breplacestorage'] == '1' ? true : false;
		$action = 'check';
		
		$filter = array('backup_id' => $backupID, 
						'save_new_storage' => $bReplace,
						'action' => $action);
			
			$result = $BP->restore_appliance_metadata($filter);
			
			if($result !== false) {
				//for 7.0 - empty array.  We may need these notices one day, but not today.
			if(!empty($result)) {
				global $Log;
				foreach($result as $msg) {
					$Log->writeVariable($msg);
					//$BP->setWarning($xml, $msg);
				}
				$result = array();
			}
			$BP->buildResult($xml, true);			
		} else {
			$BP->buildResult($xml, false, $BP->getError());
		}
	
		echo($xml->getXml());
	  	break;
			

	case "metadata_restore":
		$backupID = isset($_GET['metadata_id']) ? (int)$_GET['metadata_id'] : "";
		$bReplace = $_GET['breplacestorage'] == '1' ? true : false;		
		$action = 'restore';
		
		//we have to cancel any running jobs before restoring system metadata
		$jobList = $BP->get_job_list($dpuID);

		if($jobList !== false) {
			foreach($jobList as $id => $backup){
				$BP->cancel_job($id);	
			}
		}

		$filter = array('backup_id' => $backupID, 
						'save_new_storage' => $bReplace,
						'action' => $action);
		
		$result = $BP->restore_appliance_metadata($filter);
		if($result !== false) {
			$BP->buildResult($xml, true);	
		} else {
			$BP->buildResult($xml, false, $BP->getError());
		}
		

		echo($xml->getXml());
	  	break;	

	
	case "client_backups":	
	global $Log;
		$sourceID = $_GET['id'];
		$dpuID = $BP->get_local_system_id();
		$targetName =  isset($_GET['targetname']) ? $_GET['targetname'] : "";
			$names = isset($_GET['client_list']) ? $_GET['client_list'] : "";
			$cids = buildClientListForBackups($BP, $names, $sourceID);
			if($cids !== false){  
				$backupIDs = getClientBackups($BP, $cids, $dpuID, 60, false, false);
				if ( $backupIDs  !== false ) {
					$xml->push("root");
					foreach($backupIDs as $bid) {
						$addToQueue = $BP->add_to_replication_queue($bid, $targetName);
						$xml->push("added", array("bid" => $bid, "added" => $addToQueue));
						$xml->pop(); //added
					}
					$xml->pop(); //root
					
				} else {
					$BP->buildResult($xml, false, $BP->getError());
				}
			} else {
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;
			
		case "enable_replication_check":
			//if performing a DR, replication on the DR source (target of replication) needs to be enabled.
			$result = $BP->get_ini_value('Replication', 'Enabled', $dpuID);
			$BP->buildResult($xml, $result);
			echo($xml->getXml());
			break;
					
		case "enable_replication":
			//if performing a DR, replication on the DR source (target of replication) needs to be enabled.
			$result = $BP->set_ini_value("Replication", "Enabled", "yes", $dpuID);
			$BP->buildResult($xml, $result);
			echo($xml->getXml());
			break;
		
	
}

//grand client list is indexed by g-client id.  We need client id (not g-client id) to pass to bp_get_all_last_backups
//
function buildClientList($BP, $names, $sourceID)
{
	$clientList = array();	
	$i = 0;
	foreach ($names as $client) {
		$cid = $BP->get_client_id($client, $sourceID);
		$clientList[$i++] = $cid;	
	}	
	return $clientList;
}

function buildClientListForBackups($BP, $names, $sourceID)
{
	$dpuID = $BP->get_local_system_id();
	global $Log;
	$grandClients = $BP->get_grandclient_list($sourceID);
	$clientNameList = array();	
	$clientList = array();
	//clients come in as csv string
	$clientValues = explode(",", $names);
	$i = 0;
	foreach ($clientValues as $clientValue) {
		$clientNameList[$i++] = $clientValue;	
	}
	$selectGClients = array_intersect($grandClients,$clientNameList);
	
	$i=0;
	foreach ( $selectGClients as $id => $name) {
		$clientList[$i++] = $id;
	}

	return $clientList;
}



//this function loops through backups for all clients on source and returns the backup id for the system metadata backup.
//app_id for the system metadata is 60.
//
function getMetadataBackup($BP, $cids, $dpuID) {
	global $Log;
	
	$metadataID = "60";
	$metadataBackup = "";
	if(is_array($cids)) {
		$result = $BP->get_all_last_backups($cids, $dpuID);
		$Log->writeVariable("all last");
		$Log->writeVariable($result);
		if($result == false) {
			$msg = $BP->getError();
			global $Log;
			$Log->writeVariable($msg);
							}
		if($result != false) {
			foreach ( $result as $lastbackups ) {
				if(array_key_exists('groups', $lastbackups)) {
					$backupGroups[] = $lastbackups['groups'];
					foreach ($backupGroups as $groups){
						foreach($groups as $backups){
							if(array_key_exists('app_id', $backups) && $backups['app_id'] == $metadataID) {
								if(array_key_exists('backup_ids', $backups)){
									foreach($backups as $ids){
										$metadataBackup = $ids[0];
									}
								}
							}
						}
					}
				}
			}
		}
	}

	return $metadataBackup;
}

function getClientBackups($BP, $cids, $dpuID, $appID, $match, $onlyOne) {
	$clientBackupIDs = array();
    if (is_array($cids)) {
		 $result = $BP->get_all_last_backups($cids, $dpuID);
		 global $last;
		// $result = $last;
		 if($result == false) {
			$msg = $BP->getError();
			global $Log;
			$Log->writeVariable($msg);
		  }
		  if ($result != false) {
			  foreach ($result as $lastBackups) {
				if (isset($lastBackups['groups'])) {
					$groups = $lastBackups['groups'];
					foreach ($groups as $group) {
						if (isset($group['app_id'])) {
							$thisApp = $group['app_id'];
						}
						if ($match) {
							if ($thisApp !== $appID) {
								continue;
							}
						} else {
							if ($thisApp === $appID) {
								continue;
							}
						}
						if (isset($group['backup_ids'])) {
							$bids = $group['backup_ids'];
							foreach ($bids as $id){
								$clientBackupIDs[] = $id;
								if ($onlyOne) {
									break;
								}
							}
					  	}
					}
				 }
          	}
        }
     }
	 
	 return $clientBackupIDs;
}

$BP->destroyCookie();
?>
