<?php
// defines BP, xml, action, cookie
require 'header.php';

switch ($action) {

	case "list":	$bValid = true;
					$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
					if (!isset($_GET['sid']) || $dpuID == $BP->get_local_system_id()) {
						$strategies = $BP->get_strategy_list();
					} else {
						$strategies = $BP->get_strategy_list($dpuID);
					}
					if ($strategies === false) {
						$bValid = false;
					} else {
						$xml->push("root");
						$dedup = $BP->dedup_supported($dpuID);
						$incrSupported = ($dedup == 'block');
						foreach ($strategies as $strategy) {
							if (validIncrementalItem($incrSupported, $strategy['name'], true)) {
								$xml->emptyelement("Strategy", array("Name" => $strategy['name'],
																	 "Description" => $strategy['description']));
							}
						}
						$xml->pop(); //root
					}
					if (!$bValid) {
						$xml->clear(false);
						$BP->buildResult($xml, false);
					}
					echo($xml->getXml());
					break;
					
	case "load":	$bValid = true;
					if (isset($_GET['name'])) {
						$name = $_GET['name'];
					} else {
						$BP->buildResult($xml, false,
								"error: strategies.php: detailed list must have strategy name specified.");
						echo($xml->getXml());
						break;
					}
					$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
					if (!isset($_GET['sid']) || $dpuID == $BP->get_local_system_id()) {
						$strategy = $BP->get_strategy($name);
					} else {
						$strategy = $BP->get_strategy($name, $dpuID);
					}
					if ($strategy === false) {
						$bValid = false;
					} else {
						$xml->push("root");
						$xml->push("Strategy", array("Name" => $name));
						$xml->cData($strategy);
						$xml->pop(); // Schedule
						$xml->pop(); //root
					}
					if (!$bValid) {
						$xml->clear(false);
						$BP->buildResult($xml, false);
					}
					echo($xml->getXml());
					break;
					
	case "save":	$bValid = true;
					if (isset($_GET['name'])) {
						$name = $_GET['name'];
					} else {
						$BP->buildResult($xml, false, "error: strategies.php: save must have name specified.");
						$bValid = false;
					}
					if (isset($_GET['contents'])) {
						$contents = $_GET['contents'];
					} else if (isset($_POST['contents'])) {
						$contents = $_POST['contents'];
					} else {
						$BP->buildResult($xml, false, "error: strategies.php: save must have contents specified.");
						$bValid = false;
					}
					if ($bValid) {
						$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
						if (!isset($_GET['sid']) || $dpuID == $BP->get_local_system_id()) {
							$BP->buildResult($xml, $BP->save_strategy($name, $contents));
						} else {
							$BP->buildResult($xml, $BP->save_strategy($name, $contents, $dpuID));
						}
					}
					echo($xml->getXml());
					break;
						
	case "delete":	$bValid = true;
					if (isset($_GET['name'])) {
						$name = $_GET['name'];
					} else {
						$BP->buildResult($xml, false, "error: strategiess.php: no name specified for deletion.");
						echo($xml->getXml());
						break;
					}
					$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
					if (!isset($_GET['sid']) || $dpuID == $BP->get_local_system_id()) {
						$BP->buildResult($xml, $BP->delete_strategy($name));
					} else {
						$BP->buildResult($xml, $BP->delete_strategy($name, $dpuID));
					}
					echo($xml->getXml());
					break;
}

$BP->destroyCookie();
?>