<?php
 
 // general library functions
//require $rootdir . 'bpl/library.php';
/*
require '../library.php';
 
$xml = "<root> \
	<ID>virtual client ID/ID> \
	<ClientID>Client ID</ClientID> \
	<Processors>2</Processors> \
	<Memory>1024</Memory> \
	<Disks> \
		Disk0,Disk1,Disk2
	</Disks> \
	<Include> \
		C:
	</Include> \
	<Exclude> \
		D:,E:
	</Exclude> \
	<Instances> \
	   1, 4, 7, 10 \
	</Instances> \
	<hypervisor_info>
    	<vm_name>vm name</vm_name>
    	<vm_location>vm location</vm_location>
		<esx_host>esx host id</esx_host>
		<pool>resource pool</pool>
  	</hypervisor_info>
	<network_info>
		<network_switch>network switch name</network_switch>
		<ip_addr>ip address of the new virtual failover client</ip_addr>
		<subnet>subnet mask</subnet>
		<gateway>gateway</gateway>
	</network_info>
</root>";
 
$profile = xmlToProfile($xml, $lib);

var_dump($profile);
*/

//
// Convert an XML document for the archive profile into a profile array.
//
function xmlToClient($xml, $lib)
{
	$parser = xml_parser_create();
	xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
	xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
	xml_parse_into_struct($parser, $xml, $values, $tags);
	xml_parser_free($parser);

	$profile = array();

	$stack = array();
	$i = 0;
	foreach ($values as $val) {
		if ($val['type'] == "open") {
			if ($val['tag'] != "root") {
				$field = buildFieldName($val['tag']);
				array_push($stack, $field);
			}
		} else if ($val['type'] == "close") {
			if ($val['tag'] != "root") {
				array_pop($stack);
			}
		} else if ($val['type'] == "complete") {
			$field = buildFieldName($val['tag']);
			array_push($stack, $field);
			$bInteger = isInteger($val['tag']);
			$bBoolean = isBoolean($val['tag']);
			setArrayValue($profile, $stack, $val['value'], $bInteger, $bBoolean);
			array_pop($stack);
		}
	}

	if (array_key_exists('disks', $profile)) {
		$profile['disks'] = $lib->getIDs($profile['disks']);
	}
	if (array_key_exists('incl_vols', $profile)) {
		$profile['incl_vols'] = $lib->getStringArray($profile['incl_vols']);
	}
	if (array_key_exists('excl_vols', $profile)) {
		$profile['excl_vols'] = $lib->getStringArray($profile['excl_vols']);
	}
	if (array_key_exists('instances', $profile)) {
		$profile['instances'] = $lib->getIDs($profile['instances']);
	}
	return $profile;
	
}

function setArrayValue(&$array, $stack, $value, $bInteger, $bBoolean) {
	if ($stack) {
		$key = array_shift($stack);
		setArrayValue($array[$key], $stack, $value, $bInteger, $bBoolean);
	} else {
		if ($bInteger) {
			$array = (int)$value;
		} else if ($bBoolean) {
			$array = (bool)$value;
		} else {
			$array = $value;
		}
	}
}

function buildFieldName($tag)
{
	$field = "";

	switch ($tag) {
		case "ID":
			$field = "id";
			break;
		case "ClientID":
			$field = "real_client_id";
			break;
		case "Processors":
			$field = "processors";
			break;
		case "Memory":
			$field = "memory";
			break;
		case "Disks":
			$field = "disks";
			break;
		case "Include":
			$field = "incl_vols";
			break;
		case "Exclude":
			$field = "excl_vols";
			break;
		case "AuditVerify":
			$field = "audit_verify";
			break;
		case "Instances":
			$field = "instances";
			break;
		case "Boot":
			$field = "boot_disk";
			break;
		// WIR UEB support, all other keys go through the default case
		case "network_switch":
			$field = "switch";
			break;
		default:
			$field = $tag;
			break;
	}

	return $field;
}

function isInteger($tag)
{
	$bInteger = false;
	switch ($tag) {
		case "ID":
		case "ClientID":
		case "Processors":
		case "Memory":
		case "Boot":
		case "hyperv_host":
			$bInteger = true;
			break;
	}
	return $bInteger;
}

function isBoolean($tag)
{
	$bBoolean = false;
	switch ($tag) {
		case "AuditVerify":
			$bBoolean = true;
			break;
	}
	return $bBoolean;
}
?>