<?php
class Options
{
	var $m_worldSubDirectory;
	var $m_bplDirectory;
	var $m_networkID;
	var $m_treeLevel;
	var $m_bOutputToFile;
	var $m_nDays;
	var $_grandClientView;
	var $_sourceID;
	var $_user;
	
	function Options()
	//function __construct()
	{
		global $worldsDirectory;

		$this->m_worldSubDirectory = "random";
		$this->m_bplDirectory = $worldsDirectory . $this->m_worldSubDirectory;
		$this->m_networkID = "";
		$this->m_treeLevel = "";
		$this->m_nDays = -1;
		$this->m_startTime = -1;
		$this->m_endTime = -1;
		$this->m_strAuthentication = "";
		$this->m_aTypes = array();
		
		// status types to get, either bs (backup status), vs (vault status), or 'both'
		$this->m_StatusType = "";
		
		// Determine views for grand client, remove vault user specifying source ID.
		$this->_grandClientView = false;
		$this->_sourceID = -1;
		$this->_user = "";
	}
	
	function parseCommandLine($strArguments)
	{
		global $worldsDirectory;
			
		$args = explode(',', $strArguments);
		foreach ($args as $arg) {
			$pieces = explode(':', $arg);
			switch ($pieces[0]) {
				case "auth":		$this->m_strAuthentication = $pieces[1];
									break;
				case "world":		$this->m_worldSubDirectory = $pieces[1];
									$this->m_bplDirectory = $worldsDirectory . $this->m_worldSubDirectory;
									break;
				case "level":		$this->m_treeLevel = $pieces[1];
									break;
				case "days":		$this->m_nDays = (int)$pieces[1];
									break;
				case "start":		$this->m_startTime = (int)$pieces[1];
									break;
				case "end":			$this->m_endTime = (int)$pieces[1];
									break;
				case "networkID":
				case "networkid":	$this->m_networkID = $pieces[1];
									break;
									
				case "types":		$this->setTypes($pieces[1]);
									break;
			}
		}
	}
	
	function getDirectory() {
		return $this->m_bplDirectory;
	}
	
	function getWorldSubDirectory() {
		return $this->m_worldSubDirectory;
	}
	
	function setWorldSubDirectory($directory) {
		$this->m_worldSubDirectory = $directory;
	}
	
	function setNetworkID($id) {
		$this->m_networkID = $id;
	}
	
	function getNetworkID() {
		return $this->m_networkID;
	}
	
	function setLevel($level) {
		$this->m_treeLevel = $level;
	}
	
	function getLevel() {
		return $this->m_treeLevel;
	}
	
	function getDays() {
		return $this->m_nDays;
	}
	
	function setDays($days) {
		$this->m_nDays = $days;
	}
	
	function getStartTime() {
		return $this->m_startTime;
	}
	
	function setStartTime($startTime) {
		$this->m_startTime = $startTime;
	}
	
	function getEndTime() {
		return $this->m_endTime;
	}
	
	function setEndTime($endTime) {
		$this->m_endTime = $endTime;
	}
	
	function getAuthenticationString() {
		return $this->m_strAuthentication;
	}
	
	function setAuthenticationString($strAuth) {
		$this->m_strAuthentication = $strAuth;
	}
	
	function setTypes($strTypeList)	{
		$stringSeparator = "zxywz";
		$typeList = explode($stringSeparator, $strTypeList);
		$this->m_aTypes = $typeList;
	}
	
	function getTypes() {
		return $this->m_aTypes;
	}
	
	function setStatusType($strType) {
		$this->m_StatusType = $strType;
	}
	
	function getStatusType() {
		return $this->m_StatusType;
	}
	
	function setView($grandClientView, $src_id, $user) {
		$this->_grandClientView = $grandClientView;
		$this->_sourceID = $src_id;
		$this->_user = $user;
	}
	
	function getSourceID() {
		return $this->_sourceID;
	}
	
	function grandClientView() {
		return $this->_grandClientView;
	}
	
	function getUser() {
		return $this->_user;
	}
}

?>